	SUBROUTINE SAOERAS
C
C  Note:  This is the UNIX version.
C
C       This subroutine erases the SAOimage buffer.  IFB_SAO is obtained 
C  from the COMMON block, SAOFACTS.
C			Donald H. Gudehus, August, 1993
C			Version 1U, D. Gudehus, September, 1994
C			Modified it to run under UNIX
C                       Version 2, D. Gudehus, October 1, 1994
C                       Extended code to IFB_SAO>13
C			Version 3, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
	INCLUDE 'saofacts.for'
C
	IF (IFB_SAO.EQ.1) THEN
	  IBUFFER_SAO(1)='21000'O !  = 8704;  imhead.tid 512X512
	ELSE IF (IFB_SAO.EQ.2) THEN
	  IBUFFER_SAO(1)='21001'O !  = 8705;  imhead.tid 800x800
	ELSE IF (IFB_SAO.EQ.3) THEN
	  IBUFFER_SAO(1)='21002'O !  = 8706;  imhead.tid 1024x1024
	ELSE IF (IFB_SAO.EQ.4) THEN
	  IBUFFER_SAO(1)='21003'O !  = 8707;  imhead.tid 1600x1600
	ELSE IF (IFB_SAO.EQ.5) THEN
	  IBUFFER_SAO(1)='21004'O !  = 8708;  imhead.tid 2048x2048
	ELSE IF (IFB_SAO.EQ.6) THEN
	  IBUFFER_SAO(1)='21005'O !  = 8709;  imhead.tid 4096x4096
	ELSE IF (IFB_SAO.EQ.7) THEN
	  IBUFFER_SAO(1)='21006'O !  = 8710;  imhead.tid 4096x1024
	ELSE IF (IFB_SAO.EQ.8) THEN
	  IBUFFER_SAO(1)='21007'O !  = 8711;  imhead.tid 1024x4096
	ELSE IF (IFB_SAO.EQ.9) THEN
	  IBUFFER_SAO(1)='21010'O !  = 8712;  imhead.tid 1144x880
	ELSE IF (IFB_SAO.EQ.10) THEN
	  IBUFFER_SAO(1)='21011'O !  = 8713;  imhead.tid 1144x764
	ELSE IF (IFB_SAO.EQ.11) THEN
	  IBUFFER_SAO(1)='21012'O !  = 8714;  imhead.tid 128x128
	ELSE IF (IFB_SAO.EQ.12) THEN
	  IBUFFER_SAO(1)='21013'O !  = 8715;  imhead.tid 256x256
	ELSE IF (IFB_SAO.EQ.13) THEN
	  IBUFFER_SAO(1)='21014'O !  = 8716;  imhead.tid 90x90
        ELSE IF (IFB_SAO.GE.14) THEN
          IBUFFER_SAO(1)=8703+IFB_SAO
	END IF
	IBUFFER_SAO(2)=-1 !  imhead.thingct = 1 word
	IBUFFER_SAO(3)=5 !  imhead.subunit = FEEDBACK (for erasing screen)
	IBUFFER_SAO(4)=0 !  imhead.checksum
	IBUFFER_SAO(5)=IOR(0,'100000'O) !  imhead.x
	IBUFFER_SAO(6)=IOR(0,'100000'O) !  imhead.y
	IBUFFER_SAO(7)=1 !  imhead.z
	IBUFFER_SAO(8)=IOR(63,'300'O) !  imhead.t
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	IBUFFER_SAO(1)=IOR(0,'100000'O)
	NBYTES=2
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C  Erase any cursors and regions left on the screen
	CALL SAO_ERASE_CURSOR(1)
C
	RETURN
	END

	SUBROUTINE DYNAMIC(ADDRESS,NWORDS,DATAFORMAT,ALLOCATE)
C
C  Note:  This is the UNIX version.
C
C       This subroutine performs a dynamic allocation of memory
C  via the malloc C function.
C				Donald H. Gudehus, September 19 1994
C
C	ADDRESS		(R)	The address at which memory is available
C	NWORDS		(C)	The number of words requested
C	DATAFORMAT	(C)	The data format.  This can be I2, I4,
C				R4, or R8.  It is right justified.
C	ALLOCATE	(C)	This is .TRUE. is memory is desired.
C				.FALSE. if memory is being given up.
C
	INTEGER ADDRESS
	CHARACTER*(*) DATAFORMAT
	LOGICAL ALLOCATE  ! If .TRUE. allocate, else deallocate
C
	DECODE (1,1000,DATAFORMAT(4:4)) NBYTES_PER_WORD
1000	FORMAT(I1)
	NBYTES=NBYTES_PER_WORD*NWORDS
	IF (ALLOCATE) THEN
	  CALL DYNAMIC_C(ADDRESS,NBYTES)
	  IF (ADDRESS.EQ.0) THEN
C	    CALL PRTMSG(ISTAT,'F'X)
	    CALL ERROR(-3,'DYNAMIC_C failed in DYNAMIC')
	  END IF
	ELSE
	  CALL RELEASE_MEMORY_C(ADDRESS)
	END IF
C
	RETURN
	END

	PROGRAM SAODEMO5
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we send randomly oriented colored vectors
C  of various lengths.  The user is given a choice on whether to display
C  the vectors immediately as they are drawn (slow) or at the end (faster).
C
C			Donald H. Gudehus, September, 1994
C			Version 1U, D. Gudehus, September, 1994
C			Modified code to run under UNIX
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
	INCLUDE 'saofacts.for'
	CHARACTER*1 CHOICE
	INTEGER*4 ACTION,COLOR_TYPE
C
	CALL GET_ENDIAN
	IFB_SAO=0 !  Lets the user be prompted for the size of the buffer
C  Establish the buffer size
	CALL SAOSTART
C  Initialize SAOimage
	CALL SAOFIRST
C
C  Get some parameters set up.  
	NCOLS=MAXFB_COLS_SAO
	NROWS=MAXFB_ROWS_SAO
	NPIC_SAO=1 !  Pictures run from 1 to 16
	NFRAME_SAO=0 !  Frames run from 0 to 3.  Only one frame is supported
		     !  on SAOimage
C  Establish the starting location on the frame
	XLOC_SAO(NPIC_SAO)=0
	YLOC_SAO(NPIC_SAO)=MAXFB_ROWS_SAO-1
C  Establish the starting location in the array
	IMSX_SAO(NFRAME_SAO,NPIC_SAO)=1
	IMSY_SAO(NFRAME_SAO,NPIC_SAO)=1
C
C  Write random colored vectors onto the display
C  Send a caption now that we have set up the parameters
	TV_FILENAME(NPIC_SAO)='Colored vectors'
	CALL SAOCAPTION
C
	CHOICE=' '
	DO WHILE (CHOICE.NE.'A'.AND.CHOICE.NE.'B')
	  CHOICE='B'
	  CALL MESSAGE('Enter a choice:')
	  CALL MESSAGE(
	1 '      A = Vectors are displayed as they are drawn(slow)')
	  CALL MESSAGE(
	1 '      B = Vectors are displayed at end (faster, default)')
	  CALL USRINP_CHAR(1,'A',1,1,'CHOICE=',' ',%REF(CHOICE))
	END DO
	IF (CHOICE.EQ.'A') THEN
	  ACTION=3
	ELSE IF (CHOICE.EQ.'B') THEN
	  ACTION=4
	END IF
	ISEED=12345
	DO K=1,40
	  COLOR_TYPE=MOD(K,5)+203
	  X1=RAN(ISEED)*(NCOLS-1)+1
	  Y1=RAN(ISEED)*(NROWS-1)+1
	  X2=RAN(ISEED)*(NCOLS-1)+1
	  Y2=RAN(ISEED)*(NROWS-1)+1
	  CALL SAO_VECT(ACTION,COLOR_TYPE,X1,Y1,X2,Y2,NPIC_SAO) !  Map coordinates
	END DO
	IF (CHOICE.EQ.'B') CALL SAO_DISPLAY_VECT
	END

	SUBROUTINE SAO_LOAD_VLT(BLUE,GREEN,RED)
C
C  Note:  This is the UNIX version.
C
C       This subroutine loads a custom video look-up table into SAOimage.  It
C  is up to the calling routine to have loaded each array with an 8-bit
C  value.  The SAOimage built-in look-up tables, on the other hand, are 
C  selected by calling SAOCONVLT.
C
C			Donald H. Gudehus, October, 17, 1994
C			Version 1U, D. Gudehus, October 27, 1994
C			Converted code to UNIX
C			Version 2, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
	INTEGER BLUE(0:199),GREEN(0:199),RED(0:199)
C
	INCLUDE 'saofacts.for'
C
	IVERTEX_COUNT=200
	JMAX=IVERTEX_COUNT-1
	ICOUNT=3*(25+12*JMAX)
	I2VAL='FFFF'X  ! Flag to SAOimage that the internal LUTs will not 
		       ! be used.  The LUT information will follow in the
		       ! next packet.
	IBUFFER_SAO(1)='40000'O  ! = PACKED;  since is not IIS_READ, is write
C	IBUFFER_SAO(1)=256  ! imhead.tid,  no name
	IBUFFER_SAO(2)=-ICOUNT  ! imhead.thingct
	IBUFFER_SAO(3)=2  ! imhead.subunit = LUT
	IBUFFER_SAO(4)=0  ! imhead.checksum;  initially set to zero
	IBUFFER_SAO(5)=0  ! imhead.x
	IBUFFER_SAO(6)=0  ! imhead.y
	IBUFFER_SAO(7)=I2VAL  ! imhead.z
	IBUFFER_SAO(8)=0  ! imhead.t
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	IFLAG_GAMMA=0
	GAMMA=1.0
	DO K=1,3
	  KD=(K-1)*(25+12*JMAX)
	  CBUFFER_SAO(1+KD:1+KD)=' '
	  ENCODE (3,2003,CBUFFER_SAO(2+KD:4+KD)) IVERTEX_COUNT
2003	  FORMAT(I3)
	  CBUFFER_SAO(5+KD:5+KD)=' '
	  ENCODE (1,2001,CBUFFER_SAO(6+KD:6+KD)) IFLAG_GAMMA
2001	  FORMAT(I1)
	  CBUFFER_SAO(7+KD:7+KD)=' '
	  ENCODE (6,1006,CBUFFER_SAO(8+KD:13+KD)) GAMMA
1006	  FORMAT(F6.4)
	  DO J=0,JMAX
	    JD=12*J
	    CBUFFER_SAO(14+JD+KD:14+JD+KD)=' '
	    ENCODE (5,1005,CBUFFER_SAO(15+JD+KD:19+JD+KD)) 1.0*J/JMAX
1005	    FORMAT(F5.3)
	    CBUFFER_SAO(20+JD+KD:20+JD+KD)=' '
	    IF (K.EQ.1) THEN
	      ENCODE (5,1005,CBUFFER_SAO(21+JD+KD:25+JD+KD)) RED(J)/255.0
	    ELSE IF (K.EQ.2) THEN
	      ENCODE (5,1005,CBUFFER_SAO(21+JD+KD:25+JD+KD)) GREEN(J)/255.0
	    ELSE IF (K.EQ.3) THEN
	      ENCODE (5,1005,CBUFFER_SAO(21+JD+KD:25+JD+KD)) BLUE(J)/255.0
	    END IF
	  END DO
	END DO
	NBYTES=ICOUNT
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	RETURN
	END

	SUBROUTINE SAO_CURN(NPICN,IXT,IYT,XF,YF,XM,YM,KEY,MESSAGE)
C
C  Note:  This is the UNIX version
C
C       This subroutine reads the position of the cursor on SAOimage.
C  Since only one cursor is used in SAOimage, this subroutine differs
C  somewhat from CURN.FOR and TR_CURN.FOR.
C				Donald H. Gudehus, August, 1993
C				Version 1U, D. Gudehus, September 21, 1994
C				Changed code to work under UNIX
C				Version 2, D. Gudehus, July 25, 2006
C				Incorporated new saofacts.for
C
C	NPICN	(R)	The number of the picture;  useful when several
C			pictures have been loaded at the same time
C	IXT	(R)	The X coordinate of the cursor on the TV screen;
C			it has values between 0 and the maximum allowed by
C			the chosen frame buffer.  Zero is at the left.
C	IYT	(R)	The Y coordinate of the cursor on the TV screen;
C			it has values between 0 and the maximum allowed by
C			the chosen frame buffer.  Zero is at the top.
C	XF	(R)	The X coordinate of the cursor on the frame;  it
C			is independent of zooming and panning.  Fractional
C			values are possible, with the left edge being
C			0.000.
C	YF	(R)	Like XF but in the Y direction;  the top edge is 0.000.
C	XM	(R)	The X coordinate in the map;  it has values
C			beginning at 1.0 and is independent of zooming
C			and panning.
C	YM	(R)	Like XM but in the Y direction.
C	KEY	(R)	The ASCII code of the key that was pressed.
C	MESSAGE	(C)	A logical variable such that when .TRUE., a message
C			will be displayed when the cursor is not in the map.
C
	INTEGER*2 IXT,IYT
	LOGICAL MESSAGE
C
	INCLUDE 'saofacts.for'
C
	INTEGER OF  ! Offset
C
C  Send a command to read the cursor
	IBUFFER_SAO(1)=256 !  imhead.tid,  no name
	IBUFFER_SAO(2)=-3 !  imhead.thingct = 3 words
	IBUFFER_SAO(3)=12 !  imhead.subunit = LOOK_FEEL
        IBUFFER_SAO(4)=0 !  imhead.checksum;  initially set to zero
        IBUFFER_SAO(5)=IOR(0,'100000'O) !  imhead.x
	IBUFFER_SAO(6)=0 !  imhead.y
	IBUFFER_SAO(7)=0 !  imhead.z
	IBUFFER_SAO(8)=3
		!  imhead.t = IOP_MIIPS;  used for control.look_and_feel
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	IBUFFER_SAO(1)=0
	IBUFFER_SAO(2)=0
	IBUFFER_SAO(3)=0
	NBYTES=6
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	IBUFFER_SAO(1)='100000'O
		!  '100000'O = -32768 = IIS_READ= Reads the cursor
		!   upon trigger (pressing a key)
	IBUFFER_SAO(2)=-160 !  imhead.thingct
	IBUFFER_SAO(3)=IOR('20'O,'100000'O) !  = -32752 imhead.subunit
					    !  IMCURSOR='20'O
        IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0  ! x
        IBUFFER_SAO(6)=0  ! y
        IBUFFER_SAO(7)=1  ! Frame number
        IBUFFER_SAO(8)=0
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	NBYTES=160
  	CALL SI_READ(BUFFER_SAO,NBYTES)
C  The map coordinates returned from SAOimage are correct if only one map was
C  loaded into the frame, or in the case of several loaded maps, if the map
C  chosen with the cursor was the last map loaded.  We therefore need 
C  additional calculation.
	DECODE(10,1010,CBUFFER_SAO(1:10)) XM !  in map
1010	FORMAT(F10.3)
	DECODE(10,1010,CBUFFER_SAO(12:21)) YM
C  Get the ASCII code of the key that was pressed
	IF (BUFFER_SAO(27).GT.32.AND.BUFFER_SAO(28).EQ.32) THEN
			!  Printable character
	  KEY=BUFFER_SAO(27)
	  OF=0
	ELSE IF (BUFFER_SAO(27).EQ.92.AND.BUFFER_SAO(28).NE.32) THEN
			!  Non-printable
C  ASCII 92 = \;  positions 28-30 are ASCII code of octal characters
	  KEY=BUFFER_SAO(30)-48+8*(BUFFER_SAO(29)-48)
	  OF=3
	ELSE
	  CALL ERROR(-1,'Bad ASCII code in SAO_CURN')
	END IF
        DECODE(10,1010,CBUFFER_SAO(29+OF:38+OF)) XT
			!  in desktop window (on TV)
        DECODE(10,1010,CBUFFER_SAO(40+OF:49+OF)) YT
        IXT=XT
        IYT=YT
        DECODE(10,1010,CBUFFER_SAO(51+OF:60+OF)) XF !  in frame
        DECODE(10,1010,CBUFFER_SAO(62+OF:71+OF)) YF
C
C  Find what image the cursor is in
C
	NPICN=0
C  X on the frame increases to the right;  Y on the frame increases downwards
	DO I=1,NPIC_SAO
	  XEND=XLOC_SAO(I)+NPTSX_SAO(I)-1 !  XLOC_SAO is measured on the frame
	  YEND=YLOC_SAO(I)-NPTSY_SAO(I)+1
	  IF (INT(XF).GE.XLOC_SAO(I).AND.INT(YF).LE.YLOC_SAO(I)
	1 .AND.INT(XF).LE.XEND.AND.INT(YF).GE.YEND) THEN
	    NPICN=I
	  END IF
	END DO
	IF (NPICN.EQ.0.AND.MESSAGE) THEN
	  WRITE(6,7500)
	  WRITE(7,7500)
7500	  FORMAT(1X,'Cursor not in a map')
	END IF
C
C  Cursor's position in map
C
	IF (NPICN.NE.0) THEN
	  XM=XF-XLOC_SAO(NPICN)+IMSX_SAO(NFRAME_SAO,NPICN)
	  YM=YLOC_SAO(NPICN)-YF+1.0+IMSY_SAO(NFRAME_SAO,NPICN)
	END IF
 999	RETURN
	END

      SUBROUTINE IBMI4(INPUT,OUTPUT,N)
C
C *** ROUTINE CONVERTS INTEGER*4 FROM IBM TO VAX FORMAT
C *** IRT : JUNE 12,1979
C
      INTEGER*4 INPUT(N),OUTPUT(N),WORD
      LOGICAL*1 BYTE(4),TEMP
      EQUIVALENCE (BYTE,WORD)
C
      DO 10 I=1,N
      WORD=INPUT(I)
C *** INTERCHANGE OUTER PAIR OF BYTES
      TEMP=BYTE(1)
      BYTE(1)=BYTE(4)
      BYTE(4)=TEMP
C *** INTERCHANGE INNER PAIR OF BYTES
      TEMP=BYTE(3)
      BYTE(3)=BYTE(2)
      BYTE(2)=TEMP
C *** SET OUTPUT VALUE
      OUTPUT(I)=WORD
10    CONTINUE
      RETURN
      END

	SUBROUTINE SAOLOAD(ARRAY,NCOLS,NROWS,IXFRAME,IYFRAME,
	1BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
C
C  Note:  This is the UNIX version.
C
C       This subroutine sends data from an array to SAOimage.
C
C			Donald H. Gudehus, July, 1994
C			Version 1U, D. Gudehus, September 15, 1994
C			Changed code to work under UNIX
C                       Version 2, D. Gudehus, September 18, 1994
C                       Corrected setting of NPIC from NPICTURE
C			Version 3, D. Gudehus, October 29, 1994
C			Corrected index for colors
C			Version 4, D. Gudehus, June 9, 1995
C			Allowed for ARRAY_NAME to have spaces
C			Version 5, D. Gudehus, March 21, 2005
C			Adjusted BUFFER_TEMP for different endian
C			architectures.  This array is available through
C			the include file SAOFACT.FOR.
C			Version 6, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C			Version 7, D. Gudehus, Aug. 24, 2006
C			Added SYS_ENDIAN common block
C			Version 8, D. Gudehus, Sept. 2, 2006
C			Adjusted AMIN_SAO, AMAX_SAO, and IBUFFER_TEMP_SAO
C			for better display of intensity
C
C	ARRAY		(C)	The array containing the data to be loaded
C				into SAOimage
C	NCOLS		(C)	The number of columns in the image to be 
C				loaded, and the first dimension of ARRAY.
C	NROWS		(C)	The number of rows in the image to be 
C				loaded, and the second dimension of ARRAY.
C	IXFRAME		(C)	The X location on the frame of the lower left
C				corner of the array.  The frame's X coordinate
C				system begins at 0 at the left.
C	IYFRAME		(C)	The Y location on the frame of the lower left
C				corner of the array.  The frame's Y coordinate
C				system begins at 0 at the top.
C	BRIGHTNESS_MIN	(C)	The minimum intensity level in the image
C				which is desired to be represented in 
C				pseudocolor.  Values less than or equal to
C				this will all be assigned the same color.
C	BRIGHTNESS_MAX	(C)	The maximum intensity level in the image
C				which is desired to be represented in 
C				pseudocolor.  Values greater than or equal to
C				this will all be assigned the same color.
C	ARRAY_NAME	(C)	The name of the array or picture.  This will
C				be displayed on SAOimage.
C	NPICTURE	(C)	The number of the picture.  Since SAOimage
C				supports loading up to 16 independent pictures
C				the number must be specified.
C	MODE		(C)	The mode for loading an image.  If MODE=0
C				the entire frame buffer is used, and several
C				lines are loaded at a time.  If MODE=1
C				only one line at a time is loaded.  Although
C				this is slower, the line length can be less
C				the buffer width, and a picture can be
C				placed next to an existing picture without
C				that picture being erased.
C
	CHARACTER*(*) ARRAY_NAME
	REAL ARRAY(NCOLS,NROWS)
C
	INCLUDE 'saofacts.for' !  UNIX likes lower case
C
	CHARACTER*1 SYSTEM_ENDIAN
	COMMON /SYS_ENDIAN/ SYSTEM_ENDIAN
C
	INTEGER*2 I2,J2
C
	NFRAME_SAO=0 !  For now, there is only one frame
	NPIC_SAO=NPICTURE
	NPTSX_SAO(NPIC_SAO)=NCOLS
	NPTSY_SAO(NPIC_SAO)=NROWS
	IMIN=1 !  Starting location in array
	JMIN=1
	IMAX=NCOLS
	JMAX=NROWS
	TV_FILENAME(NPIC_SAO)=ARRAY_NAME
	INPIC_SAO=NPIC_SAO
C  Make sure XLOC_SAO and YLOC_SAO are within the frame
	XLOC_SAO(NPIC_SAO)=MIN(MAXFB_COLS_SAO-1,MAX(0,IXFRAME))
	YLOC_SAO(NPIC_SAO)=MIN(MAXFB_ROWS_SAO-1,MAX(0,IYFRAME))
C  Make sure enough room is available in the frame and if not, try to correct
C  XLOC_SAO by shifting left and lining up the right sides
	XLOC_SAO(NPIC_SAO)=MIN(MAXFB_COLS_SAO-NCOLS,XLOC_SAO(NPIC_SAO))
C  Make sure enough room is available in the frame and if not, try to correct
C  YLOC_SAO by shifting down and lining up the top sides
	YLOC_SAO(NPIC_SAO)=MAX(NROWS-1,YLOC_SAO(NPIC_SAO))
	IF (XLOC_SAO(NPIC_SAO).NE.IXFRAME.OR.YLOC_SAO(NPIC_SAO).NE.IYFRAME) 
	1CALL MESSAGE('Starting location in frame was changed')
C  Check that the possibly corrected XLOC_SAO is not off the left edge or that
C  the possibly corrected YLOC_SAO is not off the bottom edge of the 
C  frame
	IF (XLOC_SAO(NPIC_SAO).LT.0.OR.YLOC_SAO(NPIC_SAO).GT.
	1MAXFB_ROWS_SAO-1)
	1 CALL ERROR(-2,'Buffer not wide enough for image;  try again')
	IXLOC=XLOC_SAO(NPIC_SAO) !  Converts to I4
        IYLOC=YLOC_SAO(NPIC_SAO) !  Converts to I4
C  Compute the frame dependent intensity scale factor.  200 distinct values
C  can be displayed from the color lookup table;  2 values at the ends
C  of the range will display < and > before the values.
C  Testing of this algorithm can be done by loading tst0001.fits which 
C  contains integer values from 0 to 255.  Choose BRIGHTNESS_MIN=0 and
C  BRIGHTNESS_MAX=199 for display of the integer values.
	SCF_SAO(NFRAME_SAO)=(BRIGHTNESS_MAX-BRIGHTNESS_MIN)/199.0
C  Compute the values to set up SAOimage to define the clipping limits.
	AMIN_SAO(NFRAME_SAO)=BRIGHTNESS_MIN+SCF_SAO(NFRAME_SAO)
	AMAX_SAO(NFRAME_SAO)=BRIGHTNESS_MAX+SCF_SAO(NFRAME_SAO)
C
C  Prepare to load the array into frame NFRAME_SAO
C
C  Set up the new WCS header information
	I=LEN(ARRAY_NAME)
	DO WHILE(ARRAY_NAME(I:I).NE.' '.AND.I.GE.1)
	  I=I-1
	END DO
	LF=MAX(I,1) !  Length of file name
	IBUFFER_SAO(1)='40000'O !  PACKED and IMC_SAMPLE
	IBUFFER_SAO(2)=-(LF+59)
	IBUFFER_SAO(3)=17 !  imhead.subunit = WCS (World coordinate system)
        IBUFFER_SAO(4)=0
        IBUFFER_SAO(5)=0
        IBUFFER_SAO(6)=0
        IBUFFER_SAO(7)=1 !  Frame number
        IBUFFER_SAO(8)=IFB_SAO-1 !  Frame buffer configuration - 1
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
C  Send the WCS header
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C  Set up the WCS data packet
	CBUFFER_SAO(1:LF)=ARRAY_NAME(1:LF)
	BUFFER_SAO(LF+1)=10
	CBUFFER_SAO(LF+2:LF+14)='1. 0. 0. -1. ' !  xx yx xy yy
	ENCODE (7,1000,CBUFFER_SAO(LF+15:LF+21)) IMIN+0.5-IXLOC !  xo =
	!  X Coordinate at left edge of buffer;  0.5 added to conform with 
	!  corner of pixel being x.0, y.0.
1000	FORMAT(F7.1)
	CBUFFER_SAO(LF+22:LF+22)=' '
	ENCODE (7,1000,CBUFFER_SAO(LF+23:LF+29)) IYLOC+JMIN+0.5 !  yo =
	!  Y Coordinate at top edge of buffer;  0.5 added to conform with 
	!  corner of pixel being x.0, y.0.
	CBUFFER_SAO(LF+30:LF+30)=' '
	ENCODE (12,2000,CBUFFER_SAO(LF+31:LF+42)) AMIN_SAO(NFRAME_SAO) !  low
2000	FORMAT(E12.5)
	CBUFFER_SAO(LF+43:LF+43)=' '
	ENCODE (12,2000,CBUFFER_SAO(LF+44:LF+55)) AMAX_SAO(NFRAME_SAO) !  high
	CBUFFER_SAO(LF+56:LF+57)=' 1' !  w_type (=linear)
	BUFFER_SAO(LF+58)=10
	BUFFER_SAO(LF+59)=0
	NBYTES=LF+59
C  Send the WCS data packet
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C  In IRAF at this point, the LUT header is sent.  Don't need it in MIIPS.
	IF (MODE.EQ.0) THEN !  A single map is loaded, many rows at a time
			    !  for highest speed
	  DO I=1,MAXNBYTES_SAO
	    BUFFER_SAO(I)=0.0
	  END DO
	  IOFF=IMIN-1
	  JOFF=JMIN+IYLOC
C  Get the initial row in the map to be read
	  JNEXT=JMIN
C  Find out how many rows can be sent at a time.
	  NROWS_AT_A_TIME=MAXNBYTES_SAO/MAXFB_COLS_SAO
C  Start loading several rows at a time into the buffer.  The full width
C  of the display buffer is used.
	  NROWS_REMAINING=NROWS
	  DO WHILE(NROWS_REMAINING.GT.0)
C  Make sure this is not more than the remaining number of rows to be displayed
	    NROWS_AT_A_TIME=MIN(NROWS_REMAINING,NROWS_AT_A_TIME)
	    NBYTES=MAXFB_COLS_SAO*NROWS_AT_A_TIME
	    IHDBUFFER_SAO(1)='71000'O !  = 29184
	    IHDBUFFER_SAO(2)=-NBYTES !  imhead.thingct
	    IHDBUFFER_SAO(3)=1 !  imhead.subunit = MEMORY
	    IHDBUFFER_SAO(4)=0
	    I2=0 !  We always load from the beginning of the buffer
            IHDBUFFER_SAO(5)=IOR(I2,'100000'O) !  x
	    JNEXT_PLUS_DEL=JNEXT+NROWS_AT_A_TIME-1
	    J2=JOFF-JNEXT_PLUS_DEL
	    IHDBUFFER_SAO(6)=IOR(J2,'100000'O) !  y
	    IHDBUFFER_SAO(7)=1
	    IHDBUFFER_SAO(8)=IOR(63,'300'O)
	    CALL IMTOOLCHECKSUM(IHDBUFFER_SAO)
	    NBYTES_HEADER=16
	    CALL SI_WRITE(HDBUFFER_SAO,NBYTES_HEADER)
	    DO J=JNEXT,JNEXT_PLUS_DEL
C  Start the loop to increment the column number in the array
	      DO I=IMIN,IMAX
		IBUFFER_TEMP_SAO=
	1       NINT((ARRAY(I,J)-BRIGHTNESS_MIN)/SCF_SAO(NFRAME_SAO))
C  Don't let any address be too small
	        IF (IBUFFER_TEMP_SAO.LT.0) IBUFFER_TEMP_SAO=0
C  Address 200 is reserved for values >= the upper limit.  Don't let any
C  addresses be larger than this.
	        IF (IBUFFER_TEMP_SAO.GT.200) IBUFFER_TEMP_SAO=200
	        IF (SYSTEM_ENDIAN.EQ.'L') THEN
	          BUFFER_SAO(I-IMIN+IXLOC+1+(JNEXT_PLUS_DEL-J)*
	1       MAXFB_COLS_SAO)=BUFFER_TEMP_SAO(1)
	        ELSE !  Big endian
	          BUFFER_SAO(I-IMIN+IXLOC+1+(JNEXT_PLUS_DEL-J)*
	1         MAXFB_COLS_SAO)=BUFFER_TEMP_SAO(2)
	        END IF
	      END DO
	    END DO
C  Send the rows of data to SAOimage
	    CALL SI_WRITE(BUFFER_SAO,NBYTES)
C  Get the next row in the map to be read
	    JNEXT=JNEXT+NROWS_AT_A_TIME
	    NROWS_REMAINING=NROWS_REMAINING-NROWS_AT_A_TIME
	  END DO
	ELSE IF (MODE.EQ.1) THEN !  One row at a time.  Slower, but allows
C				 !  multiple images to be loaded
C  Start the loop to increment the row number in the array
	  IOFF=IMIN-1
	  JOFF=JMIN+IYLOC
C  We use the auxilliary buffer so that it doesn't have to be reloaded every
C  row.
	  IHDBUFFER_SAO(1)='71000'O !  = 29184
	  IHDBUFFER_SAO(2)=-NCOLS !  imhead.thingct
	  IHDBUFFER_SAO(3)=1 !  imhead.subunit = MEMORY
	  IHDBUFFER_SAO(4)=0
	  I2=IXLOC
          IHDBUFFER_SAO(5)=IOR(I2,'100000'O) !  x
	  IHDBUFFER_SAO(7)=1
	  IHDBUFFER_SAO(8)=IOR(63,'300'O)
	  DO J=JMIN,JMAX
	    J2=JOFF-J
	    IHDBUFFER_SAO(6)=IOR(J2,'100000'O) !  y
	    CALL IMTOOLCHECKSUM(IHDBUFFER_SAO)
	    NBYTES=16
	    CALL SI_WRITE(HDBUFFER_SAO,NBYTES)
	    NBYTES=MIN(MAXFB_COLS_SAO-I2,NCOLS)
C  Start the loop to increment the column number in the array
	    DO I=IMIN,IMAX
	      IBUFFER_TEMP_SAO=
	1     (ARRAY(I,J)-BRIGHTNESS_MIN)/SCF_SAO(NFRAME_SAO)
	      IF (IBUFFER_TEMP_SAO.LT.0) IBUFFER_TEMP_SAO=0
	      IF (IBUFFER_TEMP_SAO.GT.200) IBUFFER_TEMP_SAO=200
C  Take note of which endian this system is
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        BUFFER_SAO(I-IOFF)=BUFFER_TEMP_SAO(1)
	      ELSE !  Big endian
	        BUFFER_SAO(I-IOFF)=BUFFER_TEMP_SAO(2)
	      END IF
	    END DO
C  Send the row of data to SAOimage
	    CALL SI_WRITE(BUFFER_SAO,NBYTES)
	  END DO
	END IF
C  Exit
	RETURN
	END

	SUBROUTINE IMTOOLCHECKSUM(IBUFFER)
C
C       This function calculates the checksum for an IMTOOL header packet.
C  An IMTOOL header has 16 bytes, or 8 INTEGER*2 words.  The fourth word
C  is the checksum.  This function is used to send IMTOOL-like packets to
C  SAOimage.
C				Donald H. Gudehus, August, 1993
C			Version 2UM, D. Gudehus, March 17, 2005
C			Modified CHECKSUM for Mac OS
C
C	IBUFFER		(C/R)	The IMTOOL header array of 8 INTEGER*2 
C				words.  In the call, all words except 
C				the fourth, are ready for use.  Upon 
C				return, the fourth word equals the 
C				checksum.
C				
	INTEGER SUM
	INTEGER*2 IBUFFER(8),CHECKSUM(2)
	EQUIVALENCE (CHECKSUM(1),ISUM)
C
	SUM=0
C  Set IBUFFER(4) to zero in order to compute the initial sum
	IBUFFER(4)=0
	DO I=1,8
	  SUM=SUM+IBUFFER(I)
	END DO
C	PRINT *, IAND('177777'O-IAND(SUM,'177777'O),'177777'O)
	ISUM=IAND('177777'O-IAND(SUM,'177777'O),'177777'O)
	IBUFFER(4)=CHECKSUM(2)
C  Check that all is well
	SUM=0
	DO I=1,8
	  SUM=SUM+IBUFFER(I)
	END DO
	SUM=IAND(SUM,'177777'O)
	IF (SUM.NE.'177777'O) 
	1 CALL ERROR(-1,'Failure of checksum in IMTOOLCHECKSUM')
	END

	PROGRAM SAODEMO6
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we request the user to position the mouse
C  pointer at various places within the frame buffer and press the 
C  carriage return in order to draw a polygon.
C
C			Donald H. Gudehus, September, 1994
C			Version 1U, D. Gudehus, September, 1994
C			Changed code to work under UNIX
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
	INCLUDE 'saofacts.for'
C
	INTEGER*4 ACTION,COLOR_TYPE
	LOGICAL MESSAG,FIRST_VERTEX
C
	CALL GET_ENDIAN
C  Don't prompt the user for the size of the buffer, just use a big
C  enough one.
	IFB_SAO=1 !  Gives a 512 by 512 buffer
	CALL SAOSTART
	CALL SAOFIRST
	NPIC_SAO=1
C  Establish the starting location on the frame
        XLOC_SAO(NPIC_SAO)=0
        YLOC_SAO(NPIC_SAO)=MAXFB_ROWS_SAO-1
C  Establish the number of pixels in the picture (assumed to be as
C  big as the frame buffer).  This information is needed by SAO_CURN,
C  and would normally be provided by the call to SAOLOAD, but since we
C  are not loading a picture, we must do this manually.
	NPTSX_SAO(NPIC_SAO)=MAXFB_COLS_SAO
	NPTSY_SAO(NPIC_SAO)=MAXFB_ROWS_SAO
C  Establish the starting location in the array.  NFRAME_SAO was set
C  in SAOFIRST.
        IMSX_SAO(NFRAME_SAO,NPIC_SAO)=1
        IMSY_SAO(NFRAME_SAO,NPIC_SAO)=1
C
C  Preset the lookup table to a convenient range of colors
	IVAL='A00'X
	CALL SAOCONVLT(IVAL)
C
C  Read the cursor coordinates
	CALL MESSAGE('Be sure SAOimage has focus, and position the mouse'//
	1' pointer at')
	CALL MESSAGE('successive vertices of a polygon.')
	CALL MESSAGE('Press the Carriage Return at each vertex, but press'//
	1' q or Q at the last one.')
	ACTION=3 !  Immediate vector draw
	COLOR_TYPE=50
	KEY=0 !  Initializes the returned ASCII code of the key that will
	      !  be pressed
	FIRST_VERTEX=.TRUE.
	MESSAG=.TRUE.
        DO WHILE (KEY.NE.81.AND.KEY.NE.113)
C  We are interested in the map coordinates, XM and YM
	  CALL SAO_CURN(NPICN,IXT,IYT,XF,YF,XM,YM,KEY,MESSAG)
	  IF (FIRST_VERTEX) THEN
	    FIRST_VERTEX=.FALSE.
	    X_FIRST=XM
	    Y_FIRST=YM
	  ELSE
	    CALL SAO_VECT(ACTION,COLOR_TYPE,X_PRIOR,Y_PRIOR,XM,YM,
	1   NPIC_SAO)
	  END IF
	  X_PRIOR=XM
	  Y_PRIOR=YM
	END DO
C  When the user exits, close the polygon.
	CALL SAO_VECT(ACTION,COLOR_TYPE,XM,YM,X_FIRST,Y_FIRST,NPIC_SAO)
C
	END

	SUBROUTINE MESSAGE(MESS)
C
C		Version 2, Donald H. Gudehus, July, 1993
C		Added the LOGICAL DONT_WRITE_FILES to prevent the accumulation
C		of FORxxx.DAT files in non MIIPS application.
C
	LOGICAL DONT_WRITE_FILES
	COMMON /WRITE_FILES/ DONT_WRITE_FILES
C
	CHARACTER*(*) MESS
	WRITE(6,1000) MESS
1000	FORMAT(1H ,A)
	IF (.NOT.DONT_WRITE_FILES) WRITE(7,1000) MESS
	RETURN
	END

	INTEGER FUNCTION NELD(A,N)
C
C  Note:  This is the UNIX version.
C
C        This function counts the number of 8-byte words in the array
C  A of dimension N.  It is used after a call to USRINP.  If a default 
C  is not taken with USRINP, the correct number will be returned;  however,
C  if a default is taken with USRINP, one must precede the call to USRINP
C  with a call to SETEND.  For example,   
C	DO I=1,MAXNUMPARAM
C	  J=SETEND(PARAMETER(I))
C	END DO
C	CALL USRINP(PARAMETER,...)
C	NUM=NELD(PARAMETER,N)
C
	INTEGER ENDLIN
	REAL*8 A(N)
	DATA END /'FF7FFFFF'X/
C
	DO I=1,N
	  IF (ENDLIN(A(I)).EQ.1) GO TO 11
	END DO
   11	NELD=I-1
	RETURN
	END

	SUBROUTINE DCD(SS,L,ARRAY,NIN)
C
C		Version 2, D. Gudehus, April 3, 1999
C		Eliminated 43 GO TO statements, added DCD_INITIALIZE,
C		and changed "0 to '0'O.
C		Version 2UM, D. Gudehus, January 31, 2005
C		Modified variable format statement for Absoft compiler
C		on Mac OS.
C
	DIMENSION SS(L)
	BYTE SS
	CHARACTER*1 FMT(300)
	CHARACTER*40 VFORMAT
	LOGICAL REAL,CHAR,SIGN,EPOW,SEP
	REAL*8 ARRAY(NIN),ENDLN
	EQUIVALENCE(ENDLN,ENDL)
C
 100	FORMAT('A',I1,',')
C 101	FORMAT(I<NPOS>,'X,')
C 102	FORMAT('F',I<NPOS>,'.',I<NPOSD>,',')
 101	FORMAT('(I',I1,' ''X,'')') !  For the Absoft compiler
 102	FORMAT('(''F'',I',I1,',''.'',I',I1,','','')')
	CALL DCD_INITIALIZE(REAL,EPOW,SIGN,CHAR,SEP,IPOINT,IEPOW,ISIGN)
	I=1
	NOUT=0
	FMT(1)='('
	IFMT=2
	N1=1
	J=SETEND(ENDL)  ! Initializes the end-of-array indicator
	DO IARR=1,NIN
	  ARRAY(IARR)=ENDLN
	END DO
C
	DO WHILE(SS(I).NE.'0'O.AND.I.LE.L.AND.NOUT.LT.NIN)
	  IF (SS(I).EQ.' '.OR.SS(I).EQ.',') THEN
	    IF (.NOT.SEP) THEN
	      LF=I-N1
	      IF (CHAR) THEN
	        LF=MIN(((NIN-NOUT)*8),LF)
	        DO WHILE (LF.GT.0)
	          ENCODE(3,100,FMT(IFMT)) MIN(8,LF)
	          LF=LF-8
	          IFMT=IFMT+3
	          NOUT=NOUT+1
	        END DO
	      ELSE
	        IF (IEPOW.EQ.0) IEPOW=I
	        IF (IPOINT.EQ.0) IPOINT=I
	        LD=MAX((IEPOW-IPOINT-1),0)
	        NPOS=IFIX(LOG10(FLOAT(LF)))+1
	        NPOSD=IFIX(LOG10(FLOAT(MAX(LD,1))))+1
	        WRITE(VFORMAT,102) NPOS,NPOSD
	        ENCODE(NPOS+NPOSD+3,VFORMAT,FMT(IFMT)) LF,LD
	        IFMT=IFMT+NPOS+NPOSD+3
	        NOUT=NOUT+1
	      END IF
	      N1=I
	      CALL DCD_INITIALIZE(REAL,EPOW,SIGN,CHAR,SEP,IPOINT,IEPOW,ISIGN)
	    END IF
	    GO TO 12001
	  END IF
C
	  IF (SEP) THEN
	    LF=I-N1
	    IF (LF.GT.0) THEN
	      NPOS=IFIX(LOG10(FLOAT(LF)))+1
	      WRITE(VFORMAT,101) NPOS
	      ENCODE(NPOS+2,VFORMAT,FMT(IFMT)) LF
	      IFMT=IFMT+NPOS+2
	    END IF
	    N1=I
	    IF ((SS(I).GE.'0'.AND.SS(I).LE.'9')
	1   .OR.SS(I).EQ.'+'.OR.SS(I).EQ.'-') THEN
	      REAL=.TRUE.
	    ELSE
	      IF (SS(I).EQ.'.') THEN
	        REAL=.TRUE.
	        IPOINT=I
	      ELSE
	        CHAR=.TRUE.
	      END IF
	    END IF
	    SEP=.FALSE.
	  ELSE
	    IF (.NOT.CHAR) THEN
	      IF (EPOW) THEN
	        IF (.NOT.SIGN) THEN
	          IF (SS(I).EQ.'+'.OR.SS(I).EQ.'-') THEN
	            ISIGN=1
	            SIGN=.TRUE.
	          ELSE
	            IF (SS(I).GE.'0'.AND.SS(I).LE.'9') THEN
	              SIGN=.TRUE.
	            ELSE
	              CHAR=.TRUE.
	            END IF
	          END IF
	        ELSE 
	          IF (SS(I).LT.'0'.OR.SS(I).GT.'9'.OR.((IEPOW+ISIGN+2).LT.I))
	1         CHAR=.TRUE.
	        END IF
	      ELSE
	        IF (SS(I).EQ.'E') THEN
	          EPOW=.TRUE.
	          IEPOW=I
	        ELSE
	          IF (SS(I).EQ.'.') THEN
	            IF (IPOINT.GT.0) THEN
	              CHAR=.TRUE.
	            ELSE
	              IPOINT=I
	            END IF
	          ELSE
	            IF (SS(I).LT.'0'.OR.SS(I).GT.'9') CHAR=.TRUE.
	          END IF
	        END IF
	      END IF
	    END IF
	  END IF
12001	  CONTINUE
	  I=I+1
	END DO
C
	IF (I.GT.N1) THEN
	  IF (.NOT.SEP) THEN
	    LF=I-N1
	    IF (CHAR) THEN
	      LF=MIN(((NIN-NOUT)*8),LF)
	      DO WHILE (LF.GT.0)
	        ENCODE(3,100,FMT(IFMT)) MIN(8,LF)
	        LF=LF-8
	        IFMT=IFMT+3
	        NOUT=NOUT+1
	      END DO
	    ELSE
	      IF (IEPOW.EQ.0) IEPOW=I
	      IF (IPOINT.EQ.0) IPOINT=I
	      LD=MAX((IEPOW-IPOINT-1),0)
	      NPOS=IFIX(LOG10(FLOAT(LF)))+1
	      NPOSD=IFIX(LOG10(FLOAT(MAX(LD,1))))+1
	      WRITE(VFORMAT,102) NPOS,NPOSD
	      ENCODE(NPOS+NPOSD+3,VFORMAT,FMT(IFMT)) LF,LD
	      IFMT=IFMT+NPOS+NPOSD+3
	      NOUT=NOUT+1
	    END IF
	    N1=I
	    CALL DCD_INITIALIZE(REAL,EPOW,SIGN,CHAR,SEP,IPOINT,IEPOW,ISIGN)
	  END IF
	END IF
	FMT(IFMT-1)=')'
	IF (NOUT.GT.0) DECODE(L,FMT,SS) (ARRAY(J),J=1,NOUT)
	RETURN
C
	END
C
C
	SUBROUTINE DCD_INITIALIZE(REAL,EPOW,SIGN,CHAR,SEP,IPOINT,
	1IEPOW,ISIGN)
C
	LOGICAL REAL,CHAR,SIGN,EPOW,SEP
C
	REAL=.FALSE.
	EPOW=.FALSE.
	SIGN=.FALSE.
	CHAR=.FALSE.
	SEP=.TRUE.
	IPOINT=0
	IEPOW=0
	ISIGN=0
C
	RETURN
	END	

C       This file establishes the declarations and COMMON blocks for
C  use with the subroutines which communicate with SAOimage.
C
C			Donald H. Gudehus, July, 1994
C			Version 2, D. Gudehus, March 21, 2005
C			Dimensioned BUFFER_TEMP as 2 to handle systems with
C			big endian architecture
C			Version 3, D. Gudehus, July 24, 2006
C			Subdivided common block into those of different
C			data type, and added SAO suffixes to the variables
C			Version 4, D. Gudehus, February 3, 2008
C			Increased the length of TV_FILENAME
C
C  The following information is returned by SAOSTART:
C	CHANIN_SAO	The channel for input to the current process
C			from SAOimage (for OpenVMS)
C	CHANOUT_SAO	The channel for output from the current process
C			to SAOimage (for OpenVMS)
C	IFB_SAO		The numerical key for the frame buffer.  This
C			is only determined by SAOSTART if its initial
C			value is zero. If the user sets it to a nonzero
C			value, SAOSTART's operation is overridden.
C	MAXFB_COLS_SAO	The maximum number of columns in the selected
C			frame buffer
C	MAXFB_ROWS_SAO	The muaximum number of rows in the selected
C			frame buffer
C  The following information is returned by SAOLOAD or SAODELS (in MIIPS)
C  and is unique for each of up to 16 images:
C	NPIC_SAO	The number of the most recent picture loaded
C	XLOC_SAO	Starting x location of image measured in the frame
C	YLOC_SAO	Starting y location of image measured in the frame
C	NPTSX_SAO	Number of SAOimage pixels in the x direction in the
C			loaded image
C	NPTSY_SAO	Number of SAOimage pixels in the y direction in the
C			loaded image
C	SCF_SAO		Scale factor for grayscale
C	AMIN_SAO	Lowest intensity
C	AMAX_SAO	Highest intensity
C	IMSX_SAO	Starting column in map
C	IMSY_SAO	Starting row in map
C	MHED_SAO(1,N)	Map number
C	MHED_SAO(2,N)	Plane number
C	TV_FILENAME	The name of the file
C
	PARAMETER (MAXNBYTES_SAO=8192,MAXI2WORDS_SAO=4096)
	BYTE BUFFER_SAO(MAXNBYTES_SAO)
	CHARACTER*8192 CBUFFER_SAO
	INTEGER*2 IBUFFER_SAO(MAXI2WORDS_SAO)
	EQUIVALENCE (BUFFER_SAO,CBUFFER_SAO,IBUFFER_SAO)
	INTEGER*2 MAXFB_COLS_SAO,MAXFB_ROWS_SAO,NPIC_SAO
	INTEGER*2 XLOC_SAO(16),YLOC_SAO(16)
	INTEGER*2 NPTSX_SAO(16),NPTSY_SAO(16)
	COMMON /SAOFACTS_INTEGER2/ IBUFFER_SAO,
	1MAXFB_COLS_SAO,MAXFB_ROWS_SAO,
	2NPIC_SAO,XLOC_SAO,YLOC_SAO,NPTSX_SAO,NPTSY_SAO
C
	INTEGER*4 CHAN_IN_SAO,CHAN_OUT_SAO,IFB_SAO,NFRAME_SAO,
	1IMSX_SAO(0:3,16),IMSY_SAO(0:3,16),MHED_SAO(2,16)
	COMMON /SAOFACTS_INTEGER4/ CHAN_IN_SAO,CHAN_OUT_SAO,IFB_SAO,
	1NFRAME_SAO,IMSX_SAO,IMSY_SAO,MHED_SAO
C
	REAL*4 SCF_SAO(0:3),AMIN_SAO(0:3),AMAX_SAO(0:3)
	COMMON /SAOFACTS_REAL4/ SCF_SAO,AMIN_SAO,AMAX_SAO
C
	CHARACTER*80 TV_FILENAME(16)
	COMMON /CH_TVFACTS/ TV_FILENAME
C
	BYTE HDBUFFER_SAO(16),BUFFER_TEMP_SAO(2)
	INTEGER*2 IHDBUFFER_SAO(8),IBUFFER_TEMP_SAO
	EQUIVALENCE (HDBUFFER_SAO,IHDBUFFER_SAO)
	EQUIVALENCE (BUFFER_TEMP_SAO,IBUFFER_TEMP_SAO)
C

	SUBROUTINE ERROR(ICOND,MESS)
C
C  Note:  This is the UNIX version.  Error handling
C  actions not yet incorporated.
C
C       This subroutine handles errors.
C			Version 2, Greg Quinn, 30-NOV-79.
C                       Version 3, Bruce Cogan, Jan. 26, 1983
C                       Added writes if ICOND out of range.
C			Version 4U, D. Gudehus, September, 1994
C			Fixed up for UNIX
C			Version 4, D. Gudehus, October, 1999
C			Removed WRITE statements if condition falls
C			through to bottom.
C
C	Parameters:  ICOND  	Error level
C		     MESS	Character string to be printed.
C	
C	Error levels: 
C	ICOND=0	Warning - Message only
C	ICOND=-1 Error message given, but it is assumed that the calling
C		program will take care of the error.
C	ICOND=-2 Error condition may not be fatal.  User is given option 
C    		to continue.
C	ICOND=-3 Serious error - Force return to main program recovery 
C		location. 
C	ICOND=-4 Fatal error - Execution can't continue.  Return to 
C  		monitor by calling LIB$STOP.
C
	CHARACTER*(*) MESS
	CHARACTER*1 X
	DATA L/-2/  ! Default abort level;  should be set by main
		    ! program
C
C  Application program error codes are used in calls to LIB$SIGNAL
C  and LIB$STOP.  These codes are detected by the
C  default condition handlers STR$C_HANDL and STR$NOC_HANDL.
C
C	INTEGER APP$_ERROR,APP$_FATAL,SS$_ABORT
C	PARAMETER APP$_ERROR='80038002'X,APP$_FATAL='8003800C'X,
C	1SS$_ABORT='0000002C'X
C
C  Warning
	IF (ICOND.EQ.0) THEN
	  WRITE(7,1001) MESS
	  WRITE(6,1001) MESS
1001	  FORMAT(' WARNING!  ',A,/' Execution continues')
	  IF (ICOND.GT.L) RETURN
C
C  Error message only
	ELSE IF (ICOND.EQ.-1) THEN
   	  WRITE(7,1031) MESS
	  WRITE(6,1031) MESS
	  IF (ICOND.GT.L) RETURN
C
C  Possible error condition
	ELSE IF (ICOND.EQ.-2) THEN
   	  WRITE(7,1021) MESS
	  WRITE(6,1021) MESS
1021	  FORMAT(' POSSIBLE ERROR:  ',A/
	1 ' Enter "C" if you wish to proceed')
	  IF (ICOND.GT.L) RETURN
	  READ(5,1012) X
1012	  FORMAT(1A1)
	  IF (X.EQ.'C') RETURN
C	  CALL LIB$SIGNAL(%VAL(APP$_ERROR))
C
C  Serious error
	ELSE IF (ICOND.EQ.-3) THEN
	  WRITE(7,1031) MESS
	  WRITE(6,1031) MESS
1031	  FORMAT(' ERROR:  ',A)
	  IF (ICOND.GT.L) RETURN
C	  CALL LIB$SIGNAL(%VAL(APP$_ERROR))
C
C  Fatal error
	ELSE IF (ICOND.EQ.-4) THEN
   	  WRITE(7,1041) MESS
	  WRITE(6,1041) MESS
1041	  FORMAT(' FATAL ERROR:  ',A)
	  IF (ICOND.GT.L) RETURN
C	  CALL LIB$SIGNAL(%VAL(APP$_FATAL))
	  STOP
	END IF
C
C  If the condition has dropped through to here, signal it and
C  assume that a condition handler will grab it.
C
C	CALL LIB$SIGNAL(%VAL(ICOND))
	RETURN
C
C  Entry to change level for error abort
	ENTRY SETLEV(LL)
	L=LL
	RETURN
C
	END

	PROGRAM SAODEMO3
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we see a contact binary in action
C  by successively loading frames at various phases of the orbital 
C  motion.
C
C			Donald H. Gudehus, July, 1994
C			Version 1U, D. Gudehus, September, 1994
C			Converted code to UNIX
C			Version 2U, D. Gudehus, August 28, 1999
C			Added interframe delay
C			Version 3, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
	INCLUDE 'saofacts.for' !  UNIX likes lowercase
C
	CHARACTER*40 ARRAY_NAME
	PARAMETER NCOLS=70,NROWS=70,NIMAGES=20
	REAL ARRAY(NCOLS,NROWS,NIMAGES) !  Array size is compromise between 
					!  visible area and speed
C
	CALL GET_ENDIAN
C  Ask the user for a delay time
        DELAY_TIME=0.0
        CALL USRINP(DELAY_TIME,1,'F',4,1,'DELAY_TIME=',
	1'Enter an interframe delay time in seconds:  (default = 0.0)')
C
	IFB_SAO=13 !  Gives a 90 by 90 buffer which fills the frame in 1 buffer
		   !  load of 8192 bytes.
	CALL SAOSTART
	CALL SAOFIRST
C
C  Select a color look-up table
	IVAL='300'X
	CALL SAOCONVLT(IVAL)
	CALL MESSAGE('Creating the images')
C  Zero the arrays
	DO K=1,NIMAGES
	  DO J=1,NCOLS
	    DO I=1,NROWS
	      ARRAY(I,J,K)=0.0
	    END DO
	  END DO
	END DO
	NC1=NCOLS/2
	NR1=NROWS/2-1
	BRIGHTNESS_MIN=5.0
	BRIGHTNESS_MAX=800.0
C  Center the images within the frame
	IXFRAME=MAXFB_COLS_SAO/2-NC1
	IYFRAME=MAXFB_ROWS_SAO/2+NR1
	ARRAY_NAME='Contact Binary System'
	MODE=0 !  Fast load of a single picture
	a=2.0
	NPICTURE=1
C  First create the images.  This will result in a faster repetition rate
C  than if we calculate the images while they are being sent to SAOimage
	DO K=1,NIMAGES
	  X1=10.0*COSD(18.0*K)+NC1
	  Y1=10.0*SIND(18.0*K)+NR1
	  X2=-22.0*COSD(18.0*K)+NC1
	  Y2=-22.0*SIND(18.0*K)+NR1
C  The lower left corner of each data array is considered to be at 1, 1.
	  DO J=1,NROWS
	    DO I=1,NCOLS
	      R1=SQRT((I-X1)**2+(J-Y1)**2)
	      R2=SQRT((I-X2)**2+(J-Y2)**2)
	      ARRAY(I,J,K)=880.0/(1+R1/a)**2+440.0/(1+R2/a)**2
	    END DO
	  END DO
	END DO
	DO NREPEAT=1,8
	  DO K=1,20
	    CALL SAOLOAD(ARRAY(1,1,K),NCOLS,NROWS,IXFRAME,IYFRAME,
	1   BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
	    CALL DELAY(DELAY_TIME)
	  END DO
	END DO
	END

	CHARACTER*(*) FUNCTION CHFITSMHV(LU,MAP_NUMBER,KEYWORD,DEFAULT)
C
C       This function returns a character value from or associatied with a 
C  FITS header keyword.  The character value will have its surrounding single
C  quotes striped away.
C			Donald H. Gudehus, June 16, 2005
C
C	LU		(C)	The logical unit that the file was opened on
C	MAP_NUMBER	(C)	The map number within the file.  If more than
C				one map exists, then there will also be a
C				primary header which can be referenced with
C				MAP_NUMBER=0.
C	KEYWORD		(C)	The FITS keyword
C	DEFAULT         (C/R)   The value to be returned if keyword not found
C
	CHARACTER*(*) KEYWORD,DEFAULT
C
	BYTE PHYSREC(3000)
	CHARACTER*80 KEYCARD
	CHARACTER*3000 CHARPHYSREC
	EQUIVALENCE (PHYSREC,CHARPHYSREC)
C
	INCLUDE 'fitsfacts.for'
C
	IF (LU.LT.LUMIN.OR.LU.GT.LUMAX) THEN
	  CALL ERROR(-4,'LU out of range in CHFITSMHV')
	END IF
	IF (MAP_NUMBER.LT.0.OR.MAP_NUMBER.GT.NUMMAPS(LU))
	1CALL ERROR(-4,'MAP_NUMBER out of range in CHFITSMHV')
	IBLKLEN=2880
	IFOUND=0
C
C  If the keyword has a value which should already be in one of the FITSFACTS
C  COMMON blocks, just retrieve the information from there.
	IF (KEYWORD.EQ.'BITPIX') THEN
	  IFOUND=1
	  IF (BITPIX(MAP_NUMBER,LU).EQ.8) THEN
	    CHFITSMHV='I1'
	  ELSE IF (BITPIX(MAP_NUMBER,LU).EQ.16) THEN
	    CHFITSMHV='I2'
	  ELSE IF (BITPIX(MAP_NUMBER,LU).EQ.32) THEN
	    CHFITSMHV='I4'
	  ELSE IF (BITPIX(MAP_NUMBER,LU).EQ.-32) THEN
	    CHFITSMHV='R4'
	    IF (COMPLX(MAP_NUMBER,LU)) CHFITSMHV='C8'
	  ELSE IF (BITPIX(MAP_NUMBER,LU).EQ.-64) THEN
	    CHFITSMHV='R8'
	    IF (COMPLX(MAP_NUMBER,LU)) CHFITSMHV='C16'
	  ELSE
	    IFOUND=0
	  END IF
	ELSE
C  Search through the keywords in the header
	  KEYCARD=' '
	  CHFITSMHV=' '
	  N=LEN(KEYWORD)
	  IR=HEADERRECORDS(1,MAP_NUMBER,LU)
	  DO WHILE(KEYCARD(1:3).NE.'END')
	    IBPTR=1
	    READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	    IF (ISTAT.NE.0) THEN
	      CALL ERROR(-3,'Error in reading physical record')
	    END IF
	    DO WHILE(KEYCARD(1:3).NE.'END'.AND.IBPTR.LE.2801)
	      KEYCARD=CHARPHYSREC(IBPTR:IBPTR+79)
C  Eliminate control characters
	      DO I=1,80
	        IF (ICHAR(KEYCARD(I:I)).LT.32) KEYCARD(I:I)=' '
	      END DO
	      IF (KEYCARD(1:N).EQ.KEYWORD(1:N)) THEN
	        IND=INDEX(KEYCARD,'''')
	        CHFITSMHV=KEYCARD(IND+1:)
	        IND=INDEX(CHFITSMHV,'''')
	        CHFITSMHV=CHFITSMHV(1:IND-1)
C  Strip trailing blanks
	        I=IND-1
	        DO WHILE(CHFITSMHV(I:I).EQ.' ')
	          I=I-1
	        END DO
	        CHFITSMHV=CHFITSMHV(1:I)
	        IF (IND.EQ.0) THEN
	          IFOUND=0
	        ELSE
	          IFOUND=1
	        END IF
	      END IF
	      IBPTR=IBPTR+80
	    END DO
	    IR=IR+1
	  END DO
	END IF
C
	IF (IFOUND.NE.1) CHFITSMHV=DEFAULT
C
	RETURN
	END

	PROGRAM SAODEMO8
C
C  Note:  This is the Unix version
C
C       This program follows 3 mass points in a planar orbit about each other.
C
C			Donald H. Gudehus, November 9, 1994
C			Version 1U, D. H. G., August 31, 1999
C			Modified code for Unix
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
C	CHARACTER*3 DEVICES(10)
	REAL*8 xy(2,3),v_xy(2,3), !  2 positions, 3 objects; etc.
	1xy_prior(2,3),a_xy(2,3)
	REAL*8 TEMP(3),KN,km_AU,K(3),t,dt,dtmin,dt_try,dv_v,r3
C
	INCLUDE 'saofacts.for'
	INTEGER*4 ACTION,COLOR_TYPE
C
	CALL GET_ENDIAN
C
	CALL MESSAGE('This program demonstrates 3 gravitationally'//
	1' interacting bodies.  First')
	CALL MESSAGE('run it with the defaults (just press the <CR>).'//
	1'  Then vary the')
	CALL MESSAGE('(delta velocity)/velocity and the minimum'//
	1' time step and notice')
	CALL MESSAGE('how the accuracy of the final loops and slingshots'//
	1' changes.')
	CALL MESSAGE(' ')
	CALL MESSAGE('Be sure that the SAOimage desktop is at least 800'//
	1' pixels wide')
	CALL MESSAGE(' ')
C	G=6.668E-11 !  Gravitational constant in mks
C	M will be input in solar masses (1 solar mass = 1.9891E30 kg)
C	Distance will be input in AU (1 AU = 1.495979E11 m)
C	Velocity will be input in km/sec
C	The calculations will be done in AU, km/sec, and km/sec/sec 
C	to avoid overflow
C	r(km)=r(AU)*1.4959791E11*0.001
C	M(kg)=M(M_solar)*1.9891E30
C	a(km/sec/sec)=a(m/sec/sec)*0.001
C	a(m/sec/sec)=GM(kg)/r(m)**2
C	a(km/sec/sec)=GM(M_solar)/r(km)**2*(1.9891E30*0.001**2*0.001)
C	a(km/sec/sec)=K1*M(M_solar)/r(km)**2
C	K1=6.667E-11*1.9891E30*0.001**3
C	a(km/sec/sec)=KN*M(M_solar)/r(AU)**2
	KN=6.667D-11*1.9891D30*0.001**3/(1.4959791D8)**2
	km_AU=1.0D0/1.4959791D8
	TEMP(1)=1.0D0
	TEMP(2)=0.5D0
	TEMP(3)=0.25D0
	CALL MESSAGE('Enter the masses of the 3 objects in solar masses:')
	CALL USRINP(TEMP,3,'F',8,1,'MASSES=','(default = 1.0 0.5 0.25)')
	K(1)=KN*TEMP(1)
	K(2)=KN*TEMP(2)
	K(3)=KN*TEMP(3)
C
	TEMP(1)=3.0D0
	TEMP(2)=0.0D0
	CALL USRINP(TEMP,2,'F',8,1,'POSITION=',
	1'Enter the initial x and y position of mass 1 in units of AU:'//
	1' (default = 3 0)')
	xy(1,1)=TEMP(1)
	xy(2,1)=TEMP(2)
	TEMP(1)=0.0D0
	TEMP(2)=-3.0D0
	CALL USRINP(TEMP,2,'F',8,1,'POSITION=',
	1'Enter the initial position of mass 2 in units of AU:'//
	1' (default = 0 -3)')
	xy(1,2)=TEMP(1)
	xy(2,2)=TEMP(2)
	TEMP(1)=-3.0D0
	TEMP(2)=0.0D0
	CALL USRINP(TEMP,2,'F',8,1,'POSITION=',
	1'Enter the initial position of mass 3 in units of AU:'//
	1' (default = -3 0)')
	xy(1,3)=TEMP(1)
	xy(2,3)=TEMP(2)
C
	TEMP(1)=0.0D0
	TEMP(2)=9.0D0
	CALL USRINP(TEMP,2,'F',8,1,'VELOCITY=','Enter the initial velocity'//
	1' of object 1 in units of km/sec:  (default = 0 9)')
	v_xy(1,1)=TEMP(1)
	v_xy(2,1)=TEMP(2)
	TEMP(1)=10.0D0
	TEMP(2)=0.0D0
	CALL USRINP(TEMP,2,'F',8,1,'VELOCITY=','Enter the initial velocity'//
	1' of object 2 in units of km/sec:  (default = 10 0)')
	v_xy(1,2)=TEMP(1)
	v_xy(2,2)=TEMP(2)
	TEMP(1)=0.0D0
	TEMP(2)=-10.0D0
	CALL USRINP(TEMP,2,'F',8,1,'VELOCITY=','Enter the initial velocity'//
	1' of object 3 in units of km/sec:  (default = 0 -10)')
	v_xy(1,3)=TEMP(1)
	v_xy(2,3)=TEMP(2)
C
	dv_v=0.003D0
	CALL MESSAGE('Enter the maximum desired (delta velocity)/velocity')
	CALL USRINP(dv_v,1,'F',8,1,'DELTA_VELOCITY/VELOCITY=',
	1'per integration step:  (default = 0.003)')
	CALL MESSAGE('Enter the minimum allowable time interval in seconds'//
	1' for the steps:')
	dtmin=2000.0D0
	CALL USRINP(dtmin,1,'F',8,1,'MINIMUM_TIME_INTERVAL=',
	1'(default = 2,000;  this takes precedence over the previous'//
	2' constraint)')
	N_STEPS_PER_PLOT=60
	CALL USRINP(N_STEPS_PER_PLOT,1,'I',4,1,'N_STEPS_PER_PLOT=',
	1'Enter the number of calculations per plotted point:'//
	2'  (default = 60)')
	P_SCALE=0.15 !  Scaling for plot
	CALL USRINP(P_SCALE,1,'F',4,1,'PLOT_SCALE=',
	1'Enter the plotting scale in inches per AU:  (default = 0.15)')
	t_max=1.5D9
	CALL USRINP(t_max,1,'F',4,1,'MAXIMUM_TIME=',
	1'Enter the desired elapsed time in seconds:  (default = 1.5E9)')
C  Begin the calculation
C  The commented code below shows an alternate way of displaying the
C  results by means of the MIIPS plot package.
C	DEVICES(1)='S'
C	CALL PLOTDEVICES(DEVICES)
C	CALL PLOTDEVICES2(DEVICES)
C	CALL COLORMODE(8388564) !  Aquamarine
C	CALL PLOT(2.2,5.0,-3)
C	CALL SYMBOL(-0.8,0.5,0.3,%REF('Three-body Calculation'),0.0,22)
	IFB_SAO=2
	CALL SAOSTART
	CALL SAOFIRST
	NPIC_SAO=1
	NFRAME_SAO=0
	XLOC_SAO(NPIC_SAO)=2.2*95
	YLOC_SAO(NPIC_SAO)=0.8*95
	TV_FILENAME(NPIC_SAO)='3-body calculation'
	CALL SAOCAPTION
	IMSX_SAO(NFRAME_SAO,NPIC_SAO)=1
	IMSY_SAO(NFRAME_SAO,NPIC_SAO)=1
	NPTSX_SAO(NPIC_SAO)=MAXFB_COLS_SAO
	NPTSY_SAO(NPIC_SAO)=MAXFB_ROWS_SAO
	ACTION=3 !  Immediate display of vectors
C
	t=0.0D0
	DO WHILE (t.LT.t_max)
	  DO N=1,3 !  Loops over objects
	    xy_prior(1,N)=xy(1,N) !  Used for plotting only
	    xy_prior(2,N)=xy(2,N)
	  END DO
	  DO I=1,N_STEPS_PER_PLOT
	    DO N=1,3 !  Loops over objects
C  Update the physical quantities
	      a_xy(1,N)=0.0D0
	      a_xy(2,N)=0.0D0
	      NN=1
	      DO WHILE(NN.LE.3)
	        IF (NN.NE.N) THEN
	          r3=((xy(1,N)-xy(1,NN))**2+(xy(2,N)-xy(2,NN))**2)
	1         **1.5
	          a_xy(1,N)=a_xy(1,N)-K(N)/r3*(xy(1,N)-xy(1,NN))
	          a_xy(2,N)=a_xy(2,N)-K(N)/r3*(xy(2,N)-xy(2,NN))
	        END IF
	        NN=NN+1
	      END DO
	    END DO
C  Find the minimum delta t
	    dt=1.0D15
	    DO N=1,3 !  Loops over objects
	      IF (a_xy(1,N).NE.0.0D0) dt_try=ABS(dv_v*v_xy(1,N)/a_xy(1,N))
	      IF (dt_try.LT.dt) dt=dt_try
	      IF (a_xy(2,N).NE.0.0D0) dt_try=ABS(dv_v*v_xy(2,N)/a_xy(2,N))
	      IF (dt_try.LT.dt) dt=dt_try
	    END DO
	    dt=MAX(dt,dtmin)
	    DO N=1,3
	      v_xy(1,N)=v_xy(1,N)+a_xy(1,N)*dt
	      v_xy(2,N)=v_xy(2,N)+a_xy(2,N)*dt
	      xy(1,N)=xy(1,N)+v_xy(1,N)*dt*km_AU
	      xy(2,N)=xy(2,N)+v_xy(2,N)*dt*km_AU
	    END DO
	    t=t+dt
	  END DO
	  DO N=1,3
C	    CALL PLOT(P_SCALE*xy_prior(1,N),P_SCALE*xy_prior(2,N),3)
C	    IF (N.EQ.1) CALL COLORMODE(255) !  Blue
C	    IF (N.EQ.2) CALL COLORMODE(16766720) !  Gold
C	    IF (N.EQ.3) CALL COLORMODE(16729344) !  Orange-red
	    IF (N.EQ.1) COLOR_TYPE=206 !  Blue
	    IF (N.EQ.2) COLOR_TYPE=207 !  Yellow
	    IF (N.EQ.3) COLOR_TYPE=204 !  Red
	    X=P_SCALE*xy(1,N)
	    Y=P_SCALE*xy(2,N)
	    IF (ABS(X).GT.100.0.OR.ABS(Y).GT.100.0) STOP
C	    CALL PLOT(X,Y,2)
	    X_OLD=P_SCALE*xy_prior(1,N)
	    Y_OLD=P_SCALE*xy_prior(2,N)
	    CALL SAO_VECT(ACTION,COLOR_TYPE,95*X_OLD,95*Y_OLD,95*X,
	1   95*Y,NPIC_SAO)
	  END DO
	END DO
	END

	SUBROUTINE SAODOT(IX,IY,NPIC,IVAL)
C
C  Note:  This is the UNIX version
C
C       This subroutine lights a single pixel in SAOimage.  It is assumed
C  that a file has previously been loaded, or that SAOCATPION was called,
C  so that SAOimage is properly initialized.
C
C				Donald H. Gudehus, August, 1993
C				Version 1U, D. Gudehus, September, 23, 1994
C				Converted code to UNIX
C				Version 2, D. Gudehus, August 29, 2006
C				Incorporated changes from saofacts.for
C				and added SYS_ENDIAN common block
C
C	IX	(C)	The desired X map location of the pixel.  
C	IY	(C)	Same as IX but in the Y direction.
C	NPIC	(C)	The number of the picture (1 to 16) loaded into the
C			frame
C	IVAL	(C)	The intensity value applied to the pixel.  Numbers
C			from 0 to 255 are possible.  Some assignments are:
C
C Signed byte  Unsigned byte or integer  Color
C      -55             201               green
C      -54             202               black
C      -53             203               white
C      -52             204               red
C      -51             205               green
C      -50             206               blue
C      -49             207               yellow
C      -48             208               black
C      -47             209               white
C      -46             210               yellow
C      -45             211               red
C      -44             212               yellow
C      -43             213               white
C      -42             214               red
C      -41             215               green
C      -40             216               blue
C      -39             217               white
C
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 SYSTEM_ENDIAN
	COMMON /SYS_ENDIAN/ SYSTEM_ENDIAN
C
	INTEGER*4 NPIC
C
	IXLOC=XLOC_SAO(NPIC)  ! Converts to I4
	IYLOC=YLOC_SAO(NPIC)  ! Converts to I4
	IMIN=IMSX_SAO(NFRAME_SAO,NPIC)
	JMIN=IMSY_SAO(NFRAME_SAO,NPIC)
C  We use the auxilliary buffer so that it doesn't have to be reloaded every
C  row.
	IHDBUFFER_SAO(1)='71000'O  ! = 29184
	IHDBUFFER_SAO(2)=-1  ! imhead.thingct
	IHDBUFFER_SAO(3)=1  ! imhead.subunit = MEMORY
	IHDBUFFER_SAO(4)=0
	I2=IX-IMIN+IXLOC
	IHDBUFFER_SAO(5)=IOR(I2,'100000'O)  ! x
	IHDBUFFER_SAO(7)=1
	IHDBUFFER_SAO(8)=IOR(63,'300'O)
	J2=JMIN+IYLOC-IY
	IHDBUFFER_SAO(6)=IOR(J2,'100000'O)  ! y
	CALL IMTOOLCHECKSUM(IHDBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(HDBUFFER_SAO,NBYTES)
	NBYTES=1
	IBUFFER_TEMP_SAO=IVAL
	IF (SYSTEM_ENDIAN.EQ.'L') THEN
	  BUFFER_SAO(1)=BUFFER_TEMP_SAO(1)
	ELSE IF (SYSTEM_ENDIAN.EQ.'B') THEN
	  BUFFER_SAO(1)=BUFFER_TEMP_SAO(2)
	END IF
C  Send the row of data to SAOimage
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	RETURN
	END

	SUBROUTINE KEPLER(MEANANOM,ECCENTR,ECCENTRANOM)
C
C       This subroutine solves Kepler's equation by Newton's method
C
C				Donald H. Gudehus, April 2, 1990
C
C	MEANANOM	(C)	The mean anomaly in degrees
C	ECCENTR		(C)	The eccentricity
C	ECCENTRANOM	(R)	The eccentric anomaly in degrees
C
	REAL*8 MEANANOM,ECCENTR,ECCENTRANOM,MEANANOMRAD,PREVIOUS_EA,DEG_RAD
C
	DEG_RAD=57.29577951308232
	MEANANOMRAD=MEANANOM/DEG_RAD
	ECCENTRANOM=MEANANOMRAD  ! First approximation
	PREVIOUS_EA=0.0
	DO WHILE (ABS(ECCENTRANOM-PREVIOUS_EA).GT.1.8E-15)  ! Empirically 
		! determined limit
	  PREVIOUS_EA=ECCENTRANOM
	  ECCENTRANOM=ECCENTRANOM-(MEANANOMRAD+ECCENTR*DSIN(ECCENTRANOM)-
	1 ECCENTRANOM)/(ECCENTR*DCOS(ECCENTRANOM)-1.0)
	END DO
	ECCENTRANOM=ECCENTRANOM*DEG_RAD
	RETURN
	END

	PROGRAM SAODEMO
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  We send colored dots, moving dots, various kinds
C  of cursors, several images, and manipulate the color look-up table.
C
C			Donald H. Gudehus, 1993
C			Version 1U, D. Gudehus, September, 1994
C			Changed code for UNIX
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for
C			and put in call to GET_ENDIAN
C			Version 3, D. Gudehs, April 16, 2009
C			Removed MAXFB_COLS_SAO and MAXFB_ROWS_SAO from
C			argument list of SAODEMO_DYNAMIC1 since they are in
C			saofacts.for.
C
	INCLUDE 'saofacts.for' !  UNIX likes lower case
C
	INTEGER*4 ACTION,CURSOR_TYPE,COLOR_TYPE,ADDRESS1
	REAL INCLINA,EXTRA(6)
C
	CALL GET_ENDIAN
	IFB_SAO=0  ! Lets the user be prompted for the size of the buffer
C  Establish the buffer size
	CALL SAOSTART
C  Initialize SAOimage
	CALL SAOFIRST
C  Initialize the lookup table so that the background will be black
	IVAL='100'X
	CALL SAOCONVLT(IVAL)
C
C  Get some parameters set up.  Initially, we will only be concerned with
C  one picture
	NCOLS=MAXFB_COLS_SAO
	NROWS=MAXFB_ROWS_SAO
	NPIC_SAO=1 !  Pictures run from 1 to 16
	NFRAME_SAO=0 !  Frames run from 0 to 3.  Only one frame is supported
		     !  on SAOimage
C  Establish the starting location on the frame
	XLOC_SAO(NPIC_SAO)=0
	YLOC_SAO(NPIC_SAO)=MAXFB_ROWS_SAO-1
C  Establish the starting location in the array
	IMSX_SAO(NFRAME_SAO,NPIC_SAO)=1
	IMSY_SAO(NFRAME_SAO,NPIC_SAO)=1
C
C  Write random colored dots onto the display
C  Send a caption for the colored dots now that we have set up the parameters
	TV_FILENAME(NPIC_SAO)='Colored dots'
	CALL SAOCAPTION
C
	ISEED=12345
	NPIC1=NPIC_SAO
	DO K=1,600
	  IVAL=MOD(K,5)+203
	  IX=RAN(ISEED)*(NCOLS-1)+1
	  IY=RAN(ISEED)*(NROWS-1)+1
	  CALL SAODOT(IX,IY,NPIC1,IVAL) !  Map coordinates
	END DO
C  Send moving dots
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Moving dots'
	CALL SAOCAPTION
C  Now send the dots
	DO K=1,400 !  Longer loop for Unix since it is faster than VMS
	  ILEN=2*NINT(25.0*RAN(ISEED))+20 !  Length of streak
	  IDELTA=2*NINT(16.0*RAN(ISEED))+4 !  Length of lighted portion
	  IDELTA=MIN(IDELTA,ILEN-4)
	  THETA=360.0*RAN(ISEED)
	  DELX=COSD(THETA)
	  DELY=SIND(THETA)
	  IX=(NCOLS-2*ILEN)*RAN(ISEED)+ILEN !  Starting X location
	  IY=(NROWS-2*ILEN)*RAN(ISEED)+ILEN !  Starting Y location
	  IVAL=NINT(4.0*RAN(ISEED))+203
	  DO N=0,ILEN+IDELTA,2
	    IF (N.LE.ILEN) THEN
	      IIX=IX+NINT(N*DELX)
	      IIY=IY+NINT(N*DELY)
	      IF (IIX.GE.1.AND.IIY.GE.1.AND.IIX.LE.NCOLS.AND.
	1     IIY.LE.NROWS) CALL SAODOT(IIX,IIY,NPIC1,IVAL)
	    END IF
	    IF (N.GE.IDELTA) THEN
	      IIX=IX+NINT((N-IDELTA)*DELX)
	      IIY=IY+NINT((N-IDELTA)*DELY)
	      IF (IIX.GE.1.AND.IIY.GE.1.AND.IIX.LE.NCOLS.AND.
	1     IIY.LE.NROWS) CALL SAODOT(IIX,IIY,NPIC1,208)
	    END IF
	  END DO
	END DO
C
C  Draw erasable circles and ellipses
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Erasable circles and ellipses'
	CALL SAOCAPTION
	ACTION=1 !  Erasable cursor
	CURSOR_TYPE=1024 !  Circles and ellipses
	NPIC1=NPIC_SAO
	ISEED=12345
	DO K=1,34
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+1.5
	  Y=RAN(ISEED)*(NROWS-2)+1.5
	  a=RAN(ISEED)*NROWS*0.1+1.0
	  b=RAN(ISEED)*NCOLS*0.1+1.0
	  INCLINA=RAN(ISEED)*360.0
	  EXTRA(1)=0.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
	CALL SAO_ERASE_CURSOR(0)
C  Display some annuli too
	TV_FILENAME(NPIC_SAO)='Erasable circular and elliptical annuli'
	CALL SAOCAPTION
	DO K=1,16
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+1.5
	  Y=RAN(ISEED)*(NROWS-2)+1.5
	  a=RAN(ISEED)*NROWS*0.08+1.0
	  b=RAN(ISEED)*NCOLS*0.08+1.0
	  INCLINA=RAN(ISEED)*360.0
	  EXTRA(1)=a*1.8
	  EXTRA(2)=a*2.5
	  EXTRA(3)=a*3.0
	  EXTRA(4)=a*3.4
	  EXTRA(5)=a*3.8
	  EXTRA(6)=a*4.1
	  NEXTRA=NINT(RAN(ISEED)*5.0)+1
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,NEXTRA)
	  CALL DELAY(0.05)
	END DO
C  Pause to view
	DO I=1,100
	  IVAL='100'X
	  CALL SAOCONVLT(IVAL)
	END DO
C  Erase circle cursors
	CALL SAO_ERASE_CURSOR(0)
C
C  Draw circle cursor regions
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Erasable circle regions'
	CALL SAOCAPTION
	INCLINA=0.0
	ACTION=11 !  Erasable region cursor
	DO K=1,25
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-40)+20.0
	  Y=RAN(ISEED)*(NROWS-40)+20.0
	  a=RAN(ISEED)*MAX(60.0,NCOLS*0.1)+1.0
	  b=RAN(ISEED)*MAX(60.0,NROWS*0.1)+1.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
C  Pause to view
	DO I=1,100
	  IVAL='100'X
	  CALL SAOCONVLT(IVAL)
	END DO
C  Erase circle cursor regions
	CALL SAO_ERASE_CURSOR(1)
C
C  Draw some nonerasable circles and ellipse
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Nonerasable circles and ellipses'
	CALL SAOCAPTION	
C
	ACTION=2 !  Nonerasable cursor
	DO K=1,15
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+1.5
	  Y=RAN(ISEED)*(NROWS-2)+1.5
	  a=RAN(ISEED)*NCOLS*0.1+1.0
	  b=RAN(ISEED)*NROWS*0.1+1.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
C
C  Draw erasable rectangles
C
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Erasable rectangles'
	CALL SAOCAPTION
C
	ACTION=1 !  Erasable cursor
	CURSOR_TYPE=768 !  Rectangle
	NPIC1=NPIC_SAO
	DO K=1,30
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+2
	  Y=RAN(ISEED)*(NROWS-2)+2
	  a=RAN(ISEED)*NCOLS*0.1+1.0
	  b=RAN(ISEED)*NROWS*0.1+1.0
	  INCLINA=RAN(ISEED)*360.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
C  Erase rectangle cursor
	CALL SAO_ERASE_CURSOR(0)
C
C  Draw some erasable rectangle regions
C  Send the caption
	TV_FILENAME(NPIC)='Erasable rectangle regions'
	CALL SAOCAPTION
C
	INCLINA=0.0
	ACTION=11 !  Erasable region cursor
	DO K=1,25
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+2
	  Y=RAN(ISEED)*(NROWS-2)+2
	  a=RAN(ISEED)*NCOLS*0.1+1.0
	  b=RAN(ISEED)*NROWS*0.1+1.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
C  Pause to view 
	DO I=1,100
	  IVAL='100'X
	  CALL SAOCONVLT(IVAL)
	END DO
C  Erase rectangle cursor
	CALL SAO_ERASE_CURSOR(1)
C
C  Draw some nonerasable rectangles
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Nonerasable rectangles'
	CALL SAOCAPTION
C
	ACTION=2 !  Nonerasable cursor
	DO K=1,80
	  COLOR_TYPE=MOD(K,5)+203
	  X=RAN(ISEED)*(NCOLS-2)+2
	  Y=RAN(ISEED)*(NROWS-2)+2
	  a=RAN(ISEED)*NCOLS*0.1
	  b=RAN(ISEED)*NROWS*0.1
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	  CALL DELAY(0.05)
	END DO
C
C  Draw a picture in each quadrant of the frame buffer.
C  The upper left corner of the frame buffer, given by XLOC, YLOC is at
C  0, 0.
	IVAL='100'X
	CALL SAOCONVLT(IVAL)
C  Because we do not know ahead of time what size the array should be
C  (since that is chosen by the user when the program is run) we need
C  to use dynamic memory.  Somewhat smoother loading of the image on the
C  screen of SAOimage can be attained by putting the code for SAOLOAD 
C  here and avoiding subroutine calls and dynamic memory, but this 
C  arrangement is easier to use and understand.
	NCOLS=MAXFB_COLS_SAO/2 !  4 pictures in the frame buffer
	NROWS=MAXFB_ROWS_SAO/2
	LENGTH1=NCOLS*NROWS
	CALL DYNAMIC(ADDRESS1,LENGTH1,'  R4',.TRUE.)
	CALL SAODEMO_DYNAMIC1(%VAL(ADDRESS1),NCOLS,NROWS)
	CALL DYNAMIC(ADDRESS1,LENGTH1,'  R4',.FALSE.)
C
C  Change the color LUT
C  Send the caption
	TV_FILENAME(NPIC_SAO)='Color look-up table'
	CALL SAOCAPTION
C
	DO K=1,2
	  IF (K.EQ.1) TIME=1.0
C  First slowly
	  IF (K.EQ.2) TIME=0.2
C  Then fast
	  DO J=1,11
	    IF (J.EQ.1) IVAL='100'X
	    IF (J.EQ.2) IVAL='200'X
	    IF (J.EQ.3) IVAL='300'X
	    IF (J.EQ.4) IVAL='400'X
	    IF (J.EQ.5) IVAL='500'X
	    IF (J.EQ.6) IVAL='600'X
	    IF (J.EQ.7) IVAL='700'X
	    IF (J.EQ.8) IVAL='800'X
	    IF (J.EQ.9) IVAL='900'X
	    IF (J.EQ.10) IVAL='A00'X
	    IF (J.EQ.11) IVAL='B00'X
	    CALL SAOCONVLT(IVAL)
	    CALL DELAY(TIME)
	  END DO
	END DO
	IVAL='800'X
	CALL SAOCONVLT(IVAL)
	END
C
	SUBROUTINE SAODEMO_DYNAMIC1(ARRAY,NCOLS,NROWS)
C
	DIMENSION ARRAY(NCOLS,NROWS)
C
C	This subroutine helps SAODEMO when dynamic memory is needed
C  to create room for ARRAY.
C
C			Donald H. Gudehus, July, 1994
C			Version 2, D. Gudehus,  April 16
C			Removed MAXFB_COLS_SAO and MAXFB_ROWS_SAO from
C			argument list of SAODEMO_DYNAMIC1 since they are in
C			saofacts.for.
C
	INCLUDE 'saofacts.for'
C
	CHARACTER*40 CAPTION
C  The lower left corner of each data array is considered to be at 1, 1.
	IMIN=1
	JMIN=1
	IMAX=NCOLS
	JMAX=NROWS
	BRIGHTNESS_MIN=-1000.0
	BRIGHTNESS_MAX=1000.0
	MODE=1
	DO NPICTURE=1,4
	  IF (NPICTURE.EQ.1) THEN
	    IXLOC=MAXFB_COLS_SAO/2
	    IYLOC=MAXFB_ROWS_SAO/2-1
	    DO J=JMIN,JMAX
	      DO I=IMIN,IMAX
	        ARRAY(I,J)=1000.0*COSD(I*360.0/IMAX)
	      END DO
	    END DO
	    CAPTION='First picture'
	    CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXLOC,IYLOC,BRIGHTNESS_MIN,
	1   BRIGHTNESS_MAX,CAPTION,NPICTURE,MODE)
	  ELSE IF (NPICTURE.EQ.2) THEN
	    IXLOC=MAXFB_COLS_SAO/2
	    IYLOC=MAXFB_ROWS_SAO-1
	    DO J=JMIN,JMAX
	      DO I=IMIN,IMAX
	        ARRAY(I,J)=1000.0*COSD(J*360.0/IMAX)
	      END DO
	    END DO
	    CAPTION='Second picture'
	    CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXLOC,IYLOC,BRIGHTNESS_MIN,
	1   BRIGHTNESS_MAX,CAPTION,NPICTURE,MODE)
	  ELSE IF (NPICTURE.EQ.3) THEN
	    IXLOC=0
	    IYLOC=MAXFB_ROWS_SAO-1
	    DO J=JMIN,JMAX
	      DO I=IMIN,IMAX
	        ARRAY(I,J)=1000.0*COSD((I+J)*360.0/IMAX)
	      END DO
	    END DO
	    CAPTION='Third picture'
	    CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXLOC,IYLOC,BRIGHTNESS_MIN,
	1   BRIGHTNESS_MAX,CAPTION,NPICTURE,MODE)
	  ELSE IF (NPICTURE.EQ.4) THEN
	    IXLOC=0
	    IYLOC=MAXFB_ROWS_SAO/2-1
	    DO J=JMIN,JMAX
	      DO I=IMIN,IMAX
	        ARRAY(I,J)=1000.0*COSD((I-J)*720.0/IMAX)
	      END DO
	    END DO
	    CAPTION='Fourth picture'
	    CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXLOC,IYLOC,BRIGHTNESS_MIN,
	1   BRIGHTNESS_MAX,CAPTION,NPICTURE,MODE)
	  END IF
	END DO
	RETURN
	END

	SUBROUTINE SAVE(NAME)
C
C	Note:  this is the UNIX version.
C
C       This subroutine opens a file to save the input parameters
C  requested by SAVEC.FOR which were required by USRINP.FOR.
C			Version 2, Donald H. Gudehus, October, 1983
C			Changed file type from UNKNOWN to NEW.
C			Version 2U, D. H. G., April 18, 1998
C			Put in call to IERRNO and changed file type
C			to UNKNOWN.
C			Version 2UU, D. H. G., October 14, 2001
C			Further Unix changes (eliminated .SVE).  Since
C			the extension must always be used under Unix,
C			any name with any extension is now possible.
C			Version 3, D. H. G., October 17, 2001
C			Changed formatting of output to save file
C			so that small numbers of parameters are arranged
C			horizontally on one line as before, but large numbers of
C			parameters are output on successive lines.  This allows
C			for arbitrarily large numbers of parameters for one
C			keyword.  Increased length of FLN, A, and B.
C			Version 4, D. H. G., September 20, 2002
C			Increased size of B to 2048 to cover variables of
C			large dimension.
C			Version 4UM, D. H. G., January 31, 2005
C			Changed DISPOSE to STATUS in CLOSE statement, and 
C			modified FORMAT 1001 to allow Absoft compiler to 
C			function on Mac OS.
C			Version 5, D. H. G., February 5, 2008
C			Further increased the size of B to 4096
C
	CHARACTER NAME*(*),FLN*132,A*132,B*4096
	COMMON/BKEY/B
	PARAMETER (LU=49) !  Logical unit for save file
C
	FLN=NAME
	OPEN(UNIT=LU,NAME=FLN,TYPE='UNKNOWN')
	RETURN
C
C
	ENTRY SAVEP(NAME,NL)
C
C       This subroutine writes the keyword NAME and the associated
C  parameters in the COMMON block BKEY, into the save file.
C  Called by USRINP.  The buffer B should be long enough to hold
C  all the values of a multidimensional variable associated with
C  any keyword.  Therefore it should be dimensioned as 2048 in some
C  subroutine, or preferably all subroutines, referencing the COMMON
C  block BKEY.
C
	IF (NL.GE.1) THEN !  Parameter was entered manually
	  IF (NL.LT.50) THEN !  Horizontally spaced
	    WRITE(LU,1000) NAME,B(1:NL)
1000	    FORMAT(1X,A,A)
	  ELSE !  Vertically spaced
	    WRITE(LU,1500) NAME
1500	    FORMAT(' ',A)
	    I=1
C  Find the beginning (the first non-blank character)
	    DO WHILE (I.LE.NL)
	      IF (B(I:I).EQ.' ') THEN
	        I=I+1
	      ELSE
C  Find the next blank
	        N1=I
	        N2=INDEX(B(N1:NL),' ')
C  Convert from relative to absolute
	        N2=N2+N1-1
	        IF (N2.GE.N1.AND.N2.LE.NL) THEN
	          WRITE(LU,1500) B(N1:N2-1)
	          I=N2+1
	        ELSE
	          WRITE(LU,1500) B(N1:NL)
	          I=NL+1 !  Ends the loop
	        END IF
	      END IF
	    END DO
	  END IF
	ELSE !  Default parameters
	  WRITE(LU,1500) NAME
	END IF
	RETURN
C
	ENTRY SAVEC(NAME)
C
C       This subroutine closes a save file.
C
	IF (NAME.EQ.'DELETE') CLOSE(UNIT=LU,STATUS='DELETE')
	IF (NAME.NE.'DELETE') CLOSE(UNIT=LU,STATUS='KEEP')
	RETURN
C
	ENTRY RESTR(NAME)
C
C       This subroutine appends the parameters from the save file
C  NAME to any optional parameters already in buffer B in
C  STRKEY when called by MIIPSOPT or any other application using
C  the .OPTION method.  Here buffer A only need be as long as the
C  longest keyword or the longest parameter associated with a
C  single dimension of a keyword, approximately 132 characters.
	FLN=NAME
	OPEN(UNIT=LU,NAME=FLN,ERR=20,TYPE='OLD')
	GO TO 21
   20	IERR=IERRNO()
	IF (IERR.EQ.2) THEN
	  CALL ERROR(-2,'CANT FIND THE SAVE FILE')
	  RETURN
	ELSE
	  CALL ERROR(-3,'OPEN ERROR FOR SAVE FILE')
	  RETURN
	END IF
   21	REWIND LU
   22	READ(LU,1001,END=23) NN,A
C1001	FORMAT(1X,Q,A<NN>)
1001	FORMAT(1X,Q,A) !  D.H.G
	CALL ADDKEY(A(:NN))
	GO TO 22
   23	CONTINUE
	CLOSE(UNIT=LU)
	RETURN
	END

	SUBROUTINE SAOFIRST
C
C  Note:  This is the UNIX version
C
C       This subroutine initializes SAOimage by setting up the world coordinate
C  system (WCS) and erasing the screen.  The Imtool protocol is used.
C			Donald H. Gudehus, August, 1993
C			Version 1U, D. Gudehus, September, 1994
C			Changed code to work under UNIX
C			Version 2, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
	INCLUDE 'saofacts.for'
C
	IBUFFER_SAO(1)=256 !  imhead.tid,  no name
	IBUFFER_SAO(2)=-3 !  imhead.thingct = 3 words
	IBUFFER_SAO(3)=12 !  imhead.subunit = LOOK_FEEL
	IBUFFER_SAO(4)=0 !  imhead.checksum;  initially set to zero
	IBUFFER_SAO(5)=IOR(0,'100000'O)  ! imhead.x
	IBUFFER_SAO(6)=0 !  imhead.y
	IBUFFER_SAO(7)=0 !  imhead.z
	IBUFFER_SAO(8)=3 !  imhead.t = IOP_MIIPS;  used for control.look_and_feel
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	IBUFFER_SAO(1)=0
	IBUFFER_SAO(2)=0
	IBUFFER_SAO(3)=0
	NBYTES=6
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	IBUFFER_SAO(1)='40000'O !  PACKED and IMC_SAMPLE
	IBUFFER_SAO(2)=-51
	IBUFFER_SAO(3)=17 !  imhead.subunit = WCS (World coordinate system)
	IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0
	IBUFFER_SAO(6)=0
	IBUFFER_SAO(7)=1 !  Frame number (SAOimage system);  not useful on SAOimage
	IBUFFER_SAO(8)=IFB_SAO-1 !  Frame buffer configuration - 1
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	CBUFFER_SAO(1:9)='         '
	BUFFER_SAO(10)=10
	CBUFFER_SAO(11:30)='1. 0. 0. -1.    1.5 ' !  xx yx xy yy xo
C  CBUFFER_SAO(24:30) is X Coordinate at left edge of buffer
	ENCODE (7,1000,CBUFFER_SAO(31:37)) MAXFB_ROWS_SAO+0.5 !  yo;  0.5 added to
                                !  conform with corner of pixel being x.0, y.0.
1000	FORMAT(F7.1)
C  CBUFFER_SAO(31:37) is Y Coordinate at top edge of buffer
	CBUFFER_SAO(38:49)='   1. 200. 1' !  low high w_type (=linear)
	BUFFER_SAO(50)=10
	BUFFER_SAO(51)=0
	NBYTES=51
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
C  Establish some initial values useful in SAOERAS
	NFRAME_SAO=0 !  MIIPS system
	NPIC_SAO=1
	CALL SAOERAS
	RETURN
	END

	SUBROUTINE SAO_ERASE_CURSOR(MODE)
C
C       This subroutine erases the SAOimage cursors, including annuli, 
C  and region cursors, depending on the mode.
C				Donald H. Gudehus, August, 1993
C			Version 2, D. Gudehus, October, 1994
C			Changed call to SAO_DRAW
C
C	MODE	(C)	The mode of action.  If MODE=0, only the cursors
C			are erased.  If MODE=1, the region cursors are
C			erased as well.
C
	INTEGER ACTION,CURSOR_TYPE,COLOR_TYPE
	REAL INCLINA,EXTRA(1)
C
C  Give some sensible values
	CURSOR_TYPE=256 !  Dot
	COLOR_TYPE=201 !  Green
	X=1.0 !  Lower left corner
	Y=1.0
	a=1.0
	b=1.0
	INCLINA=0.0
	IF (MODE.EQ.0) ACTION=0 !  Erases cursors
	IF (MODE.EQ.1) ACTION=10 !  Erases regions and cursors
	EXTRA(1)=0.0
	CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,a,b,INCLINA,
	1EXTRA,0)
	RETURN
	END

	SUBROUTINE ALPHA(A,N,LENGTH,NCHAR,NFULL,NREST,NPOS)
C
C       This subroutine handles alphanumeric information.
C
C		Version 2, Donald H. Gudehus, August, 1988
C		Added possibility 4
C		Version 3, Donald H. Gudehus, June, 1995
C		Added possibility 5
C		Version 4, Donald H. Gudehus, September 17, 2004
C		Added Control K ('0B'X) to the list of characters to be
C		filtered.
C		Version 5, Donald H. Gudehus, February 15, 2005
C		Added Control B ('02'X) and Control L ('0C'X) to the list
C		of characters to be filtered.
C
C		A	(C)	is the input array
C		N 	(C)	is the dimension of A
C		LENGTH	(C)	is the length of the words (in bytes)
C		NCHAR	(R)	is the number of actual characters
C		NFULL	(R)	is the number of full words
C		NREST	(R)	is the number of remaining characters
C		NPOS    (C)	is the possibilty selector.
C				If NPOS=1 the number of characters in all
C				words are counted, excluding those blanks 
C				at the end of the string.  NCHAR is always 
C				>= 1
C				If NPOS=2 the remaining 0's are set to
C				blanks.
C				If NPOS=3, the number of characters in all 
C				words exclusive of control characters and 
C				blanks at the end of the string are counted.
C				If NPOS=4 the remaining 0's and ,'s are set
C				to blanks and each word is placed in its
C				correct position.  If there are only blanks,
C				NFULL and NCHAR are set to zero.
C				A Tab is read as a Tab on Linux but as
C				eight blanks (ASCII 32) on the Mac OS.
C				If NPOS=5 the words are checked for the 
C				presence of decimal points.  If a decimal
C				point is not found, one is inserted in each
C				required word.  This is useful if USRINP
C				is accepting character input which is to
C				be decoded into F format numbers.  Any 
C				zeros are changed to blanks.

C
	BYTE A(1)
	LOGICAL DECIMAL_POINT,WORD
C
	NL=N*LENGTH
	IF (NPOS.EQ.1) THEN
	  NCHAR=1 !  The shortest possible string is 1 byte long
	  DO I=NL,1,-1
	    X=A(I)
	    IF (X.NE.0.0.AND.X.NE.32.0) THEN
	      NCHAR=I
	      GO TO 100
	    END IF
	  END DO
 100	  CONTINUE
	  NFULL=NCHAR/LENGTH !  Only valid if text contains no spaces
	  NREST=NFULL*LENGTH-NCHAR
C
	ELSE IF (NPOS.EQ.2) THEN
C
	  DO I=1,NL
	    IF (A(I).EQ.0) A(I)=32
	  END DO
C
	ELSE IF (NPOS.EQ.3) THEN
C
	  NCHAR=1 !  The shortest possible string is 1 byte long
	  DO I=NL,1,-1
	    X=A(I)
	    IF (X.NE.0.0.AND.X.NE.32.0) THEN
	      NCHAR=I
	      GO TO 200
	    END IF
	  END DO
 200	  CONTINUE
C  Do not count control characters '02'X, '08'X, '09'X, '0A'X, '0B'X, or
C  '0C'X which are used for alphabet selection, backspacing, and sub- and
C  and sub- and superscripting in the plotting package.
	  NDUMMY=NCHAR
	  DO I=1,NDUMMY
	    IF (A(I).EQ.'02'X.OR.A(I).EQ.'08'X.OR.A(I).EQ.'09'X.OR.
	1   A(I).EQ.'0A'X.OR.A(I).EQ.'0B'X.OR.A(I).EQ.'0C'X) NCHAR=NCHAR-1
	  END DO
	  NFULL=NCHAR/LENGTH !  Only valid if text contains no spaces
	  NREST=NFULL*LENGTH-NCHAR
C
	ELSE IF (NPOS.EQ.4) THEN
C
	  DO I=1,NL
C	    IF (A(I).EQ.0.OR.A(I).EQ.44) A(I)=32
	    IF (A(I).EQ.0.OR.A(I).EQ.9) A(I)=32 !  Zero or Tab
	  END DO
C  If there are only blanks, set NFULL=0 and return;  the code below will
C  go into an infinite loop if there are only blanks.
	  NCHAR=0
	  DO I=NL,1,-1
	    X=A(I)
	    IF (X.NE.32.0) THEN
	      NCHAR=I
	      GO TO 300
	    END IF
	  END DO
 300	  IF (NCHAR.EQ.0) THEN !  All blanks
	    NFULL=0
	    RETURN
	  END IF
C  Ensure that there are no blanks at the beginning of the string
	  II=0 !  Number of blanks at the beginning of the string
	  DO WHILE (A(1).EQ.32)
	    II=II+1
	    DO I=1,NL-1
	      A(I)=A(I+1)
	    END DO
	    A(NL-II+1)=32 !  Writes a blank to the correct location at the
			  !  current end of the array.
	  END DO
	  NCHAR=NCHAR-II
C  Find the next nonblank character following a blank one and shift the
C  string so as to put things in the position of the next word.
	  IC=2 !  The character pointer
	  IW=2 !  The word pointer
	  DO WHILE (IC.LT.NL)
	    ISHIFT=0 !  A positive shift is to the right
	    IF (A(IC).NE.32.AND.A(IC-1).EQ.32) THEN	      
	      ISHIFT=(IW-1)*LENGTH+1-IC
	      IF (ISHIFT.GT.0) THEN !  Must shift to the right
	        DO I=NL,(IW-1)*LENGTH+1,-1
	          A(I)=A(I-ISHIFT)
	        END DO
C  Clean up
	        DO I=(IW-1)*LENGTH,IC,-1
	          A(I)=32
	        END DO
	      ELSE IF (ISHIFT.LT.0) THEN !  Must shift to the left
	        DO I=(IW-1)*LENGTH+1,NL+ISHIFT
	          A(I)=A(I-ISHIFT)	      
	        END DO
	      END IF
	      IW=IW+1
	    END IF
	    IC=IC+1+ISHIFT
	  END DO
	  NFULL=IW-1
C
	ELSE IF (NPOS.EQ.5) THEN
C
C  Find the beginning of the first word
	  I=1
	  DO WHILE((A(I).EQ.0.OR.A(I).EQ.32).AND.I.LE.NL)
	    I=I+1
	  END DO
C  Read through the word untill the next blank or zero, checking to see
C  if a decimal point is present
	  DO WHILE(I.LE.NL)
	    DECIMAL_POINT=.FALSE.
	    WORD=.FALSE.
	    DO WHILE(A(I).NE.0.AND.A(I).NE.32.AND.I.LE.NL)
	      WORD=.TRUE.
	      IF (A(I).EQ.46) DECIMAL_POINT=.TRUE.
	      I=I+1
	    END DO
C  If no decimal point was found in a word, add one by inserting and shifting
	    IF (.NOT.DECIMAL_POINT.AND.WORD) THEN
	      A(I)=46
	      DO II=NL,I+2,-1
	        A(II)=A(II-1)
	      END DO
	      IF (I+1.LE.NL) A(I+1)=32
	    END IF
	    I=I+1
	  END DO
C  Change the zeros to blanks
	  DO I=1,NL
	    IF (A(I).EQ.0) A(I)=32
	  END DO
	END IF
	RETURN
	END

	SUBROUTINE SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,
	1NPIC_SELECTED,a,b,INCLINA,EXTRA,NEXTRA)
C
C  Note:  This is the UNIX version
C
C       This subroutine sends commands to SAOimage via the Imtool protocol
C  in order to carry out various drawing tasks.  One can color, size, and
C  position various types of erasable cursors (circle, rectangle, etc.) and
C  various types of nonerasable cursors.  The erasable cursors are useful
C  for marking an area for possible editing or measuring action, and the
C  nonerasble ones are useful for marking the area after an editing action
C  has taken place.  When the image is reloaded, the nonerasble cursors will
C  be erased, of course.  Rotation and annuli are not yet implemented for the 
C  nonerasable cursors.
C
C				Donald H. Gudehus, August, 1993
C				Version 2, D. Gudehus, September 18, 1994
C				Changed some variable names and added case
C				of ACTION=3
C				Version 2U, D. Gudehus, September, 1994
C				Modified code for UNIX
C				Version 3, D. Gudehus, October 1, 1994
C				Allowed for an arbitrary number of annuli
C				rather than just 2 extra.
C				Version 4, D. Gudehus, July 25, 2006
C				Incorporated new saofacts.for
C
C	ACTION		(C)	The proposed action:
C				0  = erases an erasable cursor
C				1  = draws an erasable cursor
C				2  = draws a nonerasable cursor
C				3  = draws a nonerasable straight line with
C				     immediate display.  The preferred
C				     routine for drawing nonerasable straight 
C				     lines, however, is SAO_VECT.
C				4  = draws a nonerasable straight line with
C			 	     delayed display.  You should call 
C				     SAO_DISPLAY_VECT to see it in the frame 
C				     buffer or call this subroutine with 
C				     ACTION=3 and a Y range large enough to 
C				     include the vector.
C				5  = reserved for SAO_DISPLAY_VECT
C				10 = erases an erasable region cursor
C				11 = draws an erasable region cursor
C	CURSOR_TYPE	(C)	The type of cursor:
C				256  = dot cursor (100 hexidecimal)
C				       (only erasable).  For a nonerasable
C				       dot, call SAODOT.
C				768  = rectangle cursor (300 hexidecimal)
C				1024 = circle (or ellipse) cursor 
C				       (400 hexidecimal)
C				1536 = Arrow cursor (600 hexidecimal)
C				       (only erasable)
C	COLOR_TYPE	(C)	The color of the cursor:
C				201 = green
C				202 = black
C				203 = white
C				204 = red
C				206 = blue
C				207 = yellow
C				For the nonerasable cursors additional colors
C				in the range 0 to 199 are available depending
C				on the current color lookup table.
C	X		(C)	The central x location of the object in map 
C				coordinates.  It is up to the calling routine
C				to ensure that the fractional part of X is 0.5
C				in the case where the side of a rectangle 
C				is an odd number of pixels and 0.0 for an 
C				even number.  If a circle is to be centered
C				on a pixel, the fractional part should be 0.5.
C	Y		(C)	Same as X but in the vertical direction
C	NPIC_SELECTED	(C)	The picture (which of several possible in 
C				frame buffer).  This determines which 
C				picture's coordinate system will apply to 
C				X and Y.
C	a		(C)	One half the horizontal cursor length measured
C				from pixel center to pixel center.  It is up 
C				to the calling routine to ensure that the 
C				fractional part is 0.0 for an odd number of 
C				pixels for the total cursor length and 0.5 
C				for an even number.  In the case of drawing 
C				a single straight line (ACTION = 3 or 4), a 
C				is to be interpreted as the second X position.
C	b		(C)	Same as a, but in the vertical direction.
C				When a and b are unequal for the circle, an 
C				ellipse is drawn.  In the case of drawing
C				a single straight line, b is interpreted as
C				the second Y position.
C	INCLINA		(C)	The inclination of the long axis of the cursor.
C				Note this is not yet implemented for 
C				nonerasable cursors.
C	EXTRA		(C)	An array containing additional dimensions
C				or positions for the cursor.  This is useful
C				for creating annuli or polygons.  In the case
C				of annuli, each quantity gives the long half
C				axis length of each additional annulus.  In 
C				the case of polygons, the x and y coordinates
C				of the additional vertexes are given in this 
C				array.  Note:  polygons are not yet 
C				implemented.  Polygons can however be drawn
C				by successive calls to SAO_VECT.
C	NEXTRA		(C)	The number of additional dimensions.  For
C				a single circle or rectangle, its value would
C				be 0.
C
	INTEGER ACTION,CURSOR_TYPE,COLOR_TYPE
	REAL INCLINA,EXTRA(NEXTRA+1)
C
	INCLUDE 'saofacts.for'
C
	INTEGER*2 ICOUNT
	INTEGER CURSOR_TYPE2
	LOGICAL ANNULUS
C
	IF (NEXTRA.GT.0) THEN
	  ANNULUS=.TRUE.
	  ICOUNT=67+NEXTRA*10
	ELSE
	  ANNULUS=.FALSE.
	  ICOUNT=67
	END IF
	IF (ACTION.EQ.1.AND.CURSOR_TYPE.EQ.1024.AND.a.NE.b) THEN
	  CURSOR_TYPE2=1280 !  Ellipse
	ELSE
	  CURSOR_TYPE2=CURSOR_TYPE !  Nonerasable cursors can draw
				   !  ellipses with CURSOR_TYPE=1024
	END IF
	IBUFFER_SAO(1)='40000'O !  = PACKED;  since is not IIS_READ, is write
	IBUFFER_SAO(2)=-ICOUNT !  imhead.thingct
	IBUFFER_SAO(3)=13 !  = imhead.subunit
        IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0
        IBUFFER_SAO(6)=0
        IBUFFER_SAO(7)=1 !  Frame number
        IBUFFER_SAO(8)=0
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
C  NPIC_SAO is the most recent picture number loaded.
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	XSAO=X-IMSX_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSX_SAO(NFRAME_SAO,NPIC_SAO)+XLOC_SAO(NPIC_SELECTED)
	2-XLOC_SAO(NPIC_SAO)
	YSAO=Y-IMSY_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSY_SAO(NFRAME_SAO,NPIC_SAO)-YLOC_SAO(NPIC_SELECTED)
	2+YLOC_SAO(NPIC_SAO)
        ENCODE (2,2002,CBUFFER_SAO(1:2)) ACTION
2002	FORMAT(I2)
	CBUFFER_SAO(3:3)=' '
        ENCODE (4,2004,CBUFFER_SAO(4:7)) CURSOR_TYPE2
2004	FORMAT(I4)
	CBUFFER_SAO(8:8)=' '
        ENCODE (8,2008,CBUFFER_SAO(9:16)) COLOR_TYPE
2008	FORMAT(I8)
	CBUFFER_SAO(17:17)=' '
	ENCODE (9,1009,CBUFFER_SAO(18:26)) XSAO
1009	FORMAT(F9.3)
	CBUFFER_SAO(27:27)=' '
	ENCODE (9,1009,CBUFFER_SAO(28:36)) YSAO
	CBUFFER_SAO(37:37)=' '
	ENCODE (9,1009,CBUFFER_SAO(38:46)) a
	CBUFFER_SAO(47:47)=' '
	ENCODE (9,1009,CBUFFER_SAO(48:56)) b
	CBUFFER_SAO(57:57)=' '
	ENCODE (9,1009,CBUFFER_SAO(58:66)) INCLINA
	CBUFFER_SAO(67:67)=' '
	IF (ANNULUS) THEN
	  DO I=0,NEXTRA-1
	    ENCODE (9,1009,CBUFFER_SAO(68+I*10:76+I*10)) EXTRA(I+1)
	    CBUFFER_SAO(77+I*10:77+I*10)=' '
	  END DO
	END IF
	NBYTES=ICOUNT
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	RETURN
	END

	PROGRAM SAODEMO10
C
C  Note:  This is the Unix version
C
C       This program demonstrates opening a FITS file and displaying
C  it on "Enhanced" SAOimage.  File formats of BYTE, INTEGER*2, INTEGER*4,
C  REAL*4, REAL*8, COMPLEX*8 (real and imaginary parts are each REAL*4)
C  and COMPLEX*16 (real and imaginary parts are each REAL*8) are 
C  supported.  The entire image is automatically scaled so as to
C  fit within the frame.
C		Donald H. Gudehus, March 18, 2000
C		Version 2, D. H. Gudehus, June 1, 2005
C		Added support for 64-bit floating point FITS
C		Version 3, D. Gudehus, July, 2006
C		Rewrote it to make use of FITS Library routines
C
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 COMMAND
	CHARACTER*68 CHFITSMHV
	CHARACTER*80 FITS_FILENAME
C
	CHARACTER*3 DATFMT
	CHARACTER*38 MESS
	INTEGER BLUE(0:199),GREEN(0:199),RED(0:199)
	INTEGER ADDRESS
C
	CALL GET_ENDIAN
        IBLKLEN=2880
	LU=11
	CALL USRINP(%REF(FITS_FILENAME),1,'A',80,0,'INPUT_FILENAME=',
	1'Open the FITS file (include extension)') 
	CALL ALPHA(%REF(FITS_FILENAME),1,80,NC,NF,NR,2)
	OPEN(LU,STATUS='OLD',ACCESS='DIRECT',RECL=2880,
	1FORM='UNFORMATTED',FILE=FITS_FILENAME)
C
	CALL GET_FITS_INFO(LU)
C  Check for a valid file
	DO M=1,NUMMAPS(LU)
	  IF (NAXIS(M,LU).NE.2.AND.NAXIS(M,LU).NE.3) THEN
	    CALL ERROR(-4,'Sorry, NAXIS must be 2 or 3')
	  END IF
	END DO
C  Obtain the map number from the user.
	IMNUM=1
	IF (NUMMAPS(LU).EQ.1) THEN
	  CALL MESSAGE('There is one map in the file')
	ELSE IF (NUMMAPS(LU).GT.1) THEN
	  ENCODE(37,1215,MESS) NUMMAPS(LU)
1215	  FORMAT('There are'I4,' maps in the file'7X)
	  CALL MESSAGE(MESS)
	  CALL USRINP(IMNUM,1,'I',4,1,'MAP=',
	1 'Enter the map number:  (default = 1)')
	END IF
	NMAPS=NUMMAPS(LU)
C
	NPLNS=NAXIS3(IMNUM,LU)
	NROWS=NAXIS2(IMNUM,LU)
	NCOLS=NAXIS1(IMNUM,LU)
	DATFMT=CHFITSMHV(LU,IMNUM,'BITPIX','?')
	IF (DATFMT.EQ.'?') THEN
	  CALL ERROR(-3,'Error getting data format')
	  STOP
	END IF
	CALL MESSAGE('Reading from the file')
	ENCODE(38,1250,MESS) NROWS,NCOLS,DATFMT(1:3)
1250	FORMAT(I4,' rows of 'I4,' pixels in 'A3,' format')
	CALL MESSAGE(MESS)
	IF (NPLNS.EQ.1) THEN
	  WRITE (6,1254) NPLNS
1254	  FORMAT(' ','There is ',I1,' plane in this map')
	  WRITE (7,1254) NPLNS
	  IPNUM=1
	ELSE IF (NPLNS.GT.1) THEN
	  WRITE (6,1255) NPLNS
1255	  FORMAT(' ','There are ',I4,' planes in this map')
	  WRITE (7,1255) NPLNS
	  IPNUM=1
	  IF (NPLNS.EQ.2) THEN
	    CALL USRINP(IPNUM,1,'I',4,1,'PLANE=',
	1   'Enter the plane number (real = 1, imaginary =2):  (default = 1)')
	  ELSE
	    CALL USRINP(IPNUM,1,'I',4,1,'PLANE=',
	1   'Enter the plane number:  (default = 1)')
	  END IF
	END IF
C
	WRITE (6,1200) BZERO(IMNUM,LU)
1200	FORMAT(' ','A value of BZERO = ',E,' will be used')
	WRITE (7,1200) BZERO(IMNUM,LU)
	WRITE (6,1300) BSCALE(IMNUM,LU)
1300	FORMAT(' ','A value of BSCALE = ',E,' will be used')
	WRITE (7,1300) BSCALE(IMNUM,LU)
C
	IFB_SAO=0 !  Lets user be prompted for size of buffer in
		  !  Enhanced SAOimage
C  Initialize Enhanced SAOimage
	CALL SAOSTART
	CALL SAOFIRST
C
C  Reduce the size of the loaded image by the smallest integer value
C  that allows it to fit within the chosen frame
	IREDUCTX=(NCOLS-1)/MAXFB_COLS_SAO+1
	IREDUCTY=(NROWS-1)/MAXFB_ROWS_SAO+1
	IREDUCT=MAX(IREDUCTX,IREDUCTY)
	ICOLS=MAX(1,NCOLS/IREDUCT)
	IROWS=MAX(1,NROWS/IREDUCT)
C
	NWORDS=ICOLS*IROWS
	CALL DYNAMIC(ADDRESS,NWORDS,'  R4',.TRUE.)
	CALL FITS_TO_SAO1(%VAL(ADDRESS),NCOLS,NROWS,ICOLS,IROWS,IREDUCT,
	1IMNUM,IPNUM,LU,FITS_FILENAME,DATFMT,
	2BZERO(IMNUM,LU),BSCALE(IMNUM,LU))
	CALL DYNAMIC(ADDRESS,NWORDS,'  R4',.FALSE.)
C
	DO WHILE(.TRUE.)
	  COMMAND='K'
	  CALL MESSAGE('Enter a command:  (default = K)')
	  CALL MESSAGE('   J = Loads a high contrast spectrum lookup table')
	  CALL MESSAGE('   K = Loads a spectrum lookup table including white')
	  CALL MESSAGE('   Q = Quits')
	  CALL MESSAGE('   W = Loads a black and white triangle look-up table')
	  CALL MESSAGE('   X = Loads a black and white sawtooth look-up table')
	  CALL USRINP(%REF(COMMAND),1,'A',1,1,'COMMAND=',' ')
	  IF (COMMAND.EQ.'J'.OR.COMMAND.EQ.'K'.OR.COMMAND.EQ.'W') THEN
	    IF (COMMAND.EQ.'J') IVAL='900'X
	    IF (COMMAND.EQ.'K') IVAL='A00'X
	    IF (COMMAND.EQ.'W') IVAL='B00'X
	    CALL SAOCONVLT(IVAL)
	  ELSE IF (COMMAND.EQ.'Q') THEN
	    STOP
	  ELSE IF (COMMAND.EQ.'X') THEN
	    DO J=1,10
	      DO I=0,19
	        RED(I+20*(J-1))=I*255/19
	        GREEN(I+20*(J-1))=I*255/19
	        BLUE(I+20*(J-1))=I*255/19
	      END DO
	    END DO
	    CALL SAO_LOAD_VLT(BLUE,GREEN,RED)
	  END IF
	END DO
C
	CALL CLOSEFITS(LU)
	END
C
	SUBROUTINE FITS_TO_SAO1(ARRAY,NCOLS,NROWS,ICOLS,IROWS,IREDUCT,
	1IMNUM,IPNUM,LU,FITS_FILENAME,DATFMT,BZERO,BSCALE)
C
C       This subroutine helps display a FITS file on Enhanced
C  SAOimage.  The file is assumed to have been previously opened, the
C  map selected, and the plane selected.
C			Donald H. Gudehus, Aug., 2006
C
C	ARRAY	      (C) An array created by dynamic memory, and used to
C			  hold the data given to SAOLOAD
C	NCOLS	      (C) The number of columns in the file
C	NROWS	      (C) The number of rows in the file
C	ICOLS	      (C) The X dimension of ARRAY
C	IROWS	      (C) The Y dimension of ARRAY
C	IRECT	      (C) An automatically determined integer scaling factor
C			  to allow the image to fit within the frame.
C	IMNUM	      (C) The selected map number
C	IPNUM	      (C) The selected plane number
C	LU	      (C) The logical unit used for reading
C	FITS_FILENAME (C) The FITS filename which will appear on
C			  SAOimage.
C	DATFMT	      (C) The file data format
C	BZERO	      (C) The data zero point from the FITS header
C	BSCALE	      (C) The data scaling factor from the FITS header
C
	CHARACTER*3 DATFMT
	CHARACTER*80 FITS_FILENAME
	REAL*4 ARRAY(ICOLS,IROWS)
	REAL*8 BSCALE,BZERO
C
	INCLUDE 'saofacts.for'
	PARAMETER (MAXSIZE=4096)
	REAL*4 DATA(MAXSIZE),MIN_MAX(2)
	REAL*8 DATADP(MAXSIZE)
C
	IF (DATFMT.EQ.'I1'.OR.DATFMT.EQ.'I2'.OR.DATFMT.EQ.'I4'.OR.
	1 DATFMT.EQ.'R4'.OR.DATFMT.EQ.'C8') THEN
	  JJ=1
	  DO J=1,NROWS,IREDUCT
	    CALL RDFITSROW(LU,IMNUM,IPNUM,DATA,MAXSIZE,J)
	    II=1
	    DO I=1,NCOLS,IREDUCT
	      ARRAY(II,JJ)=DATA(I)
	      II=II+1
	    END DO
	    JJ=JJ+1
	  END DO
	ELSE IF (DATFMT.EQ.'R8'.OR.DATFMT.EQ.'C16') THEN
	  JJ=1
	  DO J=1,NROWS,IREDUCT
	    CALL RDDPFITSROW(LU,IMNUM,IPNUM,DATADP,MAXSIZE,J)
	    II=1
	    DO I=1,NCOLS,IREDUCT
	      ARRAY(II,JJ)=DATADP(I)
	      II=II+1
	    END DO
	    JJ=JJ+1
	  END DO
	END IF
C  Position the image in the center of the frame
 999	IXFRAME=(MAXFB_COLS_SAO-ICOLS)/2
	IYFRAME=(MAXFB_ROWS_SAO+IROWS)/2-1
	BRIGHTNESS_MIN=1.0E38
	BRIGHTNESS_MAX=-1.0E38
	DO J=1,IROWS
	  DO I=1,ICOLS
	    IF (ARRAY(I,J).LT.BRIGHTNESS_MIN) BRIGHTNESS_MIN=ARRAY(I,J)
	    IF (ARRAY(I,J).GT.BRIGHTNESS_MAX) BRIGHTNESS_MAX=ARRAY(I,J)
	  END DO
	END DO
	MIN_MAX(1)=BRIGHTNESS_MIN
	MIN_MAX(2)=BRIGHTNESS_MAX
	CALL USRINP(MIN_MAX,2,'F',4,1,'MINIMUM_MAXIMUM=','Enter the '//
	1'minimum and maximum for the display (default = values in file)')
	BRIGHTNESS_MIN=MIN_MAX(1)
	BRIGHTNESS_MAX=MIN_MAX(2)
	NPICTURE=1
C  Load SAOimage in `fast mode'
	MODE=0
	CALL SAOLOAD(ARRAY,ICOLS,IROWS,IXFRAME,IYFRAME,
	1BRIGHTNESS_MIN,BRIGHTNESS_MAX,FITS_FILENAME,NPICTURE,MODE)
C
	END

	SUBROUTINE GET_ENDIAN
C
C       This subroutine determins the endian of the curent system.
C  If the endian needs to be known in a program, this subroutine should be
C  called at the start.  Then any routines which need to know the endian
C  should incorporate the common block SYS_ENDIAN and check the variable
C  SYSTEM_ENDIAN.
C				Donald H. Gudehus, August 22, 2006
C
	BYTE PHYSREC(8)
	INTEGER*2 I2REC(4)
	INTEGER*4 I4REC(2)
	EQUIVALENCE (PHYSREC,I2REC,I4REC)

	CHARACTER*1 SYSTEM_ENDIAN
	COMMON /SYS_ENDIAN/ SYSTEM_ENDIAN
C
	DATA PHYSREC /1,2,4,8,16,32,64,128/
	DATA SYSTEM_ENDIAN /' '/
C
	IF (I2REC(1).EQ.513.AND.I2REC(2).EQ.2052.AND.I2REC(3).EQ.8208
	1.AND.I2REC(4).EQ.-32704) THEN
	  SYSTEM_ENDIAN='L'
	ELSE IF (I2REC(1).EQ.258.AND.I2REC(2).EQ.1032.AND.I2REC(3).EQ.4128
	1.AND.I2REC(4).EQ.16512) THEN
	  SYSTEM_ENDIAN='B'
	ELSE
	  SYSTEM_ENDIAN='U'
	  CALL ERROR(-3,'Unknown system endian;  call GET_ENDIAN')
	END IF
C
	RETURN
	END

	PROGRAM SAODEMO7
C
C  Note:  This is the UNIX version.
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we download a custom look-up table
C  and then send random rectangular areas which have colors corresponding
C  to increasing indexes in the look-up table.  There are two possible 
C  approaches to sending multiple areas.  We could repeatedly load an 
C  array with sub areas and then repeatedly load the entire array into
C  SAOimage.  This can be quite fast for a small frame buffer, e.g., the
C  simulated video in SAODEMO3, but becomes slow when the frame buffer is
C  large.  Another approach is to repeatedly load small areas into 
C  SAOimage with MODE=1 in SAOLOAD.  This is always slow but doesn't slow
C  down when large frame buffers are used.  This is the approach taken here,
C  but we have to in addition use dynamic memory since we are changing the
C  size of the area on each load.
C
C			Donald H. Gudehus, October 29, 1994
C			Version 1U, D. Gudehus, October 30, 1994
C			Modified code to work under UNIX
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN
C
	INCLUDE 'saofacts.for'
C
	PARAMETER NCOLS=256,NROWS=256,NIMAGES=200
C
	CHARACTER*40 ARRAY_NAME
	INTEGER*4 BLUE(200),GREEN(200),RED(200),ADDRESS
C
	CALL GET_ENDIAN
C  Don't prompt the user for the size of the buffer, just use a big
C  enough one.
	IFB_SAO=12 !  Gives a 256 by 256 buffer
	CALL SAOSTART
	CALL SAOFIRST
C
C  Create a custom look-up table
	ISEED=12345
	DO I=1,200
	  RED(I)=RAN(ISEED)*255
	  GREEN(I)=RAN(ISEED)*255
	  BLUE(I)=RAN(ISEED)*255
	END DO
C  Make the lowest location black
	RED(1)=0
	GREEN(1)=0
	BLUE(1)=0
C  Now load it into SAOimage
	CALL SAO_LOAD_VLT(BLUE,GREEN,RED)
C
	BRIGHTNESS_MIN=0.0
	BRIGHTNESS_MAX=199.0
	ARRAY_NAME='Look-up Table Demonstration'
	CALL MESSAGE('We will load 1 patch for each color in the look-up'//
	1' table, i.e., 200')
	DO K=1,NIMAGES
C  Calculate where the images will be placed in the frame.  The 
C  coordinates below are the where the lower left of each image will be 
C  placed in the frame buffer.  The frame has (0,0) in the upper left;  
C  any image has (1,1) in the lower left.
	  IX=(NCOLS-1)*RAN(ISEED)
	  IY=(NROWS-1)*RAN(ISEED)
	  IWX=MIN(1.0*NCOLS-IX,MAX(1.0,20*RAN(ISEED)))
	  IWY=MIN(IY+1.0,MAX(1.0,20*RAN(ISEED)))
	  CALL DYNAMIC(ADDRESS,IWX*IWY,'  R4',.TRUE.)
	  CALL SAODEMO7_1(%VAL(ADDRESS),IWX,IWY,IX,IY,BRIGHTNESS_MIN,
	1 BRIGHTNESS_MAX,ARRAY_NAME,K)
	  CALL DYNAMIC(ADDRESS,IWX*IWY,'  R4',.FALSE.)
	END DO
	END
C
	SUBROUTINE SAODEMO7_1(ARRAY,IWX,IWY,IX,IY,BRIGHTNESS_MIN,
	1BRIGHTNESS_MAX,ARRAY_NAME,K)
C
	DIMENSION ARRAY(IWX,IWY)
	CHARACTER*40 ARRAY_NAME
C
	DO J=1,IWY
	  DO I=1,IWX
	    ARRAY(I,J)=K-1 !  Assumes that K does not go beyond allowable
			   !  range
	  END DO
	END DO
C  NPICTURE is set to 1.  We sacrifice easy cursor readback of 
C  coordinates with this approach however.
C  MODE is set to 1 to allow loading several pictures into frame
	CALL SAOLOAD(ARRAY,IWX,IWY,IX,IY,
	1BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,1,1)
	RETURN
C
	END

      SUBROUTINE IBMI2(INPUT,OUTPUT,N)
C
C *** ROUTINE CONVERTS INTEGER*2 FROM IBM TO VAX FORMAT
C *** IRT : JUNE 12,1979
C
      INTEGER*2 INPUT(N),OUTPUT(N),WORD
      LOGICAL*1 BYTE(2),TEMP
      EQUIVALENCE (BYTE,WORD)
C
      DO 10 I =1,N
      WORD=INPUT(I)
C *** INTERCHANGE BYTES
      TEMP=BYTE(1)
      BYTE(1)=BYTE(2)
      BYTE(2)=TEMP
C *** SET OUTPUT VALUE
      OUTPUT(I)=WORD
10    CONTINUE
      RETURN
      END

	SUBROUTINE GET_FITS_INFO(LU)
C
C       This subroutine helps OPENFITS by reading through an opened file
C  to obtain the essential information about the file, and enters that
C  information into the FITSFACTS common blocks.  Currently, we allow a
C  maximum of 256 maps in a file.  The information for a particular map
C  is referenced by an index equal to the map number.  If more than one
C  map exists, then there will also be a primary header which can be
C  referenced with an index equal to 0.

C
C			Donald H. Gudehus, June 27, 2005
C
	INCLUDE 'fitsfacts.for'
C
	BYTE PHYSREC(3000)
	CHARACTER*3000 CHARPHYSREC
	EQUIVALENCE (PHYSREC,CHARPHYSREC)
	CHARACTER*1 C1_TEMP
	CHARACTER*80 KEYCARD
	LOGICAL EXTENSION_HEADER
C
	IBLKLEN=2880
C  Initialize COMMON block variables
	SIMPLE(LU)=.FALSE.
	EXTEND(LU)=0
	NUMRECORDS(LU)=0
	NUMHEADERS(LU)=0
	NUMMAPS(LU)=0
	DO I=0,MAPMAX
	  BITPIX(I,LU)=0
	  NAXIS(I,LU)=0
	  NAXIS1(I,LU)=0
	  NAXIS2(I,LU)=0
	  NAXIS3(I,LU)=1 !  Default in case keyword is not present
	  BZERO(I,LU)=0.0D0 !  Default in case keyword is not present
	  BSCALE(I,LU)=1.0D0 !  Default in case keyword is not present
	  COMPLX(I,LU)=.FALSE.
	  NUMKEYCARDS(I,LU)=0
	END DO
C  Other initializations
	NUMSIMPLE=0
	NUMXTENSION=0
	EXTENSION_HEADER=.FALSE.
	NUMBLANK=0
C  Read the header(s) of the input file in order to get the number of
C  maps and the number of columns, rows, and data type for each map.
	DO WHILE(.TRUE.)
	  KEYCARD(1:80)=' '
	  IBPTR=1
	  READ(LU,REC=NUMRECORDS(LU)+1,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	  IF (ISTAT.NE.0) THEN
	    GO TO 9999
	  ELSE
	    NUMRECORDS(LU)=NUMRECORDS(LU)+1 !  Current valid record number
	  END IF
	  DO WHILE(KEYCARD(1:3).NE.'END'.AND.IBPTR.LE.2801)
	    KEYCARD=CHARPHYSREC(IBPTR:IBPTR+79)
C  Eliminate control characters
	    DO I=1,80
	      IF (ICHAR(KEYCARD(I:I)).LT.32) KEYCARD(I:I)=' '
	    END DO
1000	    FORMAT(' ',A)
	    IF (KEYCARD(1:6).EQ.'SIMPLE') THEN
C  Mandatory keyword for primary header with extension, or header for
C  file with single map.
	      EXTENSION_HEADER=.FALSE.
	      NUMSIMPLE=NUMSIMPLE+1
	      C1_TEMP=KEYCARD(30:30)
	      IF (C1_TEMP.EQ.'T') THEN
	        SIMPLE(LU)=.TRUE.
	      ELSE IF (C1_TEMP.EQ.'F') THEN
	        SIMPLE(LU)=.FALSE.
	      END IF
	      HEADERRECORDS(1,0,LU)=NUMRECORDS(LU)
	    END IF
	    IF (KEYCARD(1:8).EQ.'XTENSION') THEN
	      EXTENSION_HEADER=.TRUE.
	      NUMXTENSION=NUMXTENSION+1
	      HEADERRECORDS(1,NUMXTENSION,LU)=NUMRECORDS(LU)
	    END IF
	    IF (EXTENSION_HEADER) THEN
	      INDEX=NUMXTENSION
	    ELSE
	      INDEX=0
	    END IF
	    IF (KEYCARD(1:6).EQ.'BITPIX') THEN
C  Mandatory keyword for primary and extension headers
	      DECODE (20,1020,KEYCARD(11:30)) BITPIX(INDEX,LU)
1020	      FORMAT(I20)
	      IF (BITPIX(INDEX,LU).EQ.0)
	1     CALL ERROR(-3,'BITPIX not defined')
	    END IF
	    IF (KEYCARD(1:6).EQ.'NAXIS') THEN
C  Mandatory keyword for primary and extension headers
	      DECODE (20,1020,KEYCARD(11:30)) NAXIS(INDEX,LU)
	    END IF
	    IF (KEYCARD(1:6).EQ.'NAXIS1') THEN
C  Mandatory keyword for primary and extension headers
	      DECODE (20,1020,KEYCARD(11:30)) NAXIS1(INDEX,LU)
	    END IF
	    IF (KEYCARD(1:6).EQ.'NAXIS2') THEN
C  Mandatory keyword for primary and extension headers
	      DECODE (20,1020,KEYCARD(11:30)) NAXIS2(INDEX,LU)
	    END IF
	    IF (KEYCARD(1:6).EQ.'NAXIS3') THEN
C  Mandatory keyword for primary and extension headers
	      DECODE (20,1020,KEYCARD(11:30)) NAXIS3(INDEX,LU)
	    END IF
	    IF (KEYCARD(1:6).EQ.'EXTEND') THEN
	      C1_TEMP=KEYCARD(30:30)
	      IF (C1_TEMP.EQ.'T') THEN
	        EXTEND(LU)=1
C  One would think that if the EXTEND keyword is true, a map should follow the
C  primary header.  However, according to the FITS documentation, it may be
C  that EXTEND is true but there are no current extensions, just the single
C  map.
	      ELSE IF (C1_TEMP.EQ.'F') THEN
	        EXTEND(LU)=2
	      END IF
	    END IF
	    IF (KEYCARD(1:5).EQ.'BZERO'.OR.KEYCARD(1:6).EQ.'BSCALE') THEN
	      I=10
	      DO WHILE (KEYCARD(I:I).EQ.' ')
	        I=I+1
	      END DO
	      ISTART=I
	      DO WHILE (KEYCARD(I:I).NE.' '.AND.KEYCARD(I:I).NE.'/')
	        I=I+1
	      END DO
	      IEND=I-1
	      NCHARS=IEND-ISTART+1
	      IF (KEYCARD(1:5).EQ.'BZERO') THEN
	        DECODE (NCHARS,1100,KEYCARD(ISTART:IEND)) BZERO(INDEX,LU)
1100	        FORMAT(E24.14)
	      ELSE IF (KEYCARD(1:6).EQ.'BSCALE') THEN
	        DECODE (NCHARS,1100,KEYCARD(ISTART:IEND))
	1       BSCALE(INDEX,LU)
	      END IF
	    END IF
	    IF (KEYCARD(1:6).EQ.'CTYPE3') THEN
	      IF (KEYCARD(12:18).EQ.'COMPLEX') THEN
	        COMPLX(INDEX,LU)=.TRUE.
	        IF (NAXIS3(INDEX,LU).NE.2) THEN
	          CALL ERROR
	1         (-2,'Inconsistent keyword values for COMPLEX data')
	        END IF
	      END IF
	    END IF
	    IF (KEYCARD.EQ.' ') NUMBLANK=NUMBLANK+1
	    IF (KEYCARD(1:3).EQ.'END') THEN
	      HEADERRECORDS(2,INDEX,LU)=NUMRECORDS(LU)
	      NUMKEYCARDS(INDEX,LU)=(HEADERRECORDS(2,INDEX,LU)-
	1     HEADERRECORDS(1,INDEX,LU))*36+(IBPTR+79)/80
	    END IF
	    IBPTR=IBPTR+80
	  END DO
	END DO
9999	CONTINUE
	IF (NUMXTENSION.NE.0) THEN
	  NUMMAPS(LU)=NUMXTENSION
	ELSE
	  IF (NAXIS(0,LU).EQ.2.OR.NAXIS(0,LU).EQ.3)
	1 NUMMAPS(LU)=NUMSIMPLE
	END IF
	IF (NUMMAPS(LU).EQ.0) THEN
	  CALL ERROR(-2,'The file contained no maps')
	  CALL MESSAGE('Forcing number of maps to be 1')
	  NUMMAPS(LU)=1
	  NAXIS3(0,LU)=0 !  Flag for other routines
	END IF
	NUMHEADERS(LU)=NUMSIMPLE+NUMXTENSION
C  Cover the case of a single header with a single map.  The map
C  can be referenced by using an index equal to 1.
	IF (NUMMAPS(LU).EQ.1) THEN
	  BITPIX(1,LU)=BITPIX(0,LU)
	  NAXIS(1,LU)=NAXIS(0,LU)
	  NAXIS1(1,LU)=NAXIS1(0,LU)
	  NAXIS2(1,LU)=NAXIS2(0,LU)
	  NAXIS3(1,LU)=NAXIS3(0,LU)
	  BZERO(1,LU)=BZERO(0,LU)
	  BSCALE(1,LU)=BSCALE(0,LU)
	  HEADERRECORDS(1,1,LU)=HEADERRECORDS(1,0,LU)
	  HEADERRECORDS(2,1,LU)=HEADERRECORDS(2,0,LU)
	  NUMKEYCARDS(1,LU)=NUMKEYCARDS(0,LU)
	  COMPLX(1,LU)=COMPLX(0,LU)
	END IF
C  Compute the starting and ending records for each map
	DO I=1,NUMMAPS(LU)-1
	  MAPRECORDS(1,I,LU)=HEADERRECORDS(2,I,LU)+1
	  MAPRECORDS(2,I,LU)=HEADERRECORDS(1,1+I,LU)-1
	END DO
	MAPRECORDS(1,NUMMAPS(LU),LU)=HEADERRECORDS(2,NUMMAPS(LU),LU)+1
	MAPRECORDS(2,NUMMAPS(LU),LU)=NUMRECORDS(LU)
C
	RETURN
	END

	FUNCTION DO(II)
C
C       This function provides the do-loop structure in the option list in
C  MIIPSOPT and is used for looping in usrinp.  The control string is 
C  executed until the list of values read by DO is exhausted.  These values 
C  are then made available to the selected option.  
C  E.g., DO($=1,2,3) OPT1(X=$) OPT2(Y=$).
C  	
	PARAMETER (NP=256)
	DIMENSION A(NP),B(NP)
C
	IF (II.EQ.0) THEN  ! FIRST ENTRY
	  CALL USRINP(A,NP,'F',4,0,'$=',
	1 'Enter the values for $ to be used in the do-loop:')
	  N=NEL(A,NP)   
	  DO I=1,N
	    B(I)=A(I)
	  END DO
	  CALL USRINP(B,N,'F',4,4,'&=',
	1 'Enter the values for & to be used in the do-loop:')
	  NBL=NEL(B,N)
	  IF (NBL.NE.N) CALL ERROR(-3,'UNEQUAL RANGE IN DO-LOOP VALUES')
	  I=1
	ELSE
	  I=I+1
	END IF
	IF (I.GT.N) THEN  ! TERMINATES LOOP
	  I=0
	  CALL MESSAGE('Do-loop has terminated')
	ELSE
	  WRITE(7,1000) A(I),B(I)
	  WRITE(6,1000) A(I),B(I)
 1000	  FORMAT(' DO-LOOP:  $=',G11.4,'   &=',G11.4)
	END IF
	II=I
	RETURN
C  RETURN CURRENT VALUE OF VARIABLE
	ENTRY DOVAL
	DOVAL=A(I)
	RETURN
	ENTRY DOVAL2
	DOVAL2=B(I)
	RETURN
	END

	PROGRAM SAODEMO9
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we see the elliptical orbital motion of a
C  binary system.
C
C			Donald H. Gudehus, August, 1999
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
	INCLUDE 'saofacts.for'
C
	PARAMETER NCOLS=128,NROWS=128,NIMAGES=72
	REAL ARRAY(NCOLS,NROWS,NIMAGES)
C
	CHARACTER*40 ARRAY_NAME
	INTEGER*4 X_OFFSET,Y_OFFSET
	REAL*8 SEMIMAJAX,ECCENTR,MEANANOM,TRUEANOM,ECCENTRANOM,RADIUS
C
	CALL GET_ENDIAN
	DELAY_TIME=0.0
	CALL USRINP(DELAY_TIME,1,'F',4,1,'DELAY_TIME=',
	1'Enter an interframe delay time in seconds:  (default = 0)')
C  Don't prompt the user for the size of the buffer, just use a big
C  enough one.
	IFB_SAO=11 !  Gives a 128 by 128 buffer
	CALL SAOSTART
	CALL SAOFIRST
C
C  Preset the lookup table to a convenient range of colors
	IVAL='A00'X
	CALL SAOCONVLT(IVAL)
C
	BRIGHTNESS_MIN=6.0
	BRIGHTNESS_MAX=1000.0
	CALL MESSAGE('Creating the images')
C  Zero the arrays
	DO K=1,NIMAGES
	  DO J=1,NROWS
	    DO I=1,NCOLS
	      ARRAY(I,J,K)=0.0
	    END DO
	  END DO
	END DO
	NC1=NCOLS/2
	NR1=NROWS/2-1
C  Center the images within the frame. 
C  The frame has (0,0) in the upper left;  
C  any image has (1,1) in the lower left.
	IXFRAME=MAXFB_COLS_SAO/2-NC1
	IYFRAME=MAXFB_ROWS_SAO/2+NR1
	ARRAY_NAME='Elliptical motion demonstration'
	MODE=0 !  Allows loading several pictures into frame
C  Create the images
	a=2.0
	SEMIMAJAX=20.0
	NPICTURE=1
	ECCENTR=0.7
	MEANANOM=0.0
	X_OFFSET=-10
	Y_OFFSET=-10
	ANG_OFFSET=45.0
	DO K=1,NIMAGES
	  MEANANOM=K*360.0/NIMAGES
	  CALL KEPLER(MEANANOM,ECCENTR,ECCENTRANOM)
	  TRUEANOM=2.0*DATAND(DSQRT((1.0+ECCENTR)/(1.0-ECCENTR))*DTAND(
	1 ECCENTRANOM/2.0))
	  RADIUS=SEMIMAJAX*(1.0-ECCENTR*DCOSD(ECCENTRANOM))
	  X1=RADIUS*DCOSD(TRUEANOM+ANG_OFFSET)+NC1+X_OFFSET
	  X2=-2.2*RADIUS*DCOSD(TRUEANOM+ANG_OFFSET)+NC1+X_OFFSET
	  Y1=RADIUS*DSIND(TRUEANOM+ANG_OFFSET)+NR1+Y_OFFSET
	  Y2=-2.2*RADIUS*DSIND(TRUEANOM+ANG_OFFSET)+NR1+Y_OFFSET
C  The lower left corner of each data array is considered to have 
C  coordinates 1, 1.
	  DO J=1,NROWS
	    DO I=1,NCOLS
	      R1=SQRT((I-X1)**2+(J-Y1)**2)
	      R2=SQRT((I-X2)**2+(J-Y2)**2)
	      ARRAY(I,J,K)=880.0/(1+R1/a)**2+350.0/(1+R2/a)**2
	    END DO
	  END DO
	END DO
C  Now load the images into SAOimage.
	DO NREPEAT=1,8
	  DO K=1,NIMAGES
	    CALL SAOLOAD(ARRAY(1,1,K),NCOLS,NROWS,IXFRAME,IYFRAME,
	1   BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
	    CALL DELAY(DELAY_TIME)
	  END DO
	END DO
C
	END

C     This file establishes the declarations and COMMON blocks for
C  use with the FITS Library Package.
C
C			Donald H. Gudehus, Summer, 2005
C
	PARAMETER (LUMIN=11,LUMAX=20,MAPMAX=256,NPLANEMAX=999)
C
	CHARACTER*80 FITSFILENAME(LUMIN:LUMAX)
	INTEGER NUMRECORDS(LUMIN:LUMAX) !  Total number of records in a file
	INTEGER NUMHEADERS(LUMIN:LUMAX) !  Total number of headers in a file
	INTEGER NUMKEYCARDS(0:MAPMAX,LUMIN:LUMAX)
					!  Number of keycards in a header
	INTEGER NUMMAPS(LUMIN:LUMAX) !  Total number of maps in a file
	INTEGER HEADERRECORDS(2,0:MAPMAX,LUMIN:LUMAX)
					!  Start and end for each header
	INTEGER MAPRECORDS(2,MAPMAX,LUMIN:LUMAX) !  Start and end for each map,
						 !  excluding the header
	INTEGER BITPIX(0:MAPMAX,LUMIN:LUMAX)
	INTEGER NAXIS(0:MAPMAX,LUMIN:LUMAX),NAXIS1(0:MAPMAX,LUMIN:LUMAX),
	1NAXIS2(0:MAPMAX,LUMIN:LUMAX),NAXIS3(0:MAPMAX,LUMIN:LUMAX)
	INTEGER EXTEND(LUMIN:LUMAX) !  0 if keyword not present, 1 if true,
				    !  2 if false
	LOGICAL SIMPLE(LUMIN:LUMAX),COMPLX(0:MAPMAX,LUMIN:LUMAX)
	LOGICAL QUIET(LUMIN:LUMAX) !  If true, the file is opened with no 
				   !  information displayed on the screen
	REAL*8 BSCALE(0:MAPMAX,LUMIN:LUMAX),BZERO(0:MAPMAX,LUMIN:LUMAX)
	COMMON /FITSFACTS_CHARACTER/ FITSFILENAME
	COMMON /FITSFACTS_INTEGER4/ NUMRECORDS,NUMHEADERS,NUMKEYCARDS,NUMMAPS,
	1HEADERRECORDS,MAPRECORDS,BITPIX,NAXIS,NAXIS1,NAXIS2,NAXIS3,EXTEND
	COMMON /FITSFACTS_LOGICALS/ SIMPLE,COMPLX,QUIET
	COMMON /FITSFACTS_REAL8/ BSCALE,BZERO
C

	SUBROUTINE SAO_VECT(ACTION,COLOR_TYPE,X1,Y1,X2,Y2,NPIC_SELECTED)
C
C  Note:  This is the UNIX version
C
C       This subroutine sends commands to SAOimage via the Imtool protocol
C  in order to draw straight lines (vectors) on the frame buffer.  This
C  subroutine duplicates the action of SAO_DRAW in the case of ACTION=3
C  but does it with less overhead.
C			Donald H. Gudehus, September, 1994
C			Version 1U, D. Gudehus, September, 1994
C			Modified code for UNIX
C			Version 2, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C			Version 3, D. Gudehus, April 14, 2009
C			Declared NPIC_SELECTED as INTEGER*2 for
C			reliability.
C
C	ACTION		(C)	Two values are permitted.  If equal to 3
C				the vector is immediately displayed.  If
C				equal to 4 it is not immediately displayed
C				and must be later followed with a call with
C				ACTION=3 and a Y range large enough to include
C				the vector.  More simply one could call
C				SAO_DISPLAY_VECTOR. This is useful for saving 
C				time when many vectors are being drawn.
C	COLOR_TYPE	(C)	The color of the cursor.  Some examples are:
C				201 = green
C				202 = black
C				203 = white
C				204 = red
C				206 = blue
C				207 = yellow
C				Other values, depending on the lookup table
C				are possible in the range 0 to 199.
C	X1		(C)	The starting x location in array, file,
C				or map coordinates.  The lower left corner
C				of the picture has coordinates (1.0,1.0).
C				The maximum possible value depends on the size
C				of the frame buffer selected.
C	Y1		(C)	The starting y location
C	X2		(C)	The ending x location
C	Y2		(C)	The ending y location
C	NPIC_SELECTED	(C)	The picture (which of several in frame buffer)
C
	INTEGER*2 NPIC_SELECTED
C
	INTEGER ACTION,COLOR_TYPE
C
	INCLUDE 'saofacts.for'
C
	INTEGER*2 ICOUNT
C
	ICOUNT=67
	IBUFFER_SAO(1)='40000'O !  = PACKED;  since is not IIS_READ, is write
	IBUFFER_SAO(2)=-ICOUNT !  imhead.thingct
	IBUFFER_SAO(3)=13 !  = imhead.subunit
        IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0
        IBUFFER_SAO(6)=0
        IBUFFER_SAO(7)=1 !  Frame number
        IBUFFER_SAO(8)=0
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
C  NPIC_SAO is the most recent picture number loaded.
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	XSAO1=X1-IMSX_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSX_SAO(NFRAME_SAO,NPIC_SAO)+XLOC_SAO(NPIC_SELECTED)-
	2XLOC_SAO(NPIC_SAO)
	YSAO1=Y1-IMSY_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSY_SAO(NFRAME_SAO,NPIC_SAO)-YLOC_SAO(NPIC_SELECTED)+
	2YLOC_SAO(NPIC_SAO)
	XSAO2=X2-IMSX_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSX_SAO(NFRAME_SAO,NPIC_SAO)+XLOC_SAO(NPIC_SELECTED)-
	2XLOC_SAO(NPIC_SAO)
	YSAO2=Y2-IMSY_SAO(NFRAME_SAO,NPIC_SELECTED)+
	1IMSY_SAO(NFRAME_SAO,NPIC_SAO)-YLOC_SAO(NPIC_SELECTED)+
	2YLOC_SAO(NPIC_SAO)
	ENCODE (2,2002,CBUFFER_SAO(1:2)) ACTION
2002	FORMAT(I2)
	CBUFFER_SAO(3:3)=' '
	CBUFFER_SAO(4:7)='  0' !  Cursor type
	CBUFFER_SAO(8:8)=' '
	ENCODE (8,2008,CBUFFER_SAO(9:16)) COLOR_TYPE
2008	FORMAT(I8)
	CBUFFER_SAO(17:17)=' '
	ENCODE (9,1009,CBUFFER_SAO(18:26)) XSAO1
1009	FORMAT(F9.3)
	CBUFFER_SAO(27:27)=' '
	ENCODE (9,1009,CBUFFER_SAO(28:36)) YSAO1
	CBUFFER_SAO(37:37)=' '
	ENCODE (9,1009,CBUFFER_SAO(38:46)) XSAO2
	CBUFFER_SAO(47:47)=' '
	ENCODE (9,1009,CBUFFER_SAO(48:56)) YSAO2
	CBUFFER_SAO(57:57)=' '
	CBUFFER_SAO(58:66)='      0.0' !  INCLINA
	CBUFFER_SAO(67:67)=' '
	NBYTES=ICOUNT
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	RETURN
	END

	SUBROUTINE USRINP(A,N,TYPE,LENGTH,IDEF,KEYWORD,MESS)
C
C  Note:  This is the UNIX version.  This must be linked with the UNIX 
C         version of NELD.FOR
C	A		(C)	The variable being input
C	N		(C)	The dimension of A
C	TYPE		(C)	The data type of A:  'F','A','I','L'
C	LENGTH		(C)	The number of bytes of A
C	IDEF		(C)	The key for how to accept the input:
C				0 = no default, 1 = default, 3 = default
C				with no verification
C	KEYWORD		(C)	The keyword
C	MESS		(C)	The message
C
C		Version 1, R. D. Ekers
C		Version 2, W. Zwitser, Jan. 2, 1979
C		Version 3, R. D. Ekers, Jan. 5, 1979
C		Modified for use on the Mt. Stromlo VAX
C		Version 4, Donald H. Gudehus, June, 1993
C		Added the COMMON BLOCK /WRITE_FILES/ which contains the
C		logical DONT_WRITE_FILES.  In MIIPS usage, this logical is
C		by default set to .FALSE., and the LOG and SVE files are
C		written to disk.  For some user applications, the accumulation
C		of FOR007.DAT and FOR049.DAT files can be avoided by setting
C		the logical to .TRUE. 
C		Version 4U, Donald H. Gudehus, August, 1994
C		Made it work under UNIX
C		Version 5, Donald H. Gudehus, March 27, 1998
C		Changed FORMAT statement 1001 slightly.
C		Version 6, Donald H. Gudehus, March 22, 1999
C		Changed TYPE and ATYPE from BYTE to CHARACTER.
C		Version 7, Donald H. Gudehus, April 7, 1999
C		Changed "0 to '0'O and removed 8 GO TOs.
C		Version 8U, Donald H. Gudehus, September 28, 1999
C		Changed SETEND to ISETEND for integer case
C		Version 8, Donald H. Gudehus, October 30, 2001
C		Changed formatting of output to log file, and screen
C		so that small numbers of parameters are arranged
C		horizontally on one line as before, but large numbers of
C		parameters are output on successive lines.  This allows
C		for arbitrarily large numbers of parameters for one
C		keyword.  Also, allowed MESS to be written to the screen
C		and to the log file when input is from a save file.
C		Version 9, Donald H. Gudehus, September 21, 2002
C		Increased B1 to 2048 to allow for larger number of dimensions
C		in an array (consistent with changes in SAVE.FOR and
C		STRKEY.FOR;  replaced ASSIGN statement for IAFILL with
C		a simple GO TO.
C		Version 10, Donald H. Gudehus, February 24, 2004
C		In writing out default values to the terminal and save
C		files, logicals would sometimes not be written if they
C		were declared as LOGICAL rather than LOGICAL*1 in the 
C		calling program.  This was because the ENDLIN function
C		was being used.  Now this is only used for integer
C		and real variables.
C		Version 10UM, Donald H. Gudehus, February 2, 2005
C		Introduced ENTRY USRINP_CHAR for Absoft compiler on Mac OS
C		Version 11, D. Gudehus, March 30, 2005
C		Changed LB to LOGICAL*4 and ALB to ALB(4) so that variable can
C		be declared as either LOGICAL*1, LOGICAL*2, or LOGICAL in
C		calling program and function on either little endian or big
C		endian machines.
C
	COMMON /BKEY/ B1
	PARAMETER MAXLP=10,NR8=2048
	CHARACTER*(*) KEYWORD,MESS
	LOGICAL LB,LOOP,SEP,DEFAULT,ENTERED,KEYWORD_FOUND
	BYTE DOLOOP(2,MAXLP),TYPEL(2,3),TYPEL6(6),LTYPEL(3)
	BYTE ALB(4),LPSYM,INSERT
	BYTE A1(132),A(1),B1(2048)
	CHARACTER*1 TYPE,ATYPE(4)
	CHARACTER*40 VFORMAT
	REAL*4 A4
	REAL*8 B8(NR8),INCR,LOW,UPP,A8
	INTEGER*2 I2
	INTEGER*4 I4,ENDLIN
	EQUIVALENCE(A8,A4,I4,I2,A1,LB),(TYPEL,TYPEL6),(ALB,LB)
C
	LOGICAL DONT_WRITE_FILES
	COMMON /WRITE_FILES/ DONT_WRITE_FILES
C
	DATA ATYPE/'F','A','I','L'/
	DATA TYPEL/4,8,0,0,2,4/ !  Floating, Character, Integer
	DATA LTYPEL/1,2,4/ !  Logical, DHG
C
	GO TO 1
	ENTRY USRINP_CHAR(N,TYPE,LENGTH,IDEF,KEYWORD,MESS,A)
   1	LPSYM=':'
	DEFAULT=.FALSE.
	ENTERED=.FALSE.
	NX=N*LENGTH
C  # of double-length words in input array B8
	NI=0
C  Default type is 1
	ITYPE=1
C  What type?
	DO I=1,4
	  IF (TYPE.EQ.ATYPE(I)) THEN
	    ITYPE=I
	  END IF
	END DO
	IF ((ITYPE.NE.2.AND.ITYPE.NE.4).AND.(LENGTH.NE.TYPEL(1,ITYPE).AND.
	1LENGTH.NE.TYPEL(2,ITYPE))) THEN
	  CALL ERROR(-4,'ILLEGAL LENGTH OF PARAMETER FOR THIS DATA TYPE')
	ELSE IF (ITYPE.EQ.4.AND.LENGTH.NE.LTYPEL(1).AND.LENGTH.NE.LTYPEL(2)
	1.AND.LENGTH.NE.LTYPEL(3)) THEN
	  CALL ERROR(-4,'ILLEGAL LENGTH OF PARAMETER FOR LOGICAL DATA TYPE')
	END IF
C  Get input parameters if present in .SVE file.
	NCH=0
	CALL GETKEY(KEYWORD,NCH)  ! In file STRKEY.FOR
	IF ((IDEF.EQ.0.OR.IDEF.EQ.1.OR.IDEF.EQ.3).AND.NCH.EQ.-1) NCH=0
	IF (NCH.NE.0) THEN
	  KEYWORD_FOUND=.TRUE.
	ELSE
	  KEYWORD_FOUND=.FALSE.
	END IF
  20	WRITE(6,1000) MESS
1000	FORMAT(1X,A)
	IF (.NOT.DONT_WRITE_FILES) WRITE(7,1000) MESS
	IF (KEYWORD_FOUND) GO TO 100
C
	WRITE(6,1001) KEYWORD
1001	FORMAT(1X,A,$)  ! D. H. G.
C  Perform input
	GO TO 100
 101	CONTINUE  ! Return point for DO looping
C  Was a default possible?
	IF ((IDEF.NE.0).OR.(.NOT.DEFAULT)) GO TO 30
	CALL ERROR(-1,'NO DEFAULT IS POSSIBLE')
C  Insist on reply if IDEF=0
	GO TO 20
  30	IF (DEFAULT) THEN
	  GO TO 140  ! Performs DEFAULTOUT
	END IF
C
	IF (.TRUE.) GO TO 110
 
C  Read input
C**************************************** PROC INPT
 100	CONTINUE
  	IF (NCH.EQ.0) THEN !  KEYWORD not in .SVE file
	  READ(5,2000) NCH,(B1(I),I=1,NCH)
2000	  FORMAT(Q,80A1)
	  ENTERED=.TRUE.
	END IF
C
2001	FORMAT('('' '',A,'I,'A1)') !  For Absoft compiler
	IF (NCH.LT.0) THEN
	  WRITE (6,2002) KEYWORD
2002	  FORMAT(1X,A)
	  IF (.NOT.DONT_WRITE_FILES) WRITE(7,2002) KEYWORD
	ELSE IF (NCH.EQ.0) THEN !  Default
	  IF (.NOT.DONT_WRITE_FILES) WRITE(7,2002) KEYWORD
	ELSE !  KEYWORD was in .SVE file, or parameters
	     !  entered above
	  IF (NCH.LT.50) THEN !  Horizontally spaced
	    NCHAR=NCH
	    WRITE(VFORMAT,2001) NCH
	    IF (.NOT.ENTERED) THEN
	      WRITE(6,VFORMAT) KEYWORD,(B1(I),I=1,NCH)
C	      WRITE(6,2001) KEYWORD,(B1(I),I=1,NCH)
C2001	      FORMAT(1X,A,<NCHAR>A1)
	    END IF
	    IF (.NOT.DONT_WRITE_FILES) THEN
	      WRITE(7,VFORMAT) KEYWORD,(B1(I),I=1,NCH)
C	      WRITE(7,2001) KEYWORD,(B1(I),I=1,NCH)
	    END IF
	  ELSE !  Vertically spaced (to avoid too long a line) D. H. G.
	    IF (.NOT.ENTERED) THEN
	      WRITE (6,2002) KEYWORD
	    END IF
	    IF (.NOT.DONT_WRITE_FILES) THEN
	      WRITE (7,2002) KEYWORD
	    END IF
	    I=1
C  Find the beginning (the first non-blank character)
	    DO WHILE (I.LE.NCH)
	      IF (B1(I).EQ.32) THEN
	        I=I+1
	      ELSE
C  Find the next blank
	        N1=I
	        J=N1+1
	        DO WHILE (B1(J).NE.32.AND.J.LE.NCH)
	          J=J+1
	        END DO
	        IF (J.GT.NCH) THEN
	          N2=0
	        ELSE
	          N2=J
	        END IF
	        IF (N2.GE.N1.AND.N2.LE.NCH) THEN
	          NCHAR=N2-N1
	          WRITE(VFORMAT,2001) NCHAR
	          IF (.NOT.ENTERED) THEN
	            WRITE (6,VFORMAT) (B1(I),I=N1,N2-1)
C	            WRITE (6,2001) (B1(I),I=N1,N2-1)
	          END IF
	          IF (.NOT.DONT_WRITE_FILES) THEN
	            WRITE (7,VFORMAT) (B1(I),I=N1,N2-1)
C	            WRITE (7,2001) (B1(I),I=N1,N2-1)
	          END IF
	          I=N2+1
	        ELSE
	          NCHAR=NCH-N1+1
	          WRITE(VFORMAT,2001) NCHAR
	          IF (.NOT.ENTERED) THEN
	            WRITE (6,VFORMAT) (B1(J),J=N1,NCH)
C	            WRITE (6,2001) (B1(J),J=N1,NCH)
	          END IF
	          IF (.NOT.DONT_WRITE_FILES) THEN
	            WRITE (7,VFORMAT) (B1(J),J=N1,NCH)
C	            WRITE (7,2001) (B1(J),J=N1,NCH)
	          END IF
	          I=NCH+1 !  Ends the loop
	        END IF
	      END IF
	    END DO
	  END IF
	END IF
C
	IF (NCH.NE.-1.AND..NOT.DONT_WRITE_FILES) CALL SAVEP(KEYWORD,NCH)
	! Saves the keyword, and parameters (contained in COMMON block BKEY)
	IF (NCH.LE.0) THEN
	  DEFAULT=.TRUE.
	ELSE  ! Decodes loop structures
	  DEFAULT=.FALSE.
	  NLOOP=0
C  Real plus integer only
	  IF (ITYPE.EQ.1.OR.ITYPE.EQ.3) THEN
	    DO I=1,MAXLP
	      DOLOOP(1,I)=0
	      DOLOOP(2,I)=0
	    END DO
	    NLOOP=1
C  Startword of do-loop in B1
	    NWORD=1
	    INSERT=0
	    LOOP=.FALSE.
	    SEP=.TRUE.
	    DO 103 I=1,NCH
	      IF (B1(I).EQ.LPSYM) THEN
	        IF (DOLOOP(2,NLOOP).EQ.1) THEN
C  Increment value present
	          DOLOOP(2,NLOOP)=2
	          INSERT=INSERT+1
	        ELSE IF (DOLOOP(2,NLOOP).EQ.2) THEN
	          CALL ERROR(-1,'ERROR IN DO-LOOP')
	          GO TO 20
	        ELSE
C  Uppervalue present
	          DOLOOP(1,NLOOP)=NWORD+INSERT
	          DOLOOP(2,NLOOP)=1
	          INSERT=INSERT+1
	        END IF
	        LOOP=.TRUE.
	        B1(I)=','
	      ELSE
C  Separation symbols
	        IF (B1(I).EQ.' '.OR.B1(I).EQ.',') THEN
	          IF (.NOT.SEP) THEN
	            NWORD=NWORD+1
	            SEP=.TRUE.
	          END IF
	          IF (LOOP) THEN
	            NLOOP=NLOOP+1
	            LOOP=.FALSE.
	          END IF
	        ELSE
	          SEP=.FALSE.
	        END IF
	      END IF
  103 	    CONTINUE
	    IF (.NOT.LOOP) THEN
	      NLOOP=NLOOP-1
	    END IF
	  END IF
	END IF
C  Decode input string into REAL*8 or Characters
	IF (NCH.GT.0) THEN
	  IF (TYPE.NE.'A'.AND.TYPE.NE.'L') CALL DCD(B1,NCH,B8,NR8)
C  # of double-length words
	  NI=NELD(B8,NR8)
	END IF
	GO TO 101
C
C  Fill output array
C*************************************** PROC OUT
 110	IF (ITYPE.EQ.2) THEN
C  Alphanumeric mode
	  DO I=1,NCH
	    A(I)=B1(I)
	  END DO
C  Remaining characters binary zero
	  DO I=NCH+1,NX
	    A(I)='0'O
	  END DO
	  RETURN
	ELSE IF (ITYPE.EQ.4) THEN
C  Logical
	  IF (B1(1).EQ.'Y'.OR.B1(1).EQ.'J'.OR.B1(1).EQ.'T'.OR.B1(1)
	1 .EQ.'y'.OR.B1(1).EQ.'j'.OR.B1(1).EQ.'t') THEN
	    LB=.TRUE.
	  ELSE
	    LB=.FALSE.
	  END IF
	  A(1)=ALB(1) !  DHG
	  IF (LENGTH.EQ.2) A(2)=ALB(2) !  DHG
	  IF (LENGTH.EQ.4) THEN !  DHG
	    A(3)=ALB(3)
	    A(4)=ALB(4)
	  END IF
	  RETURN
	END IF
C  Reals plus integers

C  ************* Perform DOVAL*********************
C  Substitute current value for DO loop variable ($).
C  $ is ASCII 36;  & is ASCII 38.  Necessary for Absoft compiler
	DO I=1,NI
	  IF (B8(I).EQ.36) B8(I)=DOVAL(IDUM)
	  IF (B8(I).EQ.38) B8(I)=DOVAL2(IDUM)
	END DO
C  ************************************************
C  Position in A
	IPOS=0
C  Next loop (if present)
	ILOOP=1
C  Position in B8
	IIN=0
	IF (NI.GT.0) THEN
  119	CONTINUE
	IIN=IIN+1
	A8=B8(IIN)
C  Perform CONVRT
	ASSIGN 121 TO ICNVRT
	GO TO 120
  121	CONTINUE
	IF (IIN.EQ.DOLOOP(1,ILOOP)) THEN
	  LOW=B8(IIN)
	  IIN=IIN+1
	  UPP=B8(IIN)
	  IF (DOLOOP(2,ILOOP).EQ.1) THEN
C  No iNCrementvalue was given
	    INCR=1.
	  ELSE
	    IIN=IIN+1
	    INCR=B8(IIN)
	  END IF
C  # of reals to be added in A
	  A4=((UPP-LOW)/INCR)
	  NREAL=IFIX(A4)
	  IF (NREAL.GT.0) THEN
	    DO IREAL=1,NREAL
	      LOW=LOW+INCR
	      A8=LOW
C  Perform CONVRT
	      ASSIGN 122 TO ICNVRT
	      GO TO 120
  122	      CONTINUE
	    END DO
	  END IF
	  ILOOP=ILOOP+1
	END IF
	IF (IIN.LT.NI) GO TO 119
	END IF
C  Close outputarray with "ENDLIN"-value
	IF (NX-IPOS.GE.LENGTH) THEN
	  IF (ITYPE.EQ.3) THEN
	    J=ISETEND(A8) !  For Unix
	  ELSE
	    J=SETEND(A8)
	  END IF
C  PERFORM AFILL
	  GO TO 130
C 131	  CONTINUE
	END IF
	RETURN
C
C  Real - Integer Conversion
C**************************************** PROC CONVRT
  120	IF (ITYPE.EQ.3) THEN
	  IF (LENGTH.EQ.2) THEN
C  integer*2
	    I2=NINT(A8)
	  ELSE
C  integer*4
	    I4=NINT(A8)
	  END IF
	END IF
C  Perform AFILL
C	ASSIGN 132 TO IAFILL
	IF (LENGTH.EQ.4.AND.ITYPE.EQ.1) A4=A8  ! For UNIX
	GO TO 130
  132	CONTINUE
	GO TO ICNVRT,(121,122)
C  Fill input/output array A
C**************************************** PROC AFILL
  130	DO I=1,LENGTH
	  A(IPOS+I)=A1(I)
	END DO
	IPOS=IPOS+LENGTH
	IF (IPOS.GT.NX) THEN
	  CALL ERROR(-3,'NUMBER OF ARRAYELEMENTS EXCEEDED')
	  NCH=0
	  GO TO 20
	END IF
	GO TO 132
C	GO TO IAFILL,(131,132)
C*********************************************** PROC DEFAULTOUT
C  Write out default values
 140	CONTINUE

C	IF (IDEF.GT.2) RETURN
	IF (TYPE.EQ.'A') THEN
1002	  FORMAT('(1X',I,'(A1))') !  For Absoft compiler
	  WRITE(VFORMAT,1002) NX
	  IF (IDEF.LE.2) WRITE(6,VFORMAT) (A(I),I=1,NX)
C	  IF (IDEF.LE.2) WRITE(6,1002) (A(I),I=1,NX)
C  NX is the total number of bytes of the variable in the call
	  IF (.NOT.DONT_WRITE_FILES) WRITE(7,VFORMAT) (A(I),I=1,NX)
	  IF (.NOT.DONT_WRITE_FILES) WRITE(49,VFORMAT) (A(I),I=1,NX)
C	  IF (.NOT.DONT_WRITE_FILES) WRITE(7,1002) (A(I),I=1,NX)
C	  IF (.NOT.DONT_WRITE_FILES) WRITE(49,1002) (A(I),I=1,NX)  
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
C1002	  FORMAT(1X,<NX>A1)
	END IF
	DO 143 J=1,N  ! Repeat for the N words of the variable
	  DO I=1,LENGTH
	    A1(I)=A(LENGTH*(J-1)+I) !  Copies input into A1
	  END DO
	  IF (TYPE.EQ.'I') THEN
	    IF (IENDLIN(I4).EQ.1) RETURN !  For Unix
	  ELSE
	    IF (TYPE.NE.'L') THEN !  D. H. G.
	      IF (ENDLIN(I4).EQ.1) RETURN
	    END IF
	  END IF
C
	  IF (TYPE.EQ.'F') THEN
	    IF (LENGTH.EQ.4) THEN
	      IF (IDEF.LE.2) WRITE(6,1003) A4
	      IF (.NOT.DONT_WRITE_FILES) WRITE(7,1003) A4
	      IF (.NOT.DONT_WRITE_FILES) WRITE(49,1003) A4
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
1003	      FORMAT(1X,G13.6,2X)
	    ELSE
	      IF (IDEF.LE.2) WRITE(6,1004) A8
	      IF (.NOT.DONT_WRITE_FILES) WRITE(7,1004) A8
	      IF (.NOT.DONT_WRITE_FILES) WRITE(49,1004) A8
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
1004	      FORMAT(1X,G16.9)
	    END IF
	  END IF
	  IF (TYPE.EQ.'I') THEN
	    IF (LENGTH.EQ.4) THEN
	      IF (IDEF.LE.2) WRITE(6,1005) I4
	      IF (.NOT.DONT_WRITE_FILES) WRITE(7,1005) I4
	      IF (.NOT.DONT_WRITE_FILES) WRITE(49,1005) I4
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
1005	      FORMAT(1X,I10)
	    ELSE
	      IF (IDEF.LE.2) WRITE(6,1006) I2
	      IF (.NOT.DONT_WRITE_FILES) WRITE(7,1006) I2
	      IF (.NOT.DONT_WRITE_FILES) WRITE(49,1006) I2
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
1006	      FORMAT(1X,I10)
	    END IF
	  END IF
	  IF (TYPE.EQ.'L') THEN
	    IF (IDEF.LE.2) WRITE(6,1007) LB
	    IF (.NOT.DONT_WRITE_FILES) WRITE(7,1007) LB
	    IF (.NOT.DONT_WRITE_FILES) WRITE(49,1007) LB
	!  Writes default parameter values to save file.  Keyword was
	!  already written with call to SAVEP
1007	    FORMAT(1X,L1) !  Must be L1 so that answer is correctly written
			  !  to the "save" file
	  END IF
 143	CONTINUE
 144	RETURN
C
	END

	PROGRAM SAMPLE
C
C  Note:  This is the UNIX version
C
C       This sample program demonstrates loading an array
C  of data into SAOimage.
C			Donald H. Gudehus, 1995
C			Version 2, D. Gudehus, August 29, 2006
C			Put in changes from saofact.for and call to
C			GET_ENDIAN
C
	INCLUDE 'saofacts.for'  ! UNIX likes lower case
	CHARACTER*40 ARRAY_NAME
	DIMENSION ARRAY(512,512)
C
	CALL GET_ENDIAN
	IFB_SAO=1  ! Calls up the 512X512 buffer;  no user prompting
	CALL SAOSTART
	CALL SAOFIRST
C  Fill the array
	NCOLS=512
	NROWS=512
	DO J=1,NROWS
	  DO I=1,NCOLS
	    ARRAY(I,J)=I+J
	  END DO
	END DO
C  Position the lower left corner of the array at the
C  lower left corner of the frame.
	IXFRAME=0
	IYFRAME=511
	BRIGHTNESS_MIN=2
	BRIGHTNESS_MAX=1024
	ARRAY_NAME='Sample image'
	NPICTURE=1
C  Load SAOimage in `fast mode'
	MODE=0
	CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXFRAME,IYFRAME,
	1BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
C
	END

	PROGRAM SAODEMO2

C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here an image representing a star is repeatedly
C  made larger and smaller, as if it is being focused at a telescope.
C  SAOimage could in fact aid in the focusing of a star on a CCD.
C
C				Donald H. Gudehus, July, 1994
C				Version 1U, D. Gudehus, September, 1994
C				Converted code to UNIX
C				Version 2U, D. Gudehus, September 4, 1999
C				Added interframe delay time
C
	INCLUDE 'saofacts.for'  ! UNIX likes lower case
C
	CHARACTER*40 ARRAY_NAME
	REAL ARRAY(64,64)
C
	CALL GET_ENDIAN
C  Ask the user for a delay time
	CALL USRINP(DELAY_TIME,1,'F',4,1,'DELAY_TIME=',
	1'Enter an interframe delay time in seconds:  (default = 0.0)')
	IFB_SAO=11  ! Gives a 128 by 128 buffer
	CALL SAOSTART
	CALL SAOFIRST
C
	IVAL='300'X
	CALL SAOCONVLT(IVAL)
C
	NCOLS=64
	NROWS=64
	BRIGHTNESS_MIN=0.0
	BRIGHTNESS_MAX=1000.0
C  Center the pictures within the frame
	IXFRAME=MAXFB_COLS_SAO/2-32
	IYFRAME=MAXFB_ROWS_SAO/2+32
	ARRAY_NAME='Focus Sequence'
	MODE=0  ! Fast load of a single picture
	DO NREPEAT=1,6
	  DO NPICTURE=1,16
	    a=2.0*ABS(MOD(NPICTURE+8,16)-8)+2.0
C  The lower left corner of each data file is considered to be at 1, 1.
	    DO J=1,NROWS
C  Vary the pictures
	      DO I=1,NCOLS
	        R=SQRT((I-32.5)**2+(J-32.5)**2)
	        IF (R/a.LT.8.0) THEN
	          ARRAY(I,J)=5000.0/a**1.6*EXP(-(R/a)**2)
	        ELSE
	          ARRAY(I,J)=0.0
	        END IF
	      END DO
	    END DO
	    CALL SAOLOAD(ARRAY,NCOLS,NROWS,IXFRAME,IYFRAME,
	1   BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
	    CALL DELAY(DELAY_TIME)
	  END DO
	END DO
	END

	SUBROUTINE STRKEY(A)
C
C       This function stores keywords and parameters in a local buffer when
C  a .OPTION is called.  This function is called by MIIPSOPT, GETCOM,
C  SAVE, and USRINP.
C
C		Version 2, Donald H. Gudehus, January 4, 1998
C		Changed STRKEY from FUNCTION to SUBROUTINE and commented
C		out STRKEY=1.
C		Version 3, Donald H. Gudehus, October 15, 2001
C		Dimensioned C as C*132
C		Version 4, D. H. G., September 20, 2002
C		Increased size of C to 2048 to cover variables of
C		large dimensionA
C		Version 5, D. H. G., February 5, 2008
C		Further increased the size of B and C to 4096
C
	CHARACTER *(*) A,KEY
	PARAMETER (NBUF=4096) !  Size of B
	CHARACTER B*4096,C*4096
	COMMON /BKEY/ C
C
C  Copy parameters to buffer B
	N=LEN(A)
C  N is the number of characters entered as an option plus optional 
C  parameters in MIIPSOPT.FOR counting from and including last character
C  of the option, irrespective of the number of characters in the option.
C  A normal OPTION or a .OPTION call gives N=1.
	IF (N.LE.2) THEN !  Empty parameter list
	  B='()'
	ELSE
	  B=A
	END IF
C	STRKEY=1
	RETURN
C
C
	ENTRY ADDKEY(A)
C
C       This entry adds parameters for a single option, contained in A, 
C  and which came from the SAVE file, to any possible optional new
C  parameters (if a .OPTION was called with new keyword values) already
C  in the list in buffer B.  This entry is called by RESTR after each
C  record is read from the SAVE file and which in turn is called by
C  MIIPSOPT or similar programs.
C
C	NB=INDEX(B,')') !  Present length
C  Find the last ')' in the string
	NST=1
	NB=0
	NB2=1
	DO WHILE (NB2.NE.0)
	  NB=INDEX(B(NST:),')')+NB
	  NST=NB
	  NB2=INDEX(B(NST+1:),')')
	  NST=NB2+NB+1
	  NB=NB+NB2
	END DO
C  Check to see if last input was a key word without a value.  This can
C  happen when a default is taken
	IF (B((NB-1):(NB-1)).EQ.'=') THEN  
	  B=B(:NB-1)//A//')' !  IF SO DO NOT PUT A SPACE BETWEEN THE INPUTS
	ELSE
	  B=B(:NB-1)//' '//A//')' !  Adds new string
	END IF
	NB=INDEX(B,')')
	IF (NB.GT.NBUF.OR.NB.EQ.0) THEN
	  CALL ERROR(-3,'PARAMETER BUFFER HAS OVERFLOWED')
	END IF
C	PRINT *, B,' B IN ADDKEY'
	RETURN
C
C
	ENTRY GETKEY(KEY,NL)
C
C       This entry finds the keyword in the local buffer B and returns the
C  associated parameter list as a character string in C in the COMMON block
C  BKEY.  NL is -1 on return if KEY is not present otherwise it is the length
C  of the string.  This entry is called by USRINP.
C
	NL=-1
	NA=INDEX(B,KEY) !  Position of Keyword;  0 if not present, a 3 if
			!  present
	IF (NA.EQ.0) RETURN !  Not present
	N1=INDEX(B(NA:),'=')+NA !  Position of start of parameters
C  Now find end of parameter list
	NB=INDEX(B(N1:),'=') !  Position of next '=' relative to start of
			     !  parameters
	IF (KEY.EQ.'Expression='.AND.B(N1+NB-2:N1+NB-2).EQ.'>') THEN
		!  In the option AR the parameters have an '=', but this can
		!  be identified by 'Expression' and '>'
	  NB=INDEX(B(NB+N1:),'=')+NB
	END IF
	IF (NB.EQ.0) THEN !  This was the last keyword
C	  N2=INDEX(B,')')-1 !  OK if only one ')'
C  Find the last ')' in the string
	  NST=1
	  N2=0
	  N22=1
	  DO WHILE (N22.NE.0)
	    N2=INDEX(B(NST:),')')+N2
	    NST=N2
	    N22=INDEX(B(NST+1:),')')
	    NST=N22+N2+1
	    N2=N2+N22
	  END DO
	  N2=N2-1	  
	ELSE  ! Searches for the preceeding separator
	  NB=NB+N1-1
	  N3=N1
   10	  N2=N3-1
	  N3=INDEX(B(N3+1:),' ')+N3 !  Next space
	  IF (N3.LT.NB) GO TO 10 !  Not far enough yet
	END IF
	NL=N2-N1+1
	C=B(N1:N2)
C	PRINT *, C,' C IN GETKEY'
	IF (NL.EQ.0) RETURN !  Dont clear if keyword only
	B=B(:NA-2)//B(N2+1:) !  Squeeze out these parameters
C	print *, B,' B IN GETKEY'
	RETURN
	END

	SUBROUTINE CLOSEFITS(LU)
C
C       This subroutine closes a FITS file and reinitializes certain
C  variables.
C				Donald H. Gudehus, August 4, 2006
C		Version 2, D. H. G., Jan. 6, 2008
C		Added QUIET(LU)=.FALSE.
C
	INCLUDE 'fitsfacts.for'
C
	CLOSE(LU)
	FITSFILENAME(LU)=' '
	QUIET(LU)=.FALSE.
	RETURN
	END

	SUBROUTINE DELAY(DELAY_TIME)
C
C  Note:  This is the UNIX version
C
C       This subroutine delays execution by an amount of time
C  in seconds given by TIME.
C
C			Donald H. Gudehus, September, 1994
C
	REAL TIMEARRAY(2)
C
	START_TIME=DTIME(TIMEARRAY)
	ACCUMULATED_TIME=0.0
	DO WHILE(ACCUMULATED_TIME.LT.DELAY_TIME)
	  ACCUMULATED_TIME=ACCUMULATED_TIME+DTIME(TIMEARRAY)
	END DO
	RETURN
	END

	PROGRAM SAODEMO4
C
C  Note:  This is the UNIX version
C
C	This program demonstrates the control of SAOimage from a
C  standalone program.  Here we load 4 images of the binary system 
C  from SAODEMO3 at 4 different phases.  The cursor can then be used to
C  read back positional information from each frame.  The program
C  calculates the desktop, frame, and map coordinates, as well as the
C  picture number.  A message is sent if the cursor is not in a picture.
C  From this information, the pixel intensity value is then obtained from 
C  the data array.
C
C			Donald H. Gudehus, September, 1994
C			Version 1U, D. Gudehus, September 21, 1994
C			Changed code to work under UNIX
C			Version 2, D. Gudehus, August 29, 2006
C			Incorporated changes from saofacts.for and
C			added call to GET_ENDIAN.
C
	INCLUDE 'saofacts.for'
C
	PARAMETER NCOLS=128,NROWS=128,NIMAGES=4
	INTEGER IXFRAME(NIMAGES),IYFRAME(NIMAGES)
	REAL ARRAY(NCOLS,NROWS,NIMAGES)
C
	CHARACTER*40 ARRAY_NAME
	INTEGER*2 IXT,IYT
	INTEGER*4 ACTION,CURSOR_TYPE,COLOR_TYPE
	LOGICAL MESSAG
	REAL INCLINA,EXTRA(1)
C
	CALL GET_ENDIAN
C  Don't prompt the user for the size of the buffer, just use a big
C  enough one.
	IFB_SAO=1 !  Gives a 512 by 512 buffer
	CALL SAOSTART
	CALL SAOFIRST
C
C  Preset the lookup table to a convenient range of colors
	IVAL='A00'X
	CALL SAOCONVLT(IVAL)
C
	CALL MESSAGE('Creating the images')
C  Zero the arrays
	DO K=1,NIMAGES
	  DO J=1,NROWS
	    DO I=1,NCOLS
	      ARRAY(I,J,K)=0.0
	    END DO
	  END DO
	END DO
	NC1=NCOLS/2
	NR1=NROWS/2-1
	BRIGHTNESS_MIN=0.0
	BRIGHTNESS_MAX=1000.0
C  Calculate where the images will be placed in the frame.  The 
C  coordinates below are the where the lower left of each image will be 
C  placed in the frame buffer.  The frame has (0,0) in the upper left;  
C  any image has (1,1) in the lower left.
	IXFRAME(1)=MAXFB_COLS_SAO/4-NC1
	IYFRAME(1)=MAXFB_ROWS_SAO/4+NR1 !  Upper left in frame buffer
	IXFRAME(2)=3*MAXFB_COLS_SAO/4-NC1
	IYFRAME(2)=MAXFB_ROWS_SAO/4+NR1 !  Upper right
	IXFRAME(3)=MAXFB_COLS_SAO/4-NC1
	IYFRAME(3)=3*MAXFB_ROWS_SAO/4+NR1 !  Lower left
	IXFRAME(4)=3*MAXFB_COLS_SAO/4-NC1
	IYFRAME(4)=3*MAXFB_ROWS_SAO/4+NR1 !  Lower right
	ARRAY_NAME='Cursor Demonstration'
	MODE=1 !  Allows loading several pictures into frame
	a=2.0
C  Create the images.
	DO K=1,NIMAGES
	  X1=10.0*COSD(90.0*K)+NC1
	  Y1=10.0*SIND(90.0*K)+NR1
	  X2=-22.0*COSD(90.0*K)+NC1
	  Y2=-22.0*SIND(90.0*K)+NR1
C  The lower left corner of each data array is considered to have 
C  coordinates 1, 1.
	  IMSX_SAO(0,K)=1
	  IMSY_SAO(0,K)=1
	  DO J=1,NROWS
	    DO I=1,NCOLS
	      R1=SQRT((I-X1)**2+(J-Y1)**2)
	      R2=SQRT((I-X2)**2+(J-Y2)**2)
	      ARRAY(I,J,K)=880.0/(1+R1/a)**2+440.0/(1+R2/a)**2+25.0
	    END DO
	  END DO
	END DO
C  Now load the images into SAOimage.  Each will be located at a 
C  different position.
	DO K=1,NIMAGES
	  NPICTURE=K
	  CALL SAOLOAD(ARRAY(1,1,K),NCOLS,NROWS,IXFRAME(K),IYFRAME(K),
	1 BRIGHTNESS_MIN,BRIGHTNESS_MAX,ARRAY_NAME,NPICTURE,MODE)
	END DO
C  Read the cursor coordinates
	KEY=0 !  Initializes the returned ASCII code of the key that will
	      !  be pressed
	CALL MESSAGE('The coordinates printed in the SAOimage window are '//
	1'array or map coordinates,')
	CALL MESSAGE('and are always relative to the last image loaded.')
	CALL MESSAGE('The coordinates you will see below are correct for '//
	1'each individual image')
	CALL MESSAGE(' ')
	DO WHILE (KEY.NE.81.AND.KEY.NE.113)
	  CALL MESSAGE('Be sure SAOimage has focus, position the cursor, '//
	1 'then press <CR> or any key.')
	  CALL MESSAGE('Press Q or q to quit')
	  MESSAG=.TRUE.
	  CALL SAO_CURN(NPICN,IXT,IYT,XF,YF,XM,YM,KEY,MESSAG)
	  WRITE (6,1000) NPICN,TV_FILENAME(NPICN)
	  WRITE (7,1000) NPICN,TV_FILENAME(NPICN)
1000	  FORMAT(' ','Cursor in image ',I2';  ','file name = ',A30)
	  WRITE (6,2000) IXT,IYT !  Position on TV
	  WRITE (7,2000) IXT, IYT
2000	  FORMAT(' ',10X,'(X, Y:  on TV desktop  )= ',I8,2X,I8)
	  WRITE (6,3000) XF,YF !  Position in frame
	  WRITE (7,3000) XF,YF
3000	  FORMAT(' ',10X,'(X, Y:  in frame       )= ',F8.3,2X,F8.3)
	  WRITE (6,4000) XM,YM !  Position in map
	  WRITE (7,4000) XM,YM
4000	  FORMAT(' ',10X,'(X, Y:  in map or array)= ',F8.3,2X,F8.3)
	  IF (XM.GE.1.AND.XM.LE.NCOLS.AND.YM.GE.1.AND.YM.LE.NROWS) THEN
	    WRITE (6,5000) ARRAY(INT(XM),INT(YM),NPICN) !  Pixel intensity
5000	    FORMAT(' ',10X,'Intensity in array      = ',F10.3)
	    WRITE (7,5000) ARRAY(INT(XM),INT(YM),NPICN) !  Pixel intensity
	  END IF
	END DO
C  Display some erasable rectangles 
C  We will reference the rectangles to the last image.
C
	ACTION=1  !  Erasable cursor
	CURSOR_TYPE=768 !  Rectangle
	NPIC1=NPIC_SAO
	X=MAXFB_COLS_SAO/2-XLOC_SAO(NPIC_SAO)+1.0
	Y=-MAXFB_ROWS_SAO/2+2.0+YLOC_SAO(NPIC_SAO)
			!  Center location of rectangle in system of last
			!  image
	DO I=1,257,16 !  Border of frame is 514X514.  We want to draw just
		      !  outside that.
	  INCLINA=(I-1)*22.5/16.0
	  COLOR_TYPE=MOD(I,5)+203
	  a=I+0.5 !  Half the horizontal length of the rectangle.  Since
		  !  our rectangle is drawn through the centers of an even
		  !  number of pixels, its length is odd.  Half of that 
		  !  gives us the 0.5.
	  b=a
	  EXTRA(1)=0.0
	  CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1 a,b,INCLINA,EXTRA,0)
	END DO
C
	END

	SUBROUTINE SAOCONVLT(IVAL)
C
C  Note:  This is the UNIX version.
C
C       This subroutine sends a packet to SAOimage via the Imtool protocol
C  to load a requested built-in video lookup table.
C  Custom lookup tables are loaded with SAO_LOAD_VLT.
C
C			Donald H. Gudehus, September 8, 1993
C			Version 2U, D. Gudehus, September, 1994
C			Converted code to work under UNIX
C			Version 3, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
C	IVAL	(C)	The color lookup table code.  The following currently
C			exist:
C			'100'X  Black and white, single cycle
C			'200'X  Blackbody 
C			'300'X  High energy physics
C			'400'X  Eight colors with no overlap
C			'500'X  Table A
C			'600'X  Table B 
C			'700'X  Table C 
C			'800'X  Table D
C			'900'X  High constrast spectrum with rollover
C			'A00'X  Spectrum with white and rollover
C			'B00'X  Black and white with rollover
C
C  Custom lookup tables are loaded with SAO_LOAD_VLT
C
	INCLUDE 'saofacts.for'
C
	INTEGER*2 I2VAL
C
	I2VAL=IVAL
	IBUFFER_SAO(1)=256  ! imhead.tid,  no name
	IBUFFER_SAO(2)=-3  ! imhead.thingct = 3 words
	IBUFFER_SAO(3)=2  ! imhead.subunit = LUT
	IBUFFER_SAO(4)=0  ! imhead.checksum;  initially set to zero
	IBUFFER_SAO(5)=0  ! imhead.x
	IBUFFER_SAO(6)=0  ! imhead.y
	IBUFFER_SAO(7)=I2VAL  ! imhead.z
	IBUFFER_SAO(8)=0  ! imhead.t
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
        CALL SI_WRITE(BUFFER_SAO,NBYTES)
	IBUFFER_SAO(1)=0
	IBUFFER_SAO(2)=0
	IBUFFER_SAO(3)=0
	NBYTES=6
        CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	RETURN
	END

	SUBROUTINE SAOCAPTION
C
C  Note:  This is the UNIX version
C
C	This subroutine displays a caption on SAOimage.  The calling 
C  routine should have the caption available in the array TV_FILENAME
C  and NPIC set to point to the requested caption.  XLOC, YLOC, AMIN, and
C  AMAX should be established as well, since the world coordinate system
C  in SAOimage is reinitialized when SAOCAPTION is called.
C
C			Donald H. Gudehus, July, 1994
C			Version 1U, D. Gudehus, September, 1994
C			Converted it into UNIX
C			Version 2, D. Gudehus, June, 1995
C			Allowed caption to have spaces in it.
C			Version 3, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
	INCLUDE 'saofacts.for'
C
C  Set up the new WCS header information
	I=40
	DO WHILE(TV_FILENAME(NPIC_SAO)(I:I).EQ.' '.AND.I.GE.1)
	  I=I-1
	END DO
	LF=MAX(I,1) !  Length of file name
	IBUFFER_SAO(1)='40000'O !  PACKED and IMC_SAMPLE
	IBUFFER_SAO(2)=-(LF+59)
	IBUFFER_SAO(3)=17 !  imhead.subunit = WCS (World coordinate system)
	IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0
	IBUFFER_SAO(6)=0
	IBUFFER_SAO(7)=1 !  Frame number
	IBUFFER_SAO(8)=IFB_SAO-1 !  Frame buffer configuration - 1
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
C  Send the WCS header
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C  Set up the WCS data packet
	IXLOC=XLOC_SAO(1)
	IYLOC=YLOC_SAO(1)
	CBUFFER_SAO(1:LF)=TV_FILENAME(NPIC_SAO)(1:LF)
	BUFFER_SAO(LF+1)=10
	CBUFFER_SAO(LF+2:LF+14)='1. 0. 0. -1. ' !  xx yx xy yy
	ENCODE (7,1000,CBUFFER_SAO(LF+15:LF+21)) 2-0.5-IXLOC !  xo =
	!  X Coordinate at left edge of buffer;  0.5 added to conform with 
	!  corner of pixel being x.0, y.0.
1000	FORMAT(F7.1)
	CBUFFER_SAO(LF+22:LF+22)=' '
	ENCODE (7,1000,CBUFFER_SAO(LF+23:LF+29)) IYLOC+2-0.5 !  yo =
	!  Y Coordinate at top edge of buffer;  0.5 added to conform with 
	!  corner of pixel being x.0, y.0.
	CBUFFER_SAO(LF+30:LF+30)=' '
	ENCODE (12,2000,CBUFFER_SAO(LF+31:LF+42)) AMIN_SAO(NFRAME_SAO) !  low
2000	FORMAT(E12.5)
	CBUFFER_SAO(LF+43:LF+43)=' '
	ENCODE (12,2000,CBUFFER_SAO(LF+44:LF+55)) AMAX_SAO(NFRAME_SAO) !  high
	CBUFFER_SAO(LF+56:LF+57)=' 1' !  w_type (=linear)
	BUFFER_SAO(LF+58)=10
	BUFFER_SAO(LF+59)=0
	NBYTES=LF+59
C  Send the WCS data packet
	CALL SI_WRITE(BUFFER_SAO,NBYTES)	
C
	RETURN
C
	END

	SUBROUTINE RWFITSROW(LU,NMAP,NPLANE,DATA,LENGTH,NROW)
C
C       This subroutine reads from or writes to a FITS file, a single 
C  row of data.  One should not call RWFITSROW directly but rather one of 
C  the various entries, e.g., RDFITSROW or RDDPFITSROW for reading, and
C  WRFITSROW or WRDPFITSROW, for writing.  Each of the entries can read
C  or write data for several different value of BITPIX, as contained
C  in the COMMON block FITSFACTS_INTEGER4.  The choice of which subroutine
C  one uses will affect whether the data array in the argument list is
C  REAL*4 or REAL*8.
C			Donald H. Gudehus, June, 2006
C			Version 2, D. H. Gudehus, January 28, 2008
C			Improved the accuracy when writing by taking
C			the nearest integer.
C
C	LU	(C)	Logical unit for I/O
C	NMAP	(C)	Number of map to be read or written to, counting
C			from 1
C	NPLANE	(C)	Number of plane to be read or written to, counting
C			from 1
C	DATA	(C/R)	Array to receive data on read or to provide data
C			on write
C	LENGTH	(C)	Dimension of array.  Should be at least as big as the
C			row length.
C	NROW	(C)	Row number to be read or written, counting from 1
C
	INTEGER LU,LENGTH,NROW
	REAL DATA(LENGTH)
	REAL*8 DATADP(LENGTH)
C
	INCLUDE 'fitsfacts.for'
C
	BYTE PHYSREC(3000)
	INTEGER*2 I2REC(1500)
	INTEGER I4REC(750),I4X2REC(1500)
	REAL*4 R4REC(750)
	REAL*8 R8REC(375)
	EQUIVALENCE (PHYSREC,I2REC,I4REC,I4X2REC,R4REC,R8REC)
	CHARACTER*3 PRGFMAT
	CHARACTER*4 CALL
	INTEGER BSWAP,WSWAP
C
	CHARACTER*1 SYSTEM_ENDIAN
	COMMON /SYS_ENDIAN/ SYSTEM_ENDIAN
C
	ENTRY RDFITSROW(LU,NMAP,NPLANE,DATA,LENGTH,NROW)
	CALL='READ'
	PRGFMAT='R4'
	GO TO 100
C
	ENTRY WRFITSROW(LU,NMAP,NPLANE,DATA,LENGTH,NROW)
	CALL='WRIT'
	PRGFMAT='R4'
	GO TO 100
C
	ENTRY RDDPFITSROW(LU,NMAP,NPLANE,DATADP,LENGTH,NROW)
	CALL='READ'
	PRGFMAT='R8'
	GO TO 100
C
	ENTRY WRDPFITSROW(LU,NMAP,NPLANE,DATADP,LENGTH,NROW)
	CALL='WRIT'
	PRGFMAT='R8'
	GO TO 100
C
 100	IBLKLEN=2880
	BSWAP=1
	WSWAP=1
C
	NBYTESPERROW=NAXIS1(NMAP,LU)*ABS(BITPIX(NMAP,LU))/8
	NBYTESPERPLANE=NBYTESPERROW*NAXIS2(NMAP,LU)
	IBYTEOFFSET1=(NROW-1)*NBYTESPERROW+(NPLANE-1)*NBYTESPERPLANE
			!  Beginning of map to row start
c	IBYTEOFFSET2=IBYTEOFFSET1+NBYTESPERROW
	IBYTEOFFSET2=IBYTEOFFSET1+NBYTESPERROW-1
			!  Beginning of map to row end
	IRECOFFSET1=IBYTEOFFSET1/IBLKLEN
	IRECOFFSET2=IBYTEOFFSET2/IBLKLEN
	IRECSTART=MAPRECORDS(1,NMAP,LU)+IRECOFFSET1
	IRECEND=MAPRECORDS(1,NMAP,LU)+IRECOFFSET2
	IBYTEOFFSET3=IBYTEOFFSET1-IRECOFFSET1*IBLKLEN
		!  From start record boundary to row start
	IBYTEOFFSET4=IBYTEOFFSET2-IRECOFFSET2*IBLKLEN
		!  From end record boundary to row end
	IF (CALL.EQ.'READ') THEN
	  ICOUNT=1
	  DO IR=IRECSTART,IRECEND
	    READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	    IF (BITPIX(NMAP,LU).EQ.8) THEN
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3+1
	!  Adds 1 because we want an index in the record
	        IEND=IBYTEOFFSET4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3+1
	          IEND=IBLKLEN
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          IF (PHYSREC(I).LT.0) THEN
	            DATA(ICOUNT)=BSCALE(NMAP,LU)*(PHYSREC(I)+256)+
	1           BZERO(NMAP,LU)
	          ELSE
	            DATA(ICOUNT)=BSCALE(NMAP,LU)*PHYSREC(I)+
	1           BZERO(NMAP,LU)
	          END IF
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          IF (PHYSREC(I).LT.0) THEN
	            DATADP(ICOUNT)=BSCALE(NMAP,LU)*(PHYSREC(I)+256)+
	1           BZERO(NMAP,LU)
	          ELSE
	            DATADP(ICOUNT)=BSCALE(NMAP,LU)*PHYSREC(I)+
	1           BZERO(NMAP,LU)
	          END IF
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.16) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI2(I2REC,I2REC,IBLKLEN/2)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/2+1
	        IEND=IBYTEOFFSET4/2+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/2+1
	          IEND=IBLKLEN/2
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/2+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/2
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          DATA(ICOUNT)=BSCALE(NMAP,LU)*I2REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          DATADP(ICOUNT)=BSCALE(NMAP,LU)*I2REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.32) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI4(I4REC,I4REC,IBLKLEN/4)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/4+1
	        IEND=IBYTEOFFSET4/4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/4+1
	          IEND=IBLKLEN/4
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/4
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          DATA(ICOUNT)=BSCALE(NMAP,LU)*I4REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          DATADP(ICOUNT)=BSCALE(NMAP,LU)*I4REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.-32) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IEEE2UNIX(I4REC,IBLKLEN/4,BSWAP,WSWAP)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/4+1
	        IEND=IBYTEOFFSET4/4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/4+1
	          IEND=IBLKLEN/4
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/4
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          DATA(ICOUNT)=BSCALE(NMAP,LU)*R4REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          DATADP(ICOUNT)=BSCALE(NMAP,LU)*R4REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.-64) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IEEE2UNIX64(I4X2REC,IBLKLEN/8,BSWAP,WSWAP)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/8+1
	        IEND=IBYTEOFFSET4/8+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/8+1
	          IEND=IBLKLEN/8
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/8+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/8
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          DATA(ICOUNT)=BSCALE(NMAP,LU)*R8REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          DATADP(ICOUNT)=BSCALE(NMAP,LU)*R8REC(I)+
	1         BZERO(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    END IF
	  END DO
	END IF
C
	IF (CALL.EQ.'WRIT') THEN
	  ICOUNT=1
	  DO IR=IRECSTART,IRECEND
	    READ(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	    IF (BITPIX(NMAP,LU).EQ.8) THEN
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3+1
	        IEND=IBYTEOFFSET4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3+1
	          IEND=IBLKLEN
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          PHYSREC(I)=NINT((DATA(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          PHYSREC(I)=NINT((DATADP(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.16) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI2(I2REC,I2REC,IBLKLEN/2)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/2+1
	        IEND=IBYTEOFFSET4/2+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/2+1
	          IEND=IBLKLEN/2
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/2+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/2
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          I2REC(I)=NINT((DATA(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          I2REC(I)=NINT((DATADP(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI2(I2REC,I2REC,IBLKLEN/2) !  Restores the order
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.32) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI4(I4REC,I4REC,IBLKLEN/4)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/4+1
	        IEND=IBYTEOFFSET4/4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/4+1
	          IEND=IBLKLEN/4
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/4
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          I4REC(I)=NINT((DATA(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          I4REC(I)=NINT((DATADP(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU))
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IBMI4(I4REC,I4REC,IBLKLEN/4)
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.-32) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IEEE2UNIX(I4REC,IBLKLEN/4,BSWAP,WSWAP)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/4+1
	        IEND=IBYTEOFFSET4/4+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/4+1
	          IEND=IBLKLEN/4
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/4+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/4
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          R4REC(I)=(DATA(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          R4REC(I)=(DATADP(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL UNIX2IEEE(I4REC,IBLKLEN/4,BSWAP,WSWAP)
	      END IF
	    ELSE IF (BITPIX(NMAP,LU).EQ.-64) THEN
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL IEEE2UNIX64(I4X2REC,IBLKLEN/8,BSWAP,WSWAP)
	      END IF
	      IF (IRECSTART.EQ.IRECEND) THEN
	        ISTART=IBYTEOFFSET3/8+1
	        IEND=IBYTEOFFSET4/8+1
	      ELSE
	        IF (IR.EQ.IRECSTART) THEN
	          ISTART=IBYTEOFFSET3/8+1
	          IEND=IBLKLEN/8
	        ELSE IF (IR.EQ.IRECEND) THEN
	          ISTART=1
	          IEND=IBYTEOFFSET4/8+1
	        ELSE
	          ISTART=1
	          IEND=IBLKLEN/8
	        END IF
	      END IF
	      IF (PRGFMAT.EQ.'R4') THEN
	        DO I=ISTART,IEND
	          R8REC(I)=(DATA(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      ELSE IF (PRGFMAT.EQ.'R8') THEN
	        DO I=ISTART,IEND
	          R8REC(I)=(DATADP(ICOUNT)-BZERO(NMAP,LU))/
	1         BSCALE(NMAP,LU)
	          ICOUNT=ICOUNT+1
	        END DO
	      END IF
	      IF (SYSTEM_ENDIAN.EQ.'L') THEN
	        CALL UNIX2IEEE64(I4X2REC,IBLKLEN/8,BSWAP,WSWAP)
	      END IF
	    END IF
C  Now write the record back
	    WRITE(LU,REC=IR,IOSTAT=ISTAT) (PHYSREC(I),I=1,IBLKLEN)
	  END DO
	END IF
C	
	RETURN
	END

	SUBROUTINE SAOSTART
C
C  Note:  This is the UNIX version
C
C       This subroutine opens the input and output pipes, imt1i and imt1o,
C  for communication with SAOimage.  If IFB, the frame buffer key, is set 
C  to zero, then the user is prompted for its value
C			Donald H. Gudehus, August, 1993
C			Version 1U, D. Gudehus, September, 1994
C			Converted code to UNIX
C			Version 2, D. Gudehus, July 25, 2006
C			Incorporated new saofacts.for
C
	INCLUDE 'saofacts.for'
C
	BYTE BIMTOOLNAME(10)
	CHARACTER IMTOOLNAME*10
	EQUIVALENCE (BIMTOOLNAME,IMTOOLNAME)
C
	IF (IFB_SAO.EQ.0) THEN
	  IFB_SAO=1
	  CALL MESSAGE('Select a frame buffer size:')
	  CALL MESSAGE('                1 =  512 X 512 (default)')
	  CALL MESSAGE('                2 =  800 X 800')
	  CALL MESSAGE('                3 = 1024 X 1024')
	  CALL MESSAGE('                4 = 1600 X 1600')
	  CALL MESSAGE('                5 = 2048 X 2048')
	  CALL MESSAGE('                6 = 4096 X 4096')
	  CALL MESSAGE('                7 = 4096 X 1024')
	  CALL MESSAGE('                8 = 1024 X 4096')
	  CALL MESSAGE('                9 = 1144 X  880')
	  CALL MESSAGE('               10 = 1144 X  764')
	  CALL MESSAGE('               11 =  128 X  128')
	  CALL MESSAGE('               12 =  256 X  256')
	  CALL MESSAGE('               13 =   90 X   90')
	  CALL USRINP(IFB_SAO,1,'I',4,1,'FRAME_BUFFER=',' ')
	END IF
	IF (IFB_SAO.EQ.1) THEN
	  MAXFB_COLS_SAO=512
	  MAXFB_ROWS_SAO=512
	ELSE IF (IFB_SAO.EQ.2) THEN
	  MAXFB_COLS_SAO=800
	  MAXFB_ROWS_SAO=800
	ELSE IF (IFB_SAO.EQ.3) THEN
	  MAXFB_COLS_SAO=1024
	  MAXFB_ROWS_SAO=1024
	ELSE IF (IFB_SAO.EQ.4) THEN
	  MAXFB_COLS_SAO=1600
	  MAXFB_ROWS_SAO=1600
	ELSE IF (IFB_SAO.EQ.5) THEN
	  MAXFB_COLS_SAO=2048
	  MAXFB_ROWS_SAO=2048
	ELSE IF (IFB_SAO.EQ.6) THEN
	  MAXFB_COLS_SAO=4096
	  MAXFB_ROWS_SAO=4096
	ELSE IF (IFB_SAO.EQ.7) THEN
	  MAXFB_COLS_SAO=4096
	  MAXFB_ROWS_SAO=1024
	ELSE IF (IFB_SAO.EQ.8) THEN
	  MAXFB_COLS_SAO=1024
	  MAXFB_ROWS_SAO=4096
	ELSE IF (IFB_SAO.EQ.9) THEN
	  MAXFB_COLS_SAO=1144
	  MAXFB_ROWS_SAO=880
	ELSE IF (IFB_SAO.EQ.10) THEN
	  MAXFB_COLS_SAO=1144
	  MAXFB_ROWS_SAO=764
	ELSE IF (IFB_SAO.EQ.11) THEN
	  MAXFB_COLS_SAO=128
	  MAXFB_ROWS_SAO=128
	ELSE IF (IFB_SAO.EQ.12) THEN
	  MAXFB_COLS_SAO=256
	  MAXFB_ROWS_SAO=256
	ELSE IF (IFB_SAO.EQ.13) THEN
	  MAXFB_COLS_SAO=90
	  MAXFB_ROWS_SAO=90
	END IF
C  Open up some pipes for communication with SAOimage.
	CALL SI_OPEN_NAMEDPIPE()
	RETURN
	END

	INTEGER FUNCTION INEL(IA,N)
C
C  Note:  This is the UNIX version.  
C
C		Version 1U, D. Gudehus, September 18, 1999
C
C       This function counts the number of 4-byte words in the integer array
C  IA of dimension N.  It is used after a call to USRINP.  If a default 
C  is not taken with USRINP, the correct number will be returned;  however,
C  if a default is taken with USRINP, one must precede the call to USRINP
C  with a call to ISETEND.  For example,   
C	DO I=1,MAXNUMPARAM
C	  J=ISETEND(IPARAMETER(I))
C	END DO
C	CALL USRINP(IPARAMETER,...)
C	NUM=INEL(IPARAMETER,N)
C
	INTEGER IENDLIN
	DIMENSION IA(N)
	DATA IEND/'80000000'X/
C
	DO I=1,N
	  IF (IA(I).EQ.IEND) GO TO 11
	END DO
   11	INEL=I-1
	RETURN
C
	ENTRY IENDLIN(IX)  ! NB This is an integer function
C 
C       This function tests for the end of array indicator and will
C  be true if the idicator is present.
C
	IENDLIN=0
	IF (IX.EQ.IEND) IENDLIN=1
	RETURN
C
	ENTRY ISETEND(IX)
C
C       This function sets the argument equal to the end-of-array
C  indicator.
C
	IX=IEND
	RETURN
C
	END

	INTEGER FUNCTION NEL(A,N)
C
C  Note:  This is the UNIX version.  
C
C		Version 2U, D. Gudehus, April, 1999
C		Modified END for Unix
C		Version 3U, D. Gudehus, Dec. 16, 2002
C		Changed ENDLIN to catch NaN situations
C		Version 3UM, D. Gudehus, February 8, 2005
C		Modified END for Absoft compiler on Mac OS
C
C       This function counts the number of 4-byte words in the array
C  A of dimension N.  It is used after a call to USRINP.  If a default 
C  is not taken with USRINP, the correct number will be returned;  however,
C  if a default is taken with USRINP, one must precede the call to USRINP
C  with a call to SETEND.  For example,   
C	DO I=1,MAXNUMPARAM
C	  J=SETEND(PARAMETER(I))
C	END DO
C	CALL USRINP(PARAMETER,...)
C	NUM=NEL(PARAMETER,N)
C
	INTEGER ENDLIN
	DIMENSION A(N)
	INTEGER IEND
	EQUIVALENCE (IEND,END)
	DATA IEND/'FF7FFFFF'X/
C
	DO I=1,N
	  IF (A(I).EQ.END) GO TO 11
	END DO
   11	NEL=I-1
	RETURN
C
	ENTRY ENDLIN(X)  ! NB This is an integer function
C 
C       This function tests for the end of array indicator and will
C  be true if the idicator is present.
C
	ENDLIN=0
	  
	IF (X.EQ.END) ENDLIN=1
C  If a NaN situation arises, and the end of the input sequence has
C  not been reached, we can catch it with the following:
	IF (X.LT.END) ENDLIN=0
	IF (X.GT.END) ENDLIN=0 !  This is the important one
	RETURN
C
	ENTRY SETEND(X)
C
C       This function sets the argument equal to the end-of-array
C  indicator.
C
	X=END
	RETURN
C
	END

	SUBROUTINE SAO_DISPLAY_VECT
C
C  Note:  This is the UNIX version
C
C       This subroutine sends commands to SAOimage via the Imtool protocol
C  in order to display previously drawn straight lines (vectors) 
C  sent with SAO_VECT with ACTION set to 4.  
C					Donald H. Gudehus, September, 1994
C				Version 1U, D. Gudehus, September, 1994
C				Changed code to work under UNIX
C				Version 2, D. Gudehus, July 25, 2006
C				Incorporated new saofacts.for
C
	INTEGER ACTION
C
	INCLUDE 'saofacts.for'
C
	INTEGER*2 ICOUNT
C
	ICOUNT=67
	IBUFFER_SAO(1)='40000'O !  = PACKED;  since is not IIS_READ, is write
	IBUFFER_SAO(2)=-ICOUNT !  imhead.thingct
	IBUFFER_SAO(3)=13 !  = imhead.subunit
        IBUFFER_SAO(4)=0
	IBUFFER_SAO(5)=0
        IBUFFER_SAO(6)=0
        IBUFFER_SAO(7)=1 !  Frame number
        IBUFFER_SAO(8)=0
	CALL IMTOOLCHECKSUM(IBUFFER_SAO)
	NBYTES=16
C  NPIC is the most recent picture number loaded.
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
	YSAO1=0.0
	YSAO2=MAXFB_ROWS_SAO-1.0
	ACTION=5
        ENCODE (2,2002,CBUFFER_SAO(1:2)) ACTION
2002	FORMAT(I2)
	CBUFFER_SAO(3:3)=' '
	CBUFFER_SAO(4:7)='  0' !  Cursor type
	CBUFFER_SAO(8:8)=' '
	CBUFFER_SAO(9:16)='      0' !  Color
	CBUFFER_SAO(17:17)=' '
1009	FORMAT(F9.3)
	CBUFFER_SAO(18:26)='      1.0' !  X1
	CBUFFER_SAO(27:27)=' '
	ENCODE (9,1009,CBUFFER_SAO(28:36)) YSAO1
	CBUFFER_SAO(37:37)=' '
	CBUFFER_SAO(38:46)='      1.0' !  X2
	CBUFFER_SAO(47:47)=' '
	ENCODE (9,1009,CBUFFER_SAO(48:56)) YSAO2
	CBUFFER_SAO(57:57)=' '
	CBUFFER_SAO(58:66)='      0.0' !  INCLINA
	CBUFFER_SAO(67:67)=' '
	NBYTES=ICOUNT
	CALL SI_WRITE(BUFFER_SAO,NBYTES)
C
	RETURN
	END
